/*
Copyright (C) 2018-2019 de4dot@gmail.com

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections.Generic;

namespace Iced.UnitTests.Intel {
	static class CodeUtils {
		// GENERATOR-BEGIN: IgnoredCode
		// ⚠️This was generated by GENERATOR!🦹‍♂️
		static readonly HashSet<string> ignored = new HashSet<string>(0, StringComparer.Ordinal) {
		};
		// GENERATOR-END: IgnoredCode

		public static bool IsIgnored(string name) {
#if NO_VEX
			if (name.StartsWith("VEX_"))
				return true;
#endif
#if NO_EVEX
			if (name.StartsWith("EVEX_"))
				return true;
#endif
#if NO_XOP
			if (name.StartsWith("XOP_"))
				return true;
#endif
#if NO_D3NOW
			if (name.StartsWith("D3NOW_"))
				return true;
#endif

			return ignored.Contains(name);
		}
	}
}
