/*
Copyright (C) 2018-2019 de4dot@gmail.com

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

// ⚠️This file was generated by GENERATOR!🦹‍♂️

#nullable enable

namespace Iced.Intel {
	static class MnemonicUtilsData {
		internal static readonly ushort[] toMnemonic = new ushort[IcedConstants.NumberOfCodeValues] {
			(ushort)Mnemonic.INVALID,// INVALID
			(ushort)Mnemonic.Db,// DeclareByte
			(ushort)Mnemonic.Dw,// DeclareWord
			(ushort)Mnemonic.Dd,// DeclareDword
			(ushort)Mnemonic.Dq,// DeclareQword
			(ushort)Mnemonic.Add,// Add_rm8_r8
			(ushort)Mnemonic.Add,// Add_rm16_r16
			(ushort)Mnemonic.Add,// Add_rm32_r32
			(ushort)Mnemonic.Add,// Add_rm64_r64
			(ushort)Mnemonic.Add,// Add_r8_rm8
			(ushort)Mnemonic.Add,// Add_r16_rm16
			(ushort)Mnemonic.Add,// Add_r32_rm32
			(ushort)Mnemonic.Add,// Add_r64_rm64
			(ushort)Mnemonic.Add,// Add_AL_imm8
			(ushort)Mnemonic.Add,// Add_AX_imm16
			(ushort)Mnemonic.Add,// Add_EAX_imm32
			(ushort)Mnemonic.Add,// Add_RAX_imm32
			(ushort)Mnemonic.Push,// Pushw_ES
			(ushort)Mnemonic.Push,// Pushd_ES
			(ushort)Mnemonic.Pop,// Popw_ES
			(ushort)Mnemonic.Pop,// Popd_ES
			(ushort)Mnemonic.Or,// Or_rm8_r8
			(ushort)Mnemonic.Or,// Or_rm16_r16
			(ushort)Mnemonic.Or,// Or_rm32_r32
			(ushort)Mnemonic.Or,// Or_rm64_r64
			(ushort)Mnemonic.Or,// Or_r8_rm8
			(ushort)Mnemonic.Or,// Or_r16_rm16
			(ushort)Mnemonic.Or,// Or_r32_rm32
			(ushort)Mnemonic.Or,// Or_r64_rm64
			(ushort)Mnemonic.Or,// Or_AL_imm8
			(ushort)Mnemonic.Or,// Or_AX_imm16
			(ushort)Mnemonic.Or,// Or_EAX_imm32
			(ushort)Mnemonic.Or,// Or_RAX_imm32
			(ushort)Mnemonic.Push,// Pushw_CS
			(ushort)Mnemonic.Push,// Pushd_CS
			(ushort)Mnemonic.Pop,// Popw_CS
			(ushort)Mnemonic.Adc,// Adc_rm8_r8
			(ushort)Mnemonic.Adc,// Adc_rm16_r16
			(ushort)Mnemonic.Adc,// Adc_rm32_r32
			(ushort)Mnemonic.Adc,// Adc_rm64_r64
			(ushort)Mnemonic.Adc,// Adc_r8_rm8
			(ushort)Mnemonic.Adc,// Adc_r16_rm16
			(ushort)Mnemonic.Adc,// Adc_r32_rm32
			(ushort)Mnemonic.Adc,// Adc_r64_rm64
			(ushort)Mnemonic.Adc,// Adc_AL_imm8
			(ushort)Mnemonic.Adc,// Adc_AX_imm16
			(ushort)Mnemonic.Adc,// Adc_EAX_imm32
			(ushort)Mnemonic.Adc,// Adc_RAX_imm32
			(ushort)Mnemonic.Push,// Pushw_SS
			(ushort)Mnemonic.Push,// Pushd_SS
			(ushort)Mnemonic.Pop,// Popw_SS
			(ushort)Mnemonic.Pop,// Popd_SS
			(ushort)Mnemonic.Sbb,// Sbb_rm8_r8
			(ushort)Mnemonic.Sbb,// Sbb_rm16_r16
			(ushort)Mnemonic.Sbb,// Sbb_rm32_r32
			(ushort)Mnemonic.Sbb,// Sbb_rm64_r64
			(ushort)Mnemonic.Sbb,// Sbb_r8_rm8
			(ushort)Mnemonic.Sbb,// Sbb_r16_rm16
			(ushort)Mnemonic.Sbb,// Sbb_r32_rm32
			(ushort)Mnemonic.Sbb,// Sbb_r64_rm64
			(ushort)Mnemonic.Sbb,// Sbb_AL_imm8
			(ushort)Mnemonic.Sbb,// Sbb_AX_imm16
			(ushort)Mnemonic.Sbb,// Sbb_EAX_imm32
			(ushort)Mnemonic.Sbb,// Sbb_RAX_imm32
			(ushort)Mnemonic.Push,// Pushw_DS
			(ushort)Mnemonic.Push,// Pushd_DS
			(ushort)Mnemonic.Pop,// Popw_DS
			(ushort)Mnemonic.Pop,// Popd_DS
			(ushort)Mnemonic.And,// And_rm8_r8
			(ushort)Mnemonic.And,// And_rm16_r16
			(ushort)Mnemonic.And,// And_rm32_r32
			(ushort)Mnemonic.And,// And_rm64_r64
			(ushort)Mnemonic.And,// And_r8_rm8
			(ushort)Mnemonic.And,// And_r16_rm16
			(ushort)Mnemonic.And,// And_r32_rm32
			(ushort)Mnemonic.And,// And_r64_rm64
			(ushort)Mnemonic.And,// And_AL_imm8
			(ushort)Mnemonic.And,// And_AX_imm16
			(ushort)Mnemonic.And,// And_EAX_imm32
			(ushort)Mnemonic.And,// And_RAX_imm32
			(ushort)Mnemonic.Daa,// Daa
			(ushort)Mnemonic.Sub,// Sub_rm8_r8
			(ushort)Mnemonic.Sub,// Sub_rm16_r16
			(ushort)Mnemonic.Sub,// Sub_rm32_r32
			(ushort)Mnemonic.Sub,// Sub_rm64_r64
			(ushort)Mnemonic.Sub,// Sub_r8_rm8
			(ushort)Mnemonic.Sub,// Sub_r16_rm16
			(ushort)Mnemonic.Sub,// Sub_r32_rm32
			(ushort)Mnemonic.Sub,// Sub_r64_rm64
			(ushort)Mnemonic.Sub,// Sub_AL_imm8
			(ushort)Mnemonic.Sub,// Sub_AX_imm16
			(ushort)Mnemonic.Sub,// Sub_EAX_imm32
			(ushort)Mnemonic.Sub,// Sub_RAX_imm32
			(ushort)Mnemonic.Das,// Das
			(ushort)Mnemonic.Xor,// Xor_rm8_r8
			(ushort)Mnemonic.Xor,// Xor_rm16_r16
			(ushort)Mnemonic.Xor,// Xor_rm32_r32
			(ushort)Mnemonic.Xor,// Xor_rm64_r64
			(ushort)Mnemonic.Xor,// Xor_r8_rm8
			(ushort)Mnemonic.Xor,// Xor_r16_rm16
			(ushort)Mnemonic.Xor,// Xor_r32_rm32
			(ushort)Mnemonic.Xor,// Xor_r64_rm64
			(ushort)Mnemonic.Xor,// Xor_AL_imm8
			(ushort)Mnemonic.Xor,// Xor_AX_imm16
			(ushort)Mnemonic.Xor,// Xor_EAX_imm32
			(ushort)Mnemonic.Xor,// Xor_RAX_imm32
			(ushort)Mnemonic.Aaa,// Aaa
			(ushort)Mnemonic.Cmp,// Cmp_rm8_r8
			(ushort)Mnemonic.Cmp,// Cmp_rm16_r16
			(ushort)Mnemonic.Cmp,// Cmp_rm32_r32
			(ushort)Mnemonic.Cmp,// Cmp_rm64_r64
			(ushort)Mnemonic.Cmp,// Cmp_r8_rm8
			(ushort)Mnemonic.Cmp,// Cmp_r16_rm16
			(ushort)Mnemonic.Cmp,// Cmp_r32_rm32
			(ushort)Mnemonic.Cmp,// Cmp_r64_rm64
			(ushort)Mnemonic.Cmp,// Cmp_AL_imm8
			(ushort)Mnemonic.Cmp,// Cmp_AX_imm16
			(ushort)Mnemonic.Cmp,// Cmp_EAX_imm32
			(ushort)Mnemonic.Cmp,// Cmp_RAX_imm32
			(ushort)Mnemonic.Aas,// Aas
			(ushort)Mnemonic.Inc,// Inc_r16
			(ushort)Mnemonic.Inc,// Inc_r32
			(ushort)Mnemonic.Dec,// Dec_r16
			(ushort)Mnemonic.Dec,// Dec_r32
			(ushort)Mnemonic.Push,// Push_r16
			(ushort)Mnemonic.Push,// Push_r32
			(ushort)Mnemonic.Push,// Push_r64
			(ushort)Mnemonic.Pop,// Pop_r16
			(ushort)Mnemonic.Pop,// Pop_r32
			(ushort)Mnemonic.Pop,// Pop_r64
			(ushort)Mnemonic.Pusha,// Pushaw
			(ushort)Mnemonic.Pusha,// Pushad
			(ushort)Mnemonic.Popa,// Popaw
			(ushort)Mnemonic.Popa,// Popad
			(ushort)Mnemonic.Bound,// Bound_r16_m1616
			(ushort)Mnemonic.Bound,// Bound_r32_m3232
			(ushort)Mnemonic.Arpl,// Arpl_rm16_r16
			(ushort)Mnemonic.Arpl,// Arpl_r32m16_r32
			(ushort)Mnemonic.Movsxd,// Movsxd_r16_rm16
			(ushort)Mnemonic.Movsxd,// Movsxd_r32_rm32
			(ushort)Mnemonic.Movsxd,// Movsxd_r64_rm32
			(ushort)Mnemonic.Push,// Push_imm16
			(ushort)Mnemonic.Push,// Pushd_imm32
			(ushort)Mnemonic.Push,// Pushq_imm32
			(ushort)Mnemonic.Imul,// Imul_r16_rm16_imm16
			(ushort)Mnemonic.Imul,// Imul_r32_rm32_imm32
			(ushort)Mnemonic.Imul,// Imul_r64_rm64_imm32
			(ushort)Mnemonic.Push,// Pushw_imm8
			(ushort)Mnemonic.Push,// Pushd_imm8
			(ushort)Mnemonic.Push,// Pushq_imm8
			(ushort)Mnemonic.Imul,// Imul_r16_rm16_imm8
			(ushort)Mnemonic.Imul,// Imul_r32_rm32_imm8
			(ushort)Mnemonic.Imul,// Imul_r64_rm64_imm8
			(ushort)Mnemonic.Insb,// Insb_m8_DX
			(ushort)Mnemonic.Insw,// Insw_m16_DX
			(ushort)Mnemonic.Insd,// Insd_m32_DX
			(ushort)Mnemonic.Outsb,// Outsb_DX_m8
			(ushort)Mnemonic.Outsw,// Outsw_DX_m16
			(ushort)Mnemonic.Outsd,// Outsd_DX_m32
			(ushort)Mnemonic.Jo,// Jo_rel8_16
			(ushort)Mnemonic.Jo,// Jo_rel8_32
			(ushort)Mnemonic.Jo,// Jo_rel8_64
			(ushort)Mnemonic.Jno,// Jno_rel8_16
			(ushort)Mnemonic.Jno,// Jno_rel8_32
			(ushort)Mnemonic.Jno,// Jno_rel8_64
			(ushort)Mnemonic.Jb,// Jb_rel8_16
			(ushort)Mnemonic.Jb,// Jb_rel8_32
			(ushort)Mnemonic.Jb,// Jb_rel8_64
			(ushort)Mnemonic.Jae,// Jae_rel8_16
			(ushort)Mnemonic.Jae,// Jae_rel8_32
			(ushort)Mnemonic.Jae,// Jae_rel8_64
			(ushort)Mnemonic.Je,// Je_rel8_16
			(ushort)Mnemonic.Je,// Je_rel8_32
			(ushort)Mnemonic.Je,// Je_rel8_64
			(ushort)Mnemonic.Jne,// Jne_rel8_16
			(ushort)Mnemonic.Jne,// Jne_rel8_32
			(ushort)Mnemonic.Jne,// Jne_rel8_64
			(ushort)Mnemonic.Jbe,// Jbe_rel8_16
			(ushort)Mnemonic.Jbe,// Jbe_rel8_32
			(ushort)Mnemonic.Jbe,// Jbe_rel8_64
			(ushort)Mnemonic.Ja,// Ja_rel8_16
			(ushort)Mnemonic.Ja,// Ja_rel8_32
			(ushort)Mnemonic.Ja,// Ja_rel8_64
			(ushort)Mnemonic.Js,// Js_rel8_16
			(ushort)Mnemonic.Js,// Js_rel8_32
			(ushort)Mnemonic.Js,// Js_rel8_64
			(ushort)Mnemonic.Jns,// Jns_rel8_16
			(ushort)Mnemonic.Jns,// Jns_rel8_32
			(ushort)Mnemonic.Jns,// Jns_rel8_64
			(ushort)Mnemonic.Jp,// Jp_rel8_16
			(ushort)Mnemonic.Jp,// Jp_rel8_32
			(ushort)Mnemonic.Jp,// Jp_rel8_64
			(ushort)Mnemonic.Jnp,// Jnp_rel8_16
			(ushort)Mnemonic.Jnp,// Jnp_rel8_32
			(ushort)Mnemonic.Jnp,// Jnp_rel8_64
			(ushort)Mnemonic.Jl,// Jl_rel8_16
			(ushort)Mnemonic.Jl,// Jl_rel8_32
			(ushort)Mnemonic.Jl,// Jl_rel8_64
			(ushort)Mnemonic.Jge,// Jge_rel8_16
			(ushort)Mnemonic.Jge,// Jge_rel8_32
			(ushort)Mnemonic.Jge,// Jge_rel8_64
			(ushort)Mnemonic.Jle,// Jle_rel8_16
			(ushort)Mnemonic.Jle,// Jle_rel8_32
			(ushort)Mnemonic.Jle,// Jle_rel8_64
			(ushort)Mnemonic.Jg,// Jg_rel8_16
			(ushort)Mnemonic.Jg,// Jg_rel8_32
			(ushort)Mnemonic.Jg,// Jg_rel8_64
			(ushort)Mnemonic.Add,// Add_rm8_imm8
			(ushort)Mnemonic.Or,// Or_rm8_imm8
			(ushort)Mnemonic.Adc,// Adc_rm8_imm8
			(ushort)Mnemonic.Sbb,// Sbb_rm8_imm8
			(ushort)Mnemonic.And,// And_rm8_imm8
			(ushort)Mnemonic.Sub,// Sub_rm8_imm8
			(ushort)Mnemonic.Xor,// Xor_rm8_imm8
			(ushort)Mnemonic.Cmp,// Cmp_rm8_imm8
			(ushort)Mnemonic.Add,// Add_rm16_imm16
			(ushort)Mnemonic.Add,// Add_rm32_imm32
			(ushort)Mnemonic.Add,// Add_rm64_imm32
			(ushort)Mnemonic.Or,// Or_rm16_imm16
			(ushort)Mnemonic.Or,// Or_rm32_imm32
			(ushort)Mnemonic.Or,// Or_rm64_imm32
			(ushort)Mnemonic.Adc,// Adc_rm16_imm16
			(ushort)Mnemonic.Adc,// Adc_rm32_imm32
			(ushort)Mnemonic.Adc,// Adc_rm64_imm32
			(ushort)Mnemonic.Sbb,// Sbb_rm16_imm16
			(ushort)Mnemonic.Sbb,// Sbb_rm32_imm32
			(ushort)Mnemonic.Sbb,// Sbb_rm64_imm32
			(ushort)Mnemonic.And,// And_rm16_imm16
			(ushort)Mnemonic.And,// And_rm32_imm32
			(ushort)Mnemonic.And,// And_rm64_imm32
			(ushort)Mnemonic.Sub,// Sub_rm16_imm16
			(ushort)Mnemonic.Sub,// Sub_rm32_imm32
			(ushort)Mnemonic.Sub,// Sub_rm64_imm32
			(ushort)Mnemonic.Xor,// Xor_rm16_imm16
			(ushort)Mnemonic.Xor,// Xor_rm32_imm32
			(ushort)Mnemonic.Xor,// Xor_rm64_imm32
			(ushort)Mnemonic.Cmp,// Cmp_rm16_imm16
			(ushort)Mnemonic.Cmp,// Cmp_rm32_imm32
			(ushort)Mnemonic.Cmp,// Cmp_rm64_imm32
			(ushort)Mnemonic.Add,// Add_rm8_imm8_82
			(ushort)Mnemonic.Or,// Or_rm8_imm8_82
			(ushort)Mnemonic.Adc,// Adc_rm8_imm8_82
			(ushort)Mnemonic.Sbb,// Sbb_rm8_imm8_82
			(ushort)Mnemonic.And,// And_rm8_imm8_82
			(ushort)Mnemonic.Sub,// Sub_rm8_imm8_82
			(ushort)Mnemonic.Xor,// Xor_rm8_imm8_82
			(ushort)Mnemonic.Cmp,// Cmp_rm8_imm8_82
			(ushort)Mnemonic.Add,// Add_rm16_imm8
			(ushort)Mnemonic.Add,// Add_rm32_imm8
			(ushort)Mnemonic.Add,// Add_rm64_imm8
			(ushort)Mnemonic.Or,// Or_rm16_imm8
			(ushort)Mnemonic.Or,// Or_rm32_imm8
			(ushort)Mnemonic.Or,// Or_rm64_imm8
			(ushort)Mnemonic.Adc,// Adc_rm16_imm8
			(ushort)Mnemonic.Adc,// Adc_rm32_imm8
			(ushort)Mnemonic.Adc,// Adc_rm64_imm8
			(ushort)Mnemonic.Sbb,// Sbb_rm16_imm8
			(ushort)Mnemonic.Sbb,// Sbb_rm32_imm8
			(ushort)Mnemonic.Sbb,// Sbb_rm64_imm8
			(ushort)Mnemonic.And,// And_rm16_imm8
			(ushort)Mnemonic.And,// And_rm32_imm8
			(ushort)Mnemonic.And,// And_rm64_imm8
			(ushort)Mnemonic.Sub,// Sub_rm16_imm8
			(ushort)Mnemonic.Sub,// Sub_rm32_imm8
			(ushort)Mnemonic.Sub,// Sub_rm64_imm8
			(ushort)Mnemonic.Xor,// Xor_rm16_imm8
			(ushort)Mnemonic.Xor,// Xor_rm32_imm8
			(ushort)Mnemonic.Xor,// Xor_rm64_imm8
			(ushort)Mnemonic.Cmp,// Cmp_rm16_imm8
			(ushort)Mnemonic.Cmp,// Cmp_rm32_imm8
			(ushort)Mnemonic.Cmp,// Cmp_rm64_imm8
			(ushort)Mnemonic.Test,// Test_rm8_r8
			(ushort)Mnemonic.Test,// Test_rm16_r16
			(ushort)Mnemonic.Test,// Test_rm32_r32
			(ushort)Mnemonic.Test,// Test_rm64_r64
			(ushort)Mnemonic.Xchg,// Xchg_rm8_r8
			(ushort)Mnemonic.Xchg,// Xchg_rm16_r16
			(ushort)Mnemonic.Xchg,// Xchg_rm32_r32
			(ushort)Mnemonic.Xchg,// Xchg_rm64_r64
			(ushort)Mnemonic.Mov,// Mov_rm8_r8
			(ushort)Mnemonic.Mov,// Mov_rm16_r16
			(ushort)Mnemonic.Mov,// Mov_rm32_r32
			(ushort)Mnemonic.Mov,// Mov_rm64_r64
			(ushort)Mnemonic.Mov,// Mov_r8_rm8
			(ushort)Mnemonic.Mov,// Mov_r16_rm16
			(ushort)Mnemonic.Mov,// Mov_r32_rm32
			(ushort)Mnemonic.Mov,// Mov_r64_rm64
			(ushort)Mnemonic.Mov,// Mov_rm16_Sreg
			(ushort)Mnemonic.Mov,// Mov_r32m16_Sreg
			(ushort)Mnemonic.Mov,// Mov_r64m16_Sreg
			(ushort)Mnemonic.Lea,// Lea_r16_m
			(ushort)Mnemonic.Lea,// Lea_r32_m
			(ushort)Mnemonic.Lea,// Lea_r64_m
			(ushort)Mnemonic.Mov,// Mov_Sreg_rm16
			(ushort)Mnemonic.Mov,// Mov_Sreg_r32m16
			(ushort)Mnemonic.Mov,// Mov_Sreg_r64m16
			(ushort)Mnemonic.Pop,// Pop_rm16
			(ushort)Mnemonic.Pop,// Pop_rm32
			(ushort)Mnemonic.Pop,// Pop_rm64
			(ushort)Mnemonic.Nop,// Nopw
			(ushort)Mnemonic.Nop,// Nopd
			(ushort)Mnemonic.Nop,// Nopq
			(ushort)Mnemonic.Xchg,// Xchg_r16_AX
			(ushort)Mnemonic.Xchg,// Xchg_r32_EAX
			(ushort)Mnemonic.Xchg,// Xchg_r64_RAX
			(ushort)Mnemonic.Pause,// Pause
			(ushort)Mnemonic.Cbw,// Cbw
			(ushort)Mnemonic.Cwde,// Cwde
			(ushort)Mnemonic.Cdqe,// Cdqe
			(ushort)Mnemonic.Cwd,// Cwd
			(ushort)Mnemonic.Cdq,// Cdq
			(ushort)Mnemonic.Cqo,// Cqo
			(ushort)Mnemonic.Call,// Call_ptr1616
			(ushort)Mnemonic.Call,// Call_ptr1632
			(ushort)Mnemonic.Wait,// Wait
			(ushort)Mnemonic.Pushf,// Pushfw
			(ushort)Mnemonic.Pushf,// Pushfd
			(ushort)Mnemonic.Pushf,// Pushfq
			(ushort)Mnemonic.Popf,// Popfw
			(ushort)Mnemonic.Popf,// Popfd
			(ushort)Mnemonic.Popf,// Popfq
			(ushort)Mnemonic.Sahf,// Sahf
			(ushort)Mnemonic.Lahf,// Lahf
			(ushort)Mnemonic.Mov,// Mov_AL_moffs8
			(ushort)Mnemonic.Mov,// Mov_AX_moffs16
			(ushort)Mnemonic.Mov,// Mov_EAX_moffs32
			(ushort)Mnemonic.Mov,// Mov_RAX_moffs64
			(ushort)Mnemonic.Mov,// Mov_moffs8_AL
			(ushort)Mnemonic.Mov,// Mov_moffs16_AX
			(ushort)Mnemonic.Mov,// Mov_moffs32_EAX
			(ushort)Mnemonic.Mov,// Mov_moffs64_RAX
			(ushort)Mnemonic.Movsb,// Movsb_m8_m8
			(ushort)Mnemonic.Movsw,// Movsw_m16_m16
			(ushort)Mnemonic.Movsd,// Movsd_m32_m32
			(ushort)Mnemonic.Movsq,// Movsq_m64_m64
			(ushort)Mnemonic.Cmpsb,// Cmpsb_m8_m8
			(ushort)Mnemonic.Cmpsw,// Cmpsw_m16_m16
			(ushort)Mnemonic.Cmpsd,// Cmpsd_m32_m32
			(ushort)Mnemonic.Cmpsq,// Cmpsq_m64_m64
			(ushort)Mnemonic.Test,// Test_AL_imm8
			(ushort)Mnemonic.Test,// Test_AX_imm16
			(ushort)Mnemonic.Test,// Test_EAX_imm32
			(ushort)Mnemonic.Test,// Test_RAX_imm32
			(ushort)Mnemonic.Stosb,// Stosb_m8_AL
			(ushort)Mnemonic.Stosw,// Stosw_m16_AX
			(ushort)Mnemonic.Stosd,// Stosd_m32_EAX
			(ushort)Mnemonic.Stosq,// Stosq_m64_RAX
			(ushort)Mnemonic.Lodsb,// Lodsb_AL_m8
			(ushort)Mnemonic.Lodsw,// Lodsw_AX_m16
			(ushort)Mnemonic.Lodsd,// Lodsd_EAX_m32
			(ushort)Mnemonic.Lodsq,// Lodsq_RAX_m64
			(ushort)Mnemonic.Scasb,// Scasb_AL_m8
			(ushort)Mnemonic.Scasw,// Scasw_AX_m16
			(ushort)Mnemonic.Scasd,// Scasd_EAX_m32
			(ushort)Mnemonic.Scasq,// Scasq_RAX_m64
			(ushort)Mnemonic.Mov,// Mov_r8_imm8
			(ushort)Mnemonic.Mov,// Mov_r16_imm16
			(ushort)Mnemonic.Mov,// Mov_r32_imm32
			(ushort)Mnemonic.Mov,// Mov_r64_imm64
			(ushort)Mnemonic.Rol,// Rol_rm8_imm8
			(ushort)Mnemonic.Ror,// Ror_rm8_imm8
			(ushort)Mnemonic.Rcl,// Rcl_rm8_imm8
			(ushort)Mnemonic.Rcr,// Rcr_rm8_imm8
			(ushort)Mnemonic.Shl,// Shl_rm8_imm8
			(ushort)Mnemonic.Shr,// Shr_rm8_imm8
			(ushort)Mnemonic.Sal,// Sal_rm8_imm8
			(ushort)Mnemonic.Sar,// Sar_rm8_imm8
			(ushort)Mnemonic.Rol,// Rol_rm16_imm8
			(ushort)Mnemonic.Rol,// Rol_rm32_imm8
			(ushort)Mnemonic.Rol,// Rol_rm64_imm8
			(ushort)Mnemonic.Ror,// Ror_rm16_imm8
			(ushort)Mnemonic.Ror,// Ror_rm32_imm8
			(ushort)Mnemonic.Ror,// Ror_rm64_imm8
			(ushort)Mnemonic.Rcl,// Rcl_rm16_imm8
			(ushort)Mnemonic.Rcl,// Rcl_rm32_imm8
			(ushort)Mnemonic.Rcl,// Rcl_rm64_imm8
			(ushort)Mnemonic.Rcr,// Rcr_rm16_imm8
			(ushort)Mnemonic.Rcr,// Rcr_rm32_imm8
			(ushort)Mnemonic.Rcr,// Rcr_rm64_imm8
			(ushort)Mnemonic.Shl,// Shl_rm16_imm8
			(ushort)Mnemonic.Shl,// Shl_rm32_imm8
			(ushort)Mnemonic.Shl,// Shl_rm64_imm8
			(ushort)Mnemonic.Shr,// Shr_rm16_imm8
			(ushort)Mnemonic.Shr,// Shr_rm32_imm8
			(ushort)Mnemonic.Shr,// Shr_rm64_imm8
			(ushort)Mnemonic.Sal,// Sal_rm16_imm8
			(ushort)Mnemonic.Sal,// Sal_rm32_imm8
			(ushort)Mnemonic.Sal,// Sal_rm64_imm8
			(ushort)Mnemonic.Sar,// Sar_rm16_imm8
			(ushort)Mnemonic.Sar,// Sar_rm32_imm8
			(ushort)Mnemonic.Sar,// Sar_rm64_imm8
			(ushort)Mnemonic.Ret,// Retnw_imm16
			(ushort)Mnemonic.Ret,// Retnd_imm16
			(ushort)Mnemonic.Ret,// Retnq_imm16
			(ushort)Mnemonic.Ret,// Retnw
			(ushort)Mnemonic.Ret,// Retnd
			(ushort)Mnemonic.Ret,// Retnq
			(ushort)Mnemonic.Les,// Les_r16_m1616
			(ushort)Mnemonic.Les,// Les_r32_m1632
			(ushort)Mnemonic.Lds,// Lds_r16_m1616
			(ushort)Mnemonic.Lds,// Lds_r32_m1632
			(ushort)Mnemonic.Mov,// Mov_rm8_imm8
			(ushort)Mnemonic.Xabort,// Xabort_imm8
			(ushort)Mnemonic.Mov,// Mov_rm16_imm16
			(ushort)Mnemonic.Mov,// Mov_rm32_imm32
			(ushort)Mnemonic.Mov,// Mov_rm64_imm32
			(ushort)Mnemonic.Xbegin,// Xbegin_rel16
			(ushort)Mnemonic.Xbegin,// Xbegin_rel32
			(ushort)Mnemonic.Enter,// Enterw_imm16_imm8
			(ushort)Mnemonic.Enter,// Enterd_imm16_imm8
			(ushort)Mnemonic.Enter,// Enterq_imm16_imm8
			(ushort)Mnemonic.Leave,// Leavew
			(ushort)Mnemonic.Leave,// Leaved
			(ushort)Mnemonic.Leave,// Leaveq
			(ushort)Mnemonic.Retf,// Retfw_imm16
			(ushort)Mnemonic.Retf,// Retfd_imm16
			(ushort)Mnemonic.Retf,// Retfq_imm16
			(ushort)Mnemonic.Retf,// Retfw
			(ushort)Mnemonic.Retf,// Retfd
			(ushort)Mnemonic.Retf,// Retfq
			(ushort)Mnemonic.Int,// Int3
			(ushort)Mnemonic.Int,// Int_imm8
			(ushort)Mnemonic.Into,// Into
			(ushort)Mnemonic.Iret,// Iretw
			(ushort)Mnemonic.Iret,// Iretd
			(ushort)Mnemonic.Iret,// Iretq
			(ushort)Mnemonic.Rol,// Rol_rm8_1
			(ushort)Mnemonic.Ror,// Ror_rm8_1
			(ushort)Mnemonic.Rcl,// Rcl_rm8_1
			(ushort)Mnemonic.Rcr,// Rcr_rm8_1
			(ushort)Mnemonic.Shl,// Shl_rm8_1
			(ushort)Mnemonic.Shr,// Shr_rm8_1
			(ushort)Mnemonic.Sal,// Sal_rm8_1
			(ushort)Mnemonic.Sar,// Sar_rm8_1
			(ushort)Mnemonic.Rol,// Rol_rm16_1
			(ushort)Mnemonic.Rol,// Rol_rm32_1
			(ushort)Mnemonic.Rol,// Rol_rm64_1
			(ushort)Mnemonic.Ror,// Ror_rm16_1
			(ushort)Mnemonic.Ror,// Ror_rm32_1
			(ushort)Mnemonic.Ror,// Ror_rm64_1
			(ushort)Mnemonic.Rcl,// Rcl_rm16_1
			(ushort)Mnemonic.Rcl,// Rcl_rm32_1
			(ushort)Mnemonic.Rcl,// Rcl_rm64_1
			(ushort)Mnemonic.Rcr,// Rcr_rm16_1
			(ushort)Mnemonic.Rcr,// Rcr_rm32_1
			(ushort)Mnemonic.Rcr,// Rcr_rm64_1
			(ushort)Mnemonic.Shl,// Shl_rm16_1
			(ushort)Mnemonic.Shl,// Shl_rm32_1
			(ushort)Mnemonic.Shl,// Shl_rm64_1
			(ushort)Mnemonic.Shr,// Shr_rm16_1
			(ushort)Mnemonic.Shr,// Shr_rm32_1
			(ushort)Mnemonic.Shr,// Shr_rm64_1
			(ushort)Mnemonic.Sal,// Sal_rm16_1
			(ushort)Mnemonic.Sal,// Sal_rm32_1
			(ushort)Mnemonic.Sal,// Sal_rm64_1
			(ushort)Mnemonic.Sar,// Sar_rm16_1
			(ushort)Mnemonic.Sar,// Sar_rm32_1
			(ushort)Mnemonic.Sar,// Sar_rm64_1
			(ushort)Mnemonic.Rol,// Rol_rm8_CL
			(ushort)Mnemonic.Ror,// Ror_rm8_CL
			(ushort)Mnemonic.Rcl,// Rcl_rm8_CL
			(ushort)Mnemonic.Rcr,// Rcr_rm8_CL
			(ushort)Mnemonic.Shl,// Shl_rm8_CL
			(ushort)Mnemonic.Shr,// Shr_rm8_CL
			(ushort)Mnemonic.Sal,// Sal_rm8_CL
			(ushort)Mnemonic.Sar,// Sar_rm8_CL
			(ushort)Mnemonic.Rol,// Rol_rm16_CL
			(ushort)Mnemonic.Rol,// Rol_rm32_CL
			(ushort)Mnemonic.Rol,// Rol_rm64_CL
			(ushort)Mnemonic.Ror,// Ror_rm16_CL
			(ushort)Mnemonic.Ror,// Ror_rm32_CL
			(ushort)Mnemonic.Ror,// Ror_rm64_CL
			(ushort)Mnemonic.Rcl,// Rcl_rm16_CL
			(ushort)Mnemonic.Rcl,// Rcl_rm32_CL
			(ushort)Mnemonic.Rcl,// Rcl_rm64_CL
			(ushort)Mnemonic.Rcr,// Rcr_rm16_CL
			(ushort)Mnemonic.Rcr,// Rcr_rm32_CL
			(ushort)Mnemonic.Rcr,// Rcr_rm64_CL
			(ushort)Mnemonic.Shl,// Shl_rm16_CL
			(ushort)Mnemonic.Shl,// Shl_rm32_CL
			(ushort)Mnemonic.Shl,// Shl_rm64_CL
			(ushort)Mnemonic.Shr,// Shr_rm16_CL
			(ushort)Mnemonic.Shr,// Shr_rm32_CL
			(ushort)Mnemonic.Shr,// Shr_rm64_CL
			(ushort)Mnemonic.Sal,// Sal_rm16_CL
			(ushort)Mnemonic.Sal,// Sal_rm32_CL
			(ushort)Mnemonic.Sal,// Sal_rm64_CL
			(ushort)Mnemonic.Sar,// Sar_rm16_CL
			(ushort)Mnemonic.Sar,// Sar_rm32_CL
			(ushort)Mnemonic.Sar,// Sar_rm64_CL
			(ushort)Mnemonic.Aam,// Aam_imm8
			(ushort)Mnemonic.Aad,// Aad_imm8
			(ushort)Mnemonic.Salc,// Salc
			(ushort)Mnemonic.Xlatb,// Xlat_m8
			(ushort)Mnemonic.Fadd,// Fadd_m32fp
			(ushort)Mnemonic.Fmul,// Fmul_m32fp
			(ushort)Mnemonic.Fcom,// Fcom_m32fp
			(ushort)Mnemonic.Fcomp,// Fcomp_m32fp
			(ushort)Mnemonic.Fsub,// Fsub_m32fp
			(ushort)Mnemonic.Fsubr,// Fsubr_m32fp
			(ushort)Mnemonic.Fdiv,// Fdiv_m32fp
			(ushort)Mnemonic.Fdivr,// Fdivr_m32fp
			(ushort)Mnemonic.Fadd,// Fadd_st0_sti
			(ushort)Mnemonic.Fmul,// Fmul_st0_sti
			(ushort)Mnemonic.Fcom,// Fcom_st0_sti
			(ushort)Mnemonic.Fcomp,// Fcomp_st0_sti
			(ushort)Mnemonic.Fsub,// Fsub_st0_sti
			(ushort)Mnemonic.Fsubr,// Fsubr_st0_sti
			(ushort)Mnemonic.Fdiv,// Fdiv_st0_sti
			(ushort)Mnemonic.Fdivr,// Fdivr_st0_sti
			(ushort)Mnemonic.Fld,// Fld_m32fp
			(ushort)Mnemonic.Fst,// Fst_m32fp
			(ushort)Mnemonic.Fstp,// Fstp_m32fp
			(ushort)Mnemonic.Fldenv,// Fldenv_m14byte
			(ushort)Mnemonic.Fldenv,// Fldenv_m28byte
			(ushort)Mnemonic.Fldcw,// Fldcw_m2byte
			(ushort)Mnemonic.Fnstenv,// Fnstenv_m14byte
			(ushort)Mnemonic.Fstenv,// Fstenv_m14byte
			(ushort)Mnemonic.Fnstenv,// Fnstenv_m28byte
			(ushort)Mnemonic.Fstenv,// Fstenv_m28byte
			(ushort)Mnemonic.Fnstcw,// Fnstcw_m2byte
			(ushort)Mnemonic.Fstcw,// Fstcw_m2byte
			(ushort)Mnemonic.Fld,// Fld_st0_sti
			(ushort)Mnemonic.Fxch,// Fxch_st0_sti
			(ushort)Mnemonic.Fnop,// Fnop
			(ushort)Mnemonic.Fstpnce,// Fstpnce_sti
			(ushort)Mnemonic.Fchs,// Fchs
			(ushort)Mnemonic.Fabs,// Fabs
			(ushort)Mnemonic.Ftst,// Ftst
			(ushort)Mnemonic.Fxam,// Fxam
			(ushort)Mnemonic.Fld1,// Fld1
			(ushort)Mnemonic.Fldl2t,// Fldl2t
			(ushort)Mnemonic.Fldl2e,// Fldl2e
			(ushort)Mnemonic.Fldpi,// Fldpi
			(ushort)Mnemonic.Fldlg2,// Fldlg2
			(ushort)Mnemonic.Fldln2,// Fldln2
			(ushort)Mnemonic.Fldz,// Fldz
			(ushort)Mnemonic.F2xm1,// F2xm1
			(ushort)Mnemonic.Fyl2x,// Fyl2x
			(ushort)Mnemonic.Fptan,// Fptan
			(ushort)Mnemonic.Fpatan,// Fpatan
			(ushort)Mnemonic.Fxtract,// Fxtract
			(ushort)Mnemonic.Fprem1,// Fprem1
			(ushort)Mnemonic.Fdecstp,// Fdecstp
			(ushort)Mnemonic.Fincstp,// Fincstp
			(ushort)Mnemonic.Fprem,// Fprem
			(ushort)Mnemonic.Fyl2xp1,// Fyl2xp1
			(ushort)Mnemonic.Fsqrt,// Fsqrt
			(ushort)Mnemonic.Fsincos,// Fsincos
			(ushort)Mnemonic.Frndint,// Frndint
			(ushort)Mnemonic.Fscale,// Fscale
			(ushort)Mnemonic.Fsin,// Fsin
			(ushort)Mnemonic.Fcos,// Fcos
			(ushort)Mnemonic.Fiadd,// Fiadd_m32int
			(ushort)Mnemonic.Fimul,// Fimul_m32int
			(ushort)Mnemonic.Ficom,// Ficom_m32int
			(ushort)Mnemonic.Ficomp,// Ficomp_m32int
			(ushort)Mnemonic.Fisub,// Fisub_m32int
			(ushort)Mnemonic.Fisubr,// Fisubr_m32int
			(ushort)Mnemonic.Fidiv,// Fidiv_m32int
			(ushort)Mnemonic.Fidivr,// Fidivr_m32int
			(ushort)Mnemonic.Fcmovb,// Fcmovb_st0_sti
			(ushort)Mnemonic.Fcmove,// Fcmove_st0_sti
			(ushort)Mnemonic.Fcmovbe,// Fcmovbe_st0_sti
			(ushort)Mnemonic.Fcmovu,// Fcmovu_st0_sti
			(ushort)Mnemonic.Fucompp,// Fucompp
			(ushort)Mnemonic.Fild,// Fild_m32int
			(ushort)Mnemonic.Fisttp,// Fisttp_m32int
			(ushort)Mnemonic.Fist,// Fist_m32int
			(ushort)Mnemonic.Fistp,// Fistp_m32int
			(ushort)Mnemonic.Fld,// Fld_m80fp
			(ushort)Mnemonic.Fstp,// Fstp_m80fp
			(ushort)Mnemonic.Fcmovnb,// Fcmovnb_st0_sti
			(ushort)Mnemonic.Fcmovne,// Fcmovne_st0_sti
			(ushort)Mnemonic.Fcmovnbe,// Fcmovnbe_st0_sti
			(ushort)Mnemonic.Fcmovnu,// Fcmovnu_st0_sti
			(ushort)Mnemonic.Fneni,// Fneni
			(ushort)Mnemonic.Feni,// Feni
			(ushort)Mnemonic.Fndisi,// Fndisi
			(ushort)Mnemonic.Fdisi,// Fdisi
			(ushort)Mnemonic.Fnclex,// Fnclex
			(ushort)Mnemonic.Fclex,// Fclex
			(ushort)Mnemonic.Fninit,// Fninit
			(ushort)Mnemonic.Finit,// Finit
			(ushort)Mnemonic.Fnsetpm,// Fnsetpm
			(ushort)Mnemonic.Fsetpm,// Fsetpm
			(ushort)Mnemonic.Frstpm,// Frstpm
			(ushort)Mnemonic.Fucomi,// Fucomi_st0_sti
			(ushort)Mnemonic.Fcomi,// Fcomi_st0_sti
			(ushort)Mnemonic.Fadd,// Fadd_m64fp
			(ushort)Mnemonic.Fmul,// Fmul_m64fp
			(ushort)Mnemonic.Fcom,// Fcom_m64fp
			(ushort)Mnemonic.Fcomp,// Fcomp_m64fp
			(ushort)Mnemonic.Fsub,// Fsub_m64fp
			(ushort)Mnemonic.Fsubr,// Fsubr_m64fp
			(ushort)Mnemonic.Fdiv,// Fdiv_m64fp
			(ushort)Mnemonic.Fdivr,// Fdivr_m64fp
			(ushort)Mnemonic.Fadd,// Fadd_sti_st0
			(ushort)Mnemonic.Fmul,// Fmul_sti_st0
			(ushort)Mnemonic.Fcom,// Fcom_st0_sti_DCD0
			(ushort)Mnemonic.Fcomp,// Fcomp_st0_sti_DCD8
			(ushort)Mnemonic.Fsubr,// Fsubr_sti_st0
			(ushort)Mnemonic.Fsub,// Fsub_sti_st0
			(ushort)Mnemonic.Fdivr,// Fdivr_sti_st0
			(ushort)Mnemonic.Fdiv,// Fdiv_sti_st0
			(ushort)Mnemonic.Fld,// Fld_m64fp
			(ushort)Mnemonic.Fisttp,// Fisttp_m64int
			(ushort)Mnemonic.Fst,// Fst_m64fp
			(ushort)Mnemonic.Fstp,// Fstp_m64fp
			(ushort)Mnemonic.Frstor,// Frstor_m94byte
			(ushort)Mnemonic.Frstor,// Frstor_m108byte
			(ushort)Mnemonic.Fnsave,// Fnsave_m94byte
			(ushort)Mnemonic.Fsave,// Fsave_m94byte
			(ushort)Mnemonic.Fnsave,// Fnsave_m108byte
			(ushort)Mnemonic.Fsave,// Fsave_m108byte
			(ushort)Mnemonic.Fnstsw,// Fnstsw_m2byte
			(ushort)Mnemonic.Fstsw,// Fstsw_m2byte
			(ushort)Mnemonic.Ffree,// Ffree_sti
			(ushort)Mnemonic.Fxch,// Fxch_st0_sti_DDC8
			(ushort)Mnemonic.Fst,// Fst_sti
			(ushort)Mnemonic.Fstp,// Fstp_sti
			(ushort)Mnemonic.Fucom,// Fucom_st0_sti
			(ushort)Mnemonic.Fucomp,// Fucomp_st0_sti
			(ushort)Mnemonic.Fiadd,// Fiadd_m16int
			(ushort)Mnemonic.Fimul,// Fimul_m16int
			(ushort)Mnemonic.Ficom,// Ficom_m16int
			(ushort)Mnemonic.Ficomp,// Ficomp_m16int
			(ushort)Mnemonic.Fisub,// Fisub_m16int
			(ushort)Mnemonic.Fisubr,// Fisubr_m16int
			(ushort)Mnemonic.Fidiv,// Fidiv_m16int
			(ushort)Mnemonic.Fidivr,// Fidivr_m16int
			(ushort)Mnemonic.Faddp,// Faddp_sti_st0
			(ushort)Mnemonic.Fmulp,// Fmulp_sti_st0
			(ushort)Mnemonic.Fcomp,// Fcomp_st0_sti_DED0
			(ushort)Mnemonic.Fcompp,// Fcompp
			(ushort)Mnemonic.Fsubrp,// Fsubrp_sti_st0
			(ushort)Mnemonic.Fsubp,// Fsubp_sti_st0
			(ushort)Mnemonic.Fdivrp,// Fdivrp_sti_st0
			(ushort)Mnemonic.Fdivp,// Fdivp_sti_st0
			(ushort)Mnemonic.Fild,// Fild_m16int
			(ushort)Mnemonic.Fisttp,// Fisttp_m16int
			(ushort)Mnemonic.Fist,// Fist_m16int
			(ushort)Mnemonic.Fistp,// Fistp_m16int
			(ushort)Mnemonic.Fbld,// Fbld_m80bcd
			(ushort)Mnemonic.Fild,// Fild_m64int
			(ushort)Mnemonic.Fbstp,// Fbstp_m80bcd
			(ushort)Mnemonic.Fistp,// Fistp_m64int
			(ushort)Mnemonic.Ffreep,// Ffreep_sti
			(ushort)Mnemonic.Fxch,// Fxch_st0_sti_DFC8
			(ushort)Mnemonic.Fstp,// Fstp_sti_DFD0
			(ushort)Mnemonic.Fstp,// Fstp_sti_DFD8
			(ushort)Mnemonic.Fnstsw,// Fnstsw_AX
			(ushort)Mnemonic.Fstsw,// Fstsw_AX
			(ushort)Mnemonic.Fstdw,// Fstdw_AX
			(ushort)Mnemonic.Fstsg,// Fstsg_AX
			(ushort)Mnemonic.Fucomip,// Fucomip_st0_sti
			(ushort)Mnemonic.Fcomip,// Fcomip_st0_sti
			(ushort)Mnemonic.Loopne,// Loopne_rel8_16_CX
			(ushort)Mnemonic.Loopne,// Loopne_rel8_32_CX
			(ushort)Mnemonic.Loopne,// Loopne_rel8_16_ECX
			(ushort)Mnemonic.Loopne,// Loopne_rel8_32_ECX
			(ushort)Mnemonic.Loopne,// Loopne_rel8_64_ECX
			(ushort)Mnemonic.Loopne,// Loopne_rel8_16_RCX
			(ushort)Mnemonic.Loopne,// Loopne_rel8_64_RCX
			(ushort)Mnemonic.Loope,// Loope_rel8_16_CX
			(ushort)Mnemonic.Loope,// Loope_rel8_32_CX
			(ushort)Mnemonic.Loope,// Loope_rel8_16_ECX
			(ushort)Mnemonic.Loope,// Loope_rel8_32_ECX
			(ushort)Mnemonic.Loope,// Loope_rel8_64_ECX
			(ushort)Mnemonic.Loope,// Loope_rel8_16_RCX
			(ushort)Mnemonic.Loope,// Loope_rel8_64_RCX
			(ushort)Mnemonic.Loop,// Loop_rel8_16_CX
			(ushort)Mnemonic.Loop,// Loop_rel8_32_CX
			(ushort)Mnemonic.Loop,// Loop_rel8_16_ECX
			(ushort)Mnemonic.Loop,// Loop_rel8_32_ECX
			(ushort)Mnemonic.Loop,// Loop_rel8_64_ECX
			(ushort)Mnemonic.Loop,// Loop_rel8_16_RCX
			(ushort)Mnemonic.Loop,// Loop_rel8_64_RCX
			(ushort)Mnemonic.Jcxz,// Jcxz_rel8_16
			(ushort)Mnemonic.Jcxz,// Jcxz_rel8_32
			(ushort)Mnemonic.Jecxz,// Jecxz_rel8_16
			(ushort)Mnemonic.Jecxz,// Jecxz_rel8_32
			(ushort)Mnemonic.Jecxz,// Jecxz_rel8_64
			(ushort)Mnemonic.Jrcxz,// Jrcxz_rel8_16
			(ushort)Mnemonic.Jrcxz,// Jrcxz_rel8_64
			(ushort)Mnemonic.In,// In_AL_imm8
			(ushort)Mnemonic.In,// In_AX_imm8
			(ushort)Mnemonic.In,// In_EAX_imm8
			(ushort)Mnemonic.Out,// Out_imm8_AL
			(ushort)Mnemonic.Out,// Out_imm8_AX
			(ushort)Mnemonic.Out,// Out_imm8_EAX
			(ushort)Mnemonic.Call,// Call_rel16
			(ushort)Mnemonic.Call,// Call_rel32_32
			(ushort)Mnemonic.Call,// Call_rel32_64
			(ushort)Mnemonic.Jmp,// Jmp_rel16
			(ushort)Mnemonic.Jmp,// Jmp_rel32_32
			(ushort)Mnemonic.Jmp,// Jmp_rel32_64
			(ushort)Mnemonic.Jmp,// Jmp_ptr1616
			(ushort)Mnemonic.Jmp,// Jmp_ptr1632
			(ushort)Mnemonic.Jmp,// Jmp_rel8_16
			(ushort)Mnemonic.Jmp,// Jmp_rel8_32
			(ushort)Mnemonic.Jmp,// Jmp_rel8_64
			(ushort)Mnemonic.In,// In_AL_DX
			(ushort)Mnemonic.In,// In_AX_DX
			(ushort)Mnemonic.In,// In_EAX_DX
			(ushort)Mnemonic.Out,// Out_DX_AL
			(ushort)Mnemonic.Out,// Out_DX_AX
			(ushort)Mnemonic.Out,// Out_DX_EAX
			(ushort)Mnemonic.Int1,// Int1
			(ushort)Mnemonic.Hlt,// Hlt
			(ushort)Mnemonic.Cmc,// Cmc
			(ushort)Mnemonic.Test,// Test_rm8_imm8
			(ushort)Mnemonic.Test,// Test_rm8_imm8_F6r1
			(ushort)Mnemonic.Not,// Not_rm8
			(ushort)Mnemonic.Neg,// Neg_rm8
			(ushort)Mnemonic.Mul,// Mul_rm8
			(ushort)Mnemonic.Imul,// Imul_rm8
			(ushort)Mnemonic.Div,// Div_rm8
			(ushort)Mnemonic.Idiv,// Idiv_rm8
			(ushort)Mnemonic.Test,// Test_rm16_imm16
			(ushort)Mnemonic.Test,// Test_rm32_imm32
			(ushort)Mnemonic.Test,// Test_rm64_imm32
			(ushort)Mnemonic.Test,// Test_rm16_imm16_F7r1
			(ushort)Mnemonic.Test,// Test_rm32_imm32_F7r1
			(ushort)Mnemonic.Test,// Test_rm64_imm32_F7r1
			(ushort)Mnemonic.Not,// Not_rm16
			(ushort)Mnemonic.Not,// Not_rm32
			(ushort)Mnemonic.Not,// Not_rm64
			(ushort)Mnemonic.Neg,// Neg_rm16
			(ushort)Mnemonic.Neg,// Neg_rm32
			(ushort)Mnemonic.Neg,// Neg_rm64
			(ushort)Mnemonic.Mul,// Mul_rm16
			(ushort)Mnemonic.Mul,// Mul_rm32
			(ushort)Mnemonic.Mul,// Mul_rm64
			(ushort)Mnemonic.Imul,// Imul_rm16
			(ushort)Mnemonic.Imul,// Imul_rm32
			(ushort)Mnemonic.Imul,// Imul_rm64
			(ushort)Mnemonic.Div,// Div_rm16
			(ushort)Mnemonic.Div,// Div_rm32
			(ushort)Mnemonic.Div,// Div_rm64
			(ushort)Mnemonic.Idiv,// Idiv_rm16
			(ushort)Mnemonic.Idiv,// Idiv_rm32
			(ushort)Mnemonic.Idiv,// Idiv_rm64
			(ushort)Mnemonic.Clc,// Clc
			(ushort)Mnemonic.Stc,// Stc
			(ushort)Mnemonic.Cli,// Cli
			(ushort)Mnemonic.Sti,// Sti
			(ushort)Mnemonic.Cld,// Cld
			(ushort)Mnemonic.Std,// Std
			(ushort)Mnemonic.Inc,// Inc_rm8
			(ushort)Mnemonic.Dec,// Dec_rm8
			(ushort)Mnemonic.Inc,// Inc_rm16
			(ushort)Mnemonic.Inc,// Inc_rm32
			(ushort)Mnemonic.Inc,// Inc_rm64
			(ushort)Mnemonic.Dec,// Dec_rm16
			(ushort)Mnemonic.Dec,// Dec_rm32
			(ushort)Mnemonic.Dec,// Dec_rm64
			(ushort)Mnemonic.Call,// Call_rm16
			(ushort)Mnemonic.Call,// Call_rm32
			(ushort)Mnemonic.Call,// Call_rm64
			(ushort)Mnemonic.Call,// Call_m1616
			(ushort)Mnemonic.Call,// Call_m1632
			(ushort)Mnemonic.Call,// Call_m1664
			(ushort)Mnemonic.Jmp,// Jmp_rm16
			(ushort)Mnemonic.Jmp,// Jmp_rm32
			(ushort)Mnemonic.Jmp,// Jmp_rm64
			(ushort)Mnemonic.Jmp,// Jmp_m1616
			(ushort)Mnemonic.Jmp,// Jmp_m1632
			(ushort)Mnemonic.Jmp,// Jmp_m1664
			(ushort)Mnemonic.Push,// Push_rm16
			(ushort)Mnemonic.Push,// Push_rm32
			(ushort)Mnemonic.Push,// Push_rm64
			(ushort)Mnemonic.Sldt,// Sldt_rm16
			(ushort)Mnemonic.Sldt,// Sldt_r32m16
			(ushort)Mnemonic.Sldt,// Sldt_r64m16
			(ushort)Mnemonic.Str,// Str_rm16
			(ushort)Mnemonic.Str,// Str_r32m16
			(ushort)Mnemonic.Str,// Str_r64m16
			(ushort)Mnemonic.Lldt,// Lldt_rm16
			(ushort)Mnemonic.Lldt,// Lldt_r32m16
			(ushort)Mnemonic.Lldt,// Lldt_r64m16
			(ushort)Mnemonic.Ltr,// Ltr_rm16
			(ushort)Mnemonic.Ltr,// Ltr_r32m16
			(ushort)Mnemonic.Ltr,// Ltr_r64m16
			(ushort)Mnemonic.Verr,// Verr_rm16
			(ushort)Mnemonic.Verr,// Verr_r32m16
			(ushort)Mnemonic.Verr,// Verr_r64m16
			(ushort)Mnemonic.Verw,// Verw_rm16
			(ushort)Mnemonic.Verw,// Verw_r32m16
			(ushort)Mnemonic.Verw,// Verw_r64m16
			(ushort)Mnemonic.Jmpe,// Jmpe_rm16
			(ushort)Mnemonic.Jmpe,// Jmpe_rm32
			(ushort)Mnemonic.Sgdt,// Sgdt_m1632_16
			(ushort)Mnemonic.Sgdt,// Sgdt_m1632
			(ushort)Mnemonic.Sgdt,// Sgdt_m1664
			(ushort)Mnemonic.Sidt,// Sidt_m1632_16
			(ushort)Mnemonic.Sidt,// Sidt_m1632
			(ushort)Mnemonic.Sidt,// Sidt_m1664
			(ushort)Mnemonic.Lgdt,// Lgdt_m1632_16
			(ushort)Mnemonic.Lgdt,// Lgdt_m1632
			(ushort)Mnemonic.Lgdt,// Lgdt_m1664
			(ushort)Mnemonic.Lidt,// Lidt_m1632_16
			(ushort)Mnemonic.Lidt,// Lidt_m1632
			(ushort)Mnemonic.Lidt,// Lidt_m1664
			(ushort)Mnemonic.Smsw,// Smsw_rm16
			(ushort)Mnemonic.Smsw,// Smsw_r32m16
			(ushort)Mnemonic.Smsw,// Smsw_r64m16
			(ushort)Mnemonic.Rstorssp,// Rstorssp_m64
			(ushort)Mnemonic.Lmsw,// Lmsw_rm16
			(ushort)Mnemonic.Lmsw,// Lmsw_r32m16
			(ushort)Mnemonic.Lmsw,// Lmsw_r64m16
			(ushort)Mnemonic.Invlpg,// Invlpg_m
			(ushort)Mnemonic.Enclv,// Enclv
			(ushort)Mnemonic.Vmcall,// Vmcall
			(ushort)Mnemonic.Vmlaunch,// Vmlaunch
			(ushort)Mnemonic.Vmresume,// Vmresume
			(ushort)Mnemonic.Vmxoff,// Vmxoff
			(ushort)Mnemonic.Pconfig,// Pconfig
			(ushort)Mnemonic.Monitor,// Monitorw
			(ushort)Mnemonic.Monitor,// Monitord
			(ushort)Mnemonic.Monitor,// Monitorq
			(ushort)Mnemonic.Mwait,// Mwait
			(ushort)Mnemonic.Clac,// Clac
			(ushort)Mnemonic.Stac,// Stac
			(ushort)Mnemonic.Encls,// Encls
			(ushort)Mnemonic.Xgetbv,// Xgetbv
			(ushort)Mnemonic.Xsetbv,// Xsetbv
			(ushort)Mnemonic.Vmfunc,// Vmfunc
			(ushort)Mnemonic.Xend,// Xend
			(ushort)Mnemonic.Xtest,// Xtest
			(ushort)Mnemonic.Enclu,// Enclu
			(ushort)Mnemonic.Vmrun,// Vmrunw
			(ushort)Mnemonic.Vmrun,// Vmrund
			(ushort)Mnemonic.Vmrun,// Vmrunq
			(ushort)Mnemonic.Vmmcall,// Vmmcall
			(ushort)Mnemonic.Vmload,// Vmloadw
			(ushort)Mnemonic.Vmload,// Vmloadd
			(ushort)Mnemonic.Vmload,// Vmloadq
			(ushort)Mnemonic.Vmsave,// Vmsavew
			(ushort)Mnemonic.Vmsave,// Vmsaved
			(ushort)Mnemonic.Vmsave,// Vmsaveq
			(ushort)Mnemonic.Stgi,// Stgi
			(ushort)Mnemonic.Clgi,// Clgi
			(ushort)Mnemonic.Skinit,// Skinit
			(ushort)Mnemonic.Invlpga,// Invlpgaw
			(ushort)Mnemonic.Invlpga,// Invlpgad
			(ushort)Mnemonic.Invlpga,// Invlpgaq
			(ushort)Mnemonic.Setssbsy,// Setssbsy
			(ushort)Mnemonic.Saveprevssp,// Saveprevssp
			(ushort)Mnemonic.Rdpkru,// Rdpkru
			(ushort)Mnemonic.Wrpkru,// Wrpkru
			(ushort)Mnemonic.Swapgs,// Swapgs
			(ushort)Mnemonic.Rdtscp,// Rdtscp
			(ushort)Mnemonic.Monitorx,// Monitorxw
			(ushort)Mnemonic.Monitorx,// Monitorxd
			(ushort)Mnemonic.Monitorx,// Monitorxq
			(ushort)Mnemonic.Mcommit,// Mcommit
			(ushort)Mnemonic.Mwaitx,// Mwaitx
			(ushort)Mnemonic.Clzero,// Clzerow
			(ushort)Mnemonic.Clzero,// Clzerod
			(ushort)Mnemonic.Clzero,// Clzeroq
			(ushort)Mnemonic.Rdpru,// Rdpru
			(ushort)Mnemonic.Lar,// Lar_r16_rm16
			(ushort)Mnemonic.Lar,// Lar_r32_r32m16
			(ushort)Mnemonic.Lar,// Lar_r64_r64m16
			(ushort)Mnemonic.Lsl,// Lsl_r16_rm16
			(ushort)Mnemonic.Lsl,// Lsl_r32_r32m16
			(ushort)Mnemonic.Lsl,// Lsl_r64_r64m16
			(ushort)Mnemonic.Loadall,// Loadallreset286
			(ushort)Mnemonic.Loadall,// Loadall286
			(ushort)Mnemonic.Syscall,// Syscall
			(ushort)Mnemonic.Clts,// Clts
			(ushort)Mnemonic.Loadall,// Loadall386
			(ushort)Mnemonic.Sysret,// Sysretd
			(ushort)Mnemonic.Sysret,// Sysretq
			(ushort)Mnemonic.Invd,// Invd
			(ushort)Mnemonic.Wbinvd,// Wbinvd
			(ushort)Mnemonic.Wbnoinvd,// Wbnoinvd
			(ushort)Mnemonic.Cl1invmb,// Cl1invmb
			(ushort)Mnemonic.Ud2,// Ud2
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F0D
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F0D
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F0D
			(ushort)Mnemonic.Prefetch,// Prefetch_m8
			(ushort)Mnemonic.Prefetchw,// Prefetchw_m8
			(ushort)Mnemonic.Prefetchwt1,// Prefetchwt1_m8
			(ushort)Mnemonic.Femms,// Femms
			(ushort)Mnemonic.Umov,// Umov_rm8_r8
			(ushort)Mnemonic.Umov,// Umov_rm16_r16
			(ushort)Mnemonic.Umov,// Umov_rm32_r32
			(ushort)Mnemonic.Umov,// Umov_r8_rm8
			(ushort)Mnemonic.Umov,// Umov_r16_rm16
			(ushort)Mnemonic.Umov,// Umov_r32_rm32
			(ushort)Mnemonic.Movups,// Movups_xmm_xmmm128
			(ushort)Mnemonic.Vmovups,// VEX_Vmovups_xmm_xmmm128
			(ushort)Mnemonic.Vmovups,// VEX_Vmovups_ymm_ymmm256
			(ushort)Mnemonic.Vmovups,// EVEX_Vmovups_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovups,// EVEX_Vmovups_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovups,// EVEX_Vmovups_zmm_k1z_zmmm512
			(ushort)Mnemonic.Movupd,// Movupd_xmm_xmmm128
			(ushort)Mnemonic.Vmovupd,// VEX_Vmovupd_xmm_xmmm128
			(ushort)Mnemonic.Vmovupd,// VEX_Vmovupd_ymm_ymmm256
			(ushort)Mnemonic.Vmovupd,// EVEX_Vmovupd_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovupd,// EVEX_Vmovupd_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovupd,// EVEX_Vmovupd_zmm_k1z_zmmm512
			(ushort)Mnemonic.Movss,// Movss_xmm_xmmm32
			(ushort)Mnemonic.Vmovss,// VEX_Vmovss_xmm_xmm_xmm
			(ushort)Mnemonic.Vmovss,// VEX_Vmovss_xmm_m32
			(ushort)Mnemonic.Vmovss,// EVEX_Vmovss_xmm_k1z_xmm_xmm
			(ushort)Mnemonic.Vmovss,// EVEX_Vmovss_xmm_k1z_m32
			(ushort)Mnemonic.Movsd,// Movsd_xmm_xmmm64
			(ushort)Mnemonic.Vmovsd,// VEX_Vmovsd_xmm_xmm_xmm
			(ushort)Mnemonic.Vmovsd,// VEX_Vmovsd_xmm_m64
			(ushort)Mnemonic.Vmovsd,// EVEX_Vmovsd_xmm_k1z_xmm_xmm
			(ushort)Mnemonic.Vmovsd,// EVEX_Vmovsd_xmm_k1z_m64
			(ushort)Mnemonic.Movups,// Movups_xmmm128_xmm
			(ushort)Mnemonic.Vmovups,// VEX_Vmovups_xmmm128_xmm
			(ushort)Mnemonic.Vmovups,// VEX_Vmovups_ymmm256_ymm
			(ushort)Mnemonic.Vmovups,// EVEX_Vmovups_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovups,// EVEX_Vmovups_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovups,// EVEX_Vmovups_zmmm512_k1z_zmm
			(ushort)Mnemonic.Movupd,// Movupd_xmmm128_xmm
			(ushort)Mnemonic.Vmovupd,// VEX_Vmovupd_xmmm128_xmm
			(ushort)Mnemonic.Vmovupd,// VEX_Vmovupd_ymmm256_ymm
			(ushort)Mnemonic.Vmovupd,// EVEX_Vmovupd_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovupd,// EVEX_Vmovupd_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovupd,// EVEX_Vmovupd_zmmm512_k1z_zmm
			(ushort)Mnemonic.Movss,// Movss_xmmm32_xmm
			(ushort)Mnemonic.Vmovss,// VEX_Vmovss_xmm_xmm_xmm_0F11
			(ushort)Mnemonic.Vmovss,// VEX_Vmovss_m32_xmm
			(ushort)Mnemonic.Vmovss,// EVEX_Vmovss_xmm_k1z_xmm_xmm_0F11
			(ushort)Mnemonic.Vmovss,// EVEX_Vmovss_m32_k1_xmm
			(ushort)Mnemonic.Movsd,// Movsd_xmmm64_xmm
			(ushort)Mnemonic.Vmovsd,// VEX_Vmovsd_xmm_xmm_xmm_0F11
			(ushort)Mnemonic.Vmovsd,// VEX_Vmovsd_m64_xmm
			(ushort)Mnemonic.Vmovsd,// EVEX_Vmovsd_xmm_k1z_xmm_xmm_0F11
			(ushort)Mnemonic.Vmovsd,// EVEX_Vmovsd_m64_k1_xmm
			(ushort)Mnemonic.Movhlps,// Movhlps_xmm_xmm
			(ushort)Mnemonic.Movlps,// Movlps_xmm_m64
			(ushort)Mnemonic.Vmovhlps,// VEX_Vmovhlps_xmm_xmm_xmm
			(ushort)Mnemonic.Vmovlps,// VEX_Vmovlps_xmm_xmm_m64
			(ushort)Mnemonic.Vmovhlps,// EVEX_Vmovhlps_xmm_xmm_xmm
			(ushort)Mnemonic.Vmovlps,// EVEX_Vmovlps_xmm_xmm_m64
			(ushort)Mnemonic.Movlpd,// Movlpd_xmm_m64
			(ushort)Mnemonic.Vmovlpd,// VEX_Vmovlpd_xmm_xmm_m64
			(ushort)Mnemonic.Vmovlpd,// EVEX_Vmovlpd_xmm_xmm_m64
			(ushort)Mnemonic.Movsldup,// Movsldup_xmm_xmmm128
			(ushort)Mnemonic.Vmovsldup,// VEX_Vmovsldup_xmm_xmmm128
			(ushort)Mnemonic.Vmovsldup,// VEX_Vmovsldup_ymm_ymmm256
			(ushort)Mnemonic.Vmovsldup,// EVEX_Vmovsldup_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovsldup,// EVEX_Vmovsldup_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovsldup,// EVEX_Vmovsldup_zmm_k1z_zmmm512
			(ushort)Mnemonic.Movddup,// Movddup_xmm_xmmm64
			(ushort)Mnemonic.Vmovddup,// VEX_Vmovddup_xmm_xmmm64
			(ushort)Mnemonic.Vmovddup,// VEX_Vmovddup_ymm_ymmm256
			(ushort)Mnemonic.Vmovddup,// EVEX_Vmovddup_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vmovddup,// EVEX_Vmovddup_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovddup,// EVEX_Vmovddup_zmm_k1z_zmmm512
			(ushort)Mnemonic.Movlps,// Movlps_m64_xmm
			(ushort)Mnemonic.Vmovlps,// VEX_Vmovlps_m64_xmm
			(ushort)Mnemonic.Vmovlps,// EVEX_Vmovlps_m64_xmm
			(ushort)Mnemonic.Movlpd,// Movlpd_m64_xmm
			(ushort)Mnemonic.Vmovlpd,// VEX_Vmovlpd_m64_xmm
			(ushort)Mnemonic.Vmovlpd,// EVEX_Vmovlpd_m64_xmm
			(ushort)Mnemonic.Unpcklps,// Unpcklps_xmm_xmmm128
			(ushort)Mnemonic.Vunpcklps,// VEX_Vunpcklps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vunpcklps,// VEX_Vunpcklps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vunpcklps,// EVEX_Vunpcklps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vunpcklps,// EVEX_Vunpcklps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vunpcklps,// EVEX_Vunpcklps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Unpcklpd,// Unpcklpd_xmm_xmmm128
			(ushort)Mnemonic.Vunpcklpd,// VEX_Vunpcklpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vunpcklpd,// VEX_Vunpcklpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vunpcklpd,// EVEX_Vunpcklpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vunpcklpd,// EVEX_Vunpcklpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vunpcklpd,// EVEX_Vunpcklpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Unpckhps,// Unpckhps_xmm_xmmm128
			(ushort)Mnemonic.Vunpckhps,// VEX_Vunpckhps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vunpckhps,// VEX_Vunpckhps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vunpckhps,// EVEX_Vunpckhps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vunpckhps,// EVEX_Vunpckhps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vunpckhps,// EVEX_Vunpckhps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Unpckhpd,// Unpckhpd_xmm_xmmm128
			(ushort)Mnemonic.Vunpckhpd,// VEX_Vunpckhpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vunpckhpd,// VEX_Vunpckhpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vunpckhpd,// EVEX_Vunpckhpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vunpckhpd,// EVEX_Vunpckhpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vunpckhpd,// EVEX_Vunpckhpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Movlhps,// Movlhps_xmm_xmm
			(ushort)Mnemonic.Vmovlhps,// VEX_Vmovlhps_xmm_xmm_xmm
			(ushort)Mnemonic.Vmovlhps,// EVEX_Vmovlhps_xmm_xmm_xmm
			(ushort)Mnemonic.Movhps,// Movhps_xmm_m64
			(ushort)Mnemonic.Vmovhps,// VEX_Vmovhps_xmm_xmm_m64
			(ushort)Mnemonic.Vmovhps,// EVEX_Vmovhps_xmm_xmm_m64
			(ushort)Mnemonic.Movhpd,// Movhpd_xmm_m64
			(ushort)Mnemonic.Vmovhpd,// VEX_Vmovhpd_xmm_xmm_m64
			(ushort)Mnemonic.Vmovhpd,// EVEX_Vmovhpd_xmm_xmm_m64
			(ushort)Mnemonic.Movshdup,// Movshdup_xmm_xmmm128
			(ushort)Mnemonic.Vmovshdup,// VEX_Vmovshdup_xmm_xmmm128
			(ushort)Mnemonic.Vmovshdup,// VEX_Vmovshdup_ymm_ymmm256
			(ushort)Mnemonic.Vmovshdup,// EVEX_Vmovshdup_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovshdup,// EVEX_Vmovshdup_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovshdup,// EVEX_Vmovshdup_zmm_k1z_zmmm512
			(ushort)Mnemonic.Movhps,// Movhps_m64_xmm
			(ushort)Mnemonic.Vmovhps,// VEX_Vmovhps_m64_xmm
			(ushort)Mnemonic.Vmovhps,// EVEX_Vmovhps_m64_xmm
			(ushort)Mnemonic.Movhpd,// Movhpd_m64_xmm
			(ushort)Mnemonic.Vmovhpd,// VEX_Vmovhpd_m64_xmm
			(ushort)Mnemonic.Vmovhpd,// EVEX_Vmovhpd_m64_xmm
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F18
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F18
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F18
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F19
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F19
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F19
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F1A
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F1A
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F1A
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F1B
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F1B
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F1B
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F1C
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F1C
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F1C
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F1D
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F1D
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F1D
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F1E
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F1E
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F1E
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm16_r16_0F1F
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm32_r32_0F1F
			(ushort)Mnemonic.ReservedNop,// ReservedNop_rm64_r64_0F1F
			(ushort)Mnemonic.Prefetchnta,// Prefetchnta_m8
			(ushort)Mnemonic.Prefetcht0,// Prefetcht0_m8
			(ushort)Mnemonic.Prefetcht1,// Prefetcht1_m8
			(ushort)Mnemonic.Prefetcht2,// Prefetcht2_m8
			(ushort)Mnemonic.Bndldx,// Bndldx_bnd_mib
			(ushort)Mnemonic.Bndmov,// Bndmov_bnd_bndm64
			(ushort)Mnemonic.Bndmov,// Bndmov_bnd_bndm128
			(ushort)Mnemonic.Bndcl,// Bndcl_bnd_rm32
			(ushort)Mnemonic.Bndcl,// Bndcl_bnd_rm64
			(ushort)Mnemonic.Bndcu,// Bndcu_bnd_rm32
			(ushort)Mnemonic.Bndcu,// Bndcu_bnd_rm64
			(ushort)Mnemonic.Bndstx,// Bndstx_mib_bnd
			(ushort)Mnemonic.Bndmov,// Bndmov_bndm64_bnd
			(ushort)Mnemonic.Bndmov,// Bndmov_bndm128_bnd
			(ushort)Mnemonic.Bndmk,// Bndmk_bnd_m32
			(ushort)Mnemonic.Bndmk,// Bndmk_bnd_m64
			(ushort)Mnemonic.Bndcn,// Bndcn_bnd_rm32
			(ushort)Mnemonic.Bndcn,// Bndcn_bnd_rm64
			(ushort)Mnemonic.Cldemote,// Cldemote_m8
			(ushort)Mnemonic.Rdsspd,// Rdsspd_r32
			(ushort)Mnemonic.Rdsspq,// Rdsspq_r64
			(ushort)Mnemonic.Endbr64,// Endbr64
			(ushort)Mnemonic.Endbr32,// Endbr32
			(ushort)Mnemonic.Nop,// Nop_rm16
			(ushort)Mnemonic.Nop,// Nop_rm32
			(ushort)Mnemonic.Nop,// Nop_rm64
			(ushort)Mnemonic.Mov,// Mov_r32_cr
			(ushort)Mnemonic.Mov,// Mov_r64_cr
			(ushort)Mnemonic.Mov,// Mov_r32_dr
			(ushort)Mnemonic.Mov,// Mov_r64_dr
			(ushort)Mnemonic.Mov,// Mov_cr_r32
			(ushort)Mnemonic.Mov,// Mov_cr_r64
			(ushort)Mnemonic.Mov,// Mov_dr_r32
			(ushort)Mnemonic.Mov,// Mov_dr_r64
			(ushort)Mnemonic.Mov,// Mov_r32_tr
			(ushort)Mnemonic.Mov,// Mov_tr_r32
			(ushort)Mnemonic.Movaps,// Movaps_xmm_xmmm128
			(ushort)Mnemonic.Vmovaps,// VEX_Vmovaps_xmm_xmmm128
			(ushort)Mnemonic.Vmovaps,// VEX_Vmovaps_ymm_ymmm256
			(ushort)Mnemonic.Vmovaps,// EVEX_Vmovaps_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovaps,// EVEX_Vmovaps_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovaps,// EVEX_Vmovaps_zmm_k1z_zmmm512
			(ushort)Mnemonic.Movapd,// Movapd_xmm_xmmm128
			(ushort)Mnemonic.Vmovapd,// VEX_Vmovapd_xmm_xmmm128
			(ushort)Mnemonic.Vmovapd,// VEX_Vmovapd_ymm_ymmm256
			(ushort)Mnemonic.Vmovapd,// EVEX_Vmovapd_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovapd,// EVEX_Vmovapd_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovapd,// EVEX_Vmovapd_zmm_k1z_zmmm512
			(ushort)Mnemonic.Movaps,// Movaps_xmmm128_xmm
			(ushort)Mnemonic.Vmovaps,// VEX_Vmovaps_xmmm128_xmm
			(ushort)Mnemonic.Vmovaps,// VEX_Vmovaps_ymmm256_ymm
			(ushort)Mnemonic.Vmovaps,// EVEX_Vmovaps_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovaps,// EVEX_Vmovaps_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovaps,// EVEX_Vmovaps_zmmm512_k1z_zmm
			(ushort)Mnemonic.Movapd,// Movapd_xmmm128_xmm
			(ushort)Mnemonic.Vmovapd,// VEX_Vmovapd_xmmm128_xmm
			(ushort)Mnemonic.Vmovapd,// VEX_Vmovapd_ymmm256_ymm
			(ushort)Mnemonic.Vmovapd,// EVEX_Vmovapd_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovapd,// EVEX_Vmovapd_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovapd,// EVEX_Vmovapd_zmmm512_k1z_zmm
			(ushort)Mnemonic.Cvtpi2ps,// Cvtpi2ps_xmm_mmm64
			(ushort)Mnemonic.Cvtpi2pd,// Cvtpi2pd_xmm_mmm64
			(ushort)Mnemonic.Cvtsi2ss,// Cvtsi2ss_xmm_rm32
			(ushort)Mnemonic.Cvtsi2ss,// Cvtsi2ss_xmm_rm64
			(ushort)Mnemonic.Vcvtsi2ss,// VEX_Vcvtsi2ss_xmm_xmm_rm32
			(ushort)Mnemonic.Vcvtsi2ss,// VEX_Vcvtsi2ss_xmm_xmm_rm64
			(ushort)Mnemonic.Vcvtsi2ss,// EVEX_Vcvtsi2ss_xmm_xmm_rm32_er
			(ushort)Mnemonic.Vcvtsi2ss,// EVEX_Vcvtsi2ss_xmm_xmm_rm64_er
			(ushort)Mnemonic.Cvtsi2sd,// Cvtsi2sd_xmm_rm32
			(ushort)Mnemonic.Cvtsi2sd,// Cvtsi2sd_xmm_rm64
			(ushort)Mnemonic.Vcvtsi2sd,// VEX_Vcvtsi2sd_xmm_xmm_rm32
			(ushort)Mnemonic.Vcvtsi2sd,// VEX_Vcvtsi2sd_xmm_xmm_rm64
			(ushort)Mnemonic.Vcvtsi2sd,// EVEX_Vcvtsi2sd_xmm_xmm_rm32_er
			(ushort)Mnemonic.Vcvtsi2sd,// EVEX_Vcvtsi2sd_xmm_xmm_rm64_er
			(ushort)Mnemonic.Movntps,// Movntps_m128_xmm
			(ushort)Mnemonic.Vmovntps,// VEX_Vmovntps_m128_xmm
			(ushort)Mnemonic.Vmovntps,// VEX_Vmovntps_m256_ymm
			(ushort)Mnemonic.Vmovntps,// EVEX_Vmovntps_m128_xmm
			(ushort)Mnemonic.Vmovntps,// EVEX_Vmovntps_m256_ymm
			(ushort)Mnemonic.Vmovntps,// EVEX_Vmovntps_m512_zmm
			(ushort)Mnemonic.Movntpd,// Movntpd_m128_xmm
			(ushort)Mnemonic.Vmovntpd,// VEX_Vmovntpd_m128_xmm
			(ushort)Mnemonic.Vmovntpd,// VEX_Vmovntpd_m256_ymm
			(ushort)Mnemonic.Vmovntpd,// EVEX_Vmovntpd_m128_xmm
			(ushort)Mnemonic.Vmovntpd,// EVEX_Vmovntpd_m256_ymm
			(ushort)Mnemonic.Vmovntpd,// EVEX_Vmovntpd_m512_zmm
			(ushort)Mnemonic.Movntss,// Movntss_m32_xmm
			(ushort)Mnemonic.Movntsd,// Movntsd_m64_xmm
			(ushort)Mnemonic.Cvttps2pi,// Cvttps2pi_mm_xmmm64
			(ushort)Mnemonic.Cvttpd2pi,// Cvttpd2pi_mm_xmmm128
			(ushort)Mnemonic.Cvttss2si,// Cvttss2si_r32_xmmm32
			(ushort)Mnemonic.Cvttss2si,// Cvttss2si_r64_xmmm32
			(ushort)Mnemonic.Vcvttss2si,// VEX_Vcvttss2si_r32_xmmm32
			(ushort)Mnemonic.Vcvttss2si,// VEX_Vcvttss2si_r64_xmmm32
			(ushort)Mnemonic.Vcvttss2si,// EVEX_Vcvttss2si_r32_xmmm32_sae
			(ushort)Mnemonic.Vcvttss2si,// EVEX_Vcvttss2si_r64_xmmm32_sae
			(ushort)Mnemonic.Cvttsd2si,// Cvttsd2si_r32_xmmm64
			(ushort)Mnemonic.Cvttsd2si,// Cvttsd2si_r64_xmmm64
			(ushort)Mnemonic.Vcvttsd2si,// VEX_Vcvttsd2si_r32_xmmm64
			(ushort)Mnemonic.Vcvttsd2si,// VEX_Vcvttsd2si_r64_xmmm64
			(ushort)Mnemonic.Vcvttsd2si,// EVEX_Vcvttsd2si_r32_xmmm64_sae
			(ushort)Mnemonic.Vcvttsd2si,// EVEX_Vcvttsd2si_r64_xmmm64_sae
			(ushort)Mnemonic.Cvtps2pi,// Cvtps2pi_mm_xmmm64
			(ushort)Mnemonic.Cvtpd2pi,// Cvtpd2pi_mm_xmmm128
			(ushort)Mnemonic.Cvtss2si,// Cvtss2si_r32_xmmm32
			(ushort)Mnemonic.Cvtss2si,// Cvtss2si_r64_xmmm32
			(ushort)Mnemonic.Vcvtss2si,// VEX_Vcvtss2si_r32_xmmm32
			(ushort)Mnemonic.Vcvtss2si,// VEX_Vcvtss2si_r64_xmmm32
			(ushort)Mnemonic.Vcvtss2si,// EVEX_Vcvtss2si_r32_xmmm32_er
			(ushort)Mnemonic.Vcvtss2si,// EVEX_Vcvtss2si_r64_xmmm32_er
			(ushort)Mnemonic.Cvtsd2si,// Cvtsd2si_r32_xmmm64
			(ushort)Mnemonic.Cvtsd2si,// Cvtsd2si_r64_xmmm64
			(ushort)Mnemonic.Vcvtsd2si,// VEX_Vcvtsd2si_r32_xmmm64
			(ushort)Mnemonic.Vcvtsd2si,// VEX_Vcvtsd2si_r64_xmmm64
			(ushort)Mnemonic.Vcvtsd2si,// EVEX_Vcvtsd2si_r32_xmmm64_er
			(ushort)Mnemonic.Vcvtsd2si,// EVEX_Vcvtsd2si_r64_xmmm64_er
			(ushort)Mnemonic.Ucomiss,// Ucomiss_xmm_xmmm32
			(ushort)Mnemonic.Vucomiss,// VEX_Vucomiss_xmm_xmmm32
			(ushort)Mnemonic.Vucomiss,// EVEX_Vucomiss_xmm_xmmm32_sae
			(ushort)Mnemonic.Ucomisd,// Ucomisd_xmm_xmmm64
			(ushort)Mnemonic.Vucomisd,// VEX_Vucomisd_xmm_xmmm64
			(ushort)Mnemonic.Vucomisd,// EVEX_Vucomisd_xmm_xmmm64_sae
			(ushort)Mnemonic.Comiss,// Comiss_xmm_xmmm32
			(ushort)Mnemonic.Comisd,// Comisd_xmm_xmmm64
			(ushort)Mnemonic.Vcomiss,// VEX_Vcomiss_xmm_xmmm32
			(ushort)Mnemonic.Vcomisd,// VEX_Vcomisd_xmm_xmmm64
			(ushort)Mnemonic.Vcomiss,// EVEX_Vcomiss_xmm_xmmm32_sae
			(ushort)Mnemonic.Vcomisd,// EVEX_Vcomisd_xmm_xmmm64_sae
			(ushort)Mnemonic.Wrmsr,// Wrmsr
			(ushort)Mnemonic.Rdtsc,// Rdtsc
			(ushort)Mnemonic.Rdmsr,// Rdmsr
			(ushort)Mnemonic.Rdpmc,// Rdpmc
			(ushort)Mnemonic.Sysenter,// Sysenter
			(ushort)Mnemonic.Sysexit,// Sysexitd
			(ushort)Mnemonic.Sysexit,// Sysexitq
			(ushort)Mnemonic.Getsec,// Getsec
			(ushort)Mnemonic.Cmovo,// Cmovo_r16_rm16
			(ushort)Mnemonic.Cmovo,// Cmovo_r32_rm32
			(ushort)Mnemonic.Cmovo,// Cmovo_r64_rm64
			(ushort)Mnemonic.Cmovno,// Cmovno_r16_rm16
			(ushort)Mnemonic.Cmovno,// Cmovno_r32_rm32
			(ushort)Mnemonic.Cmovno,// Cmovno_r64_rm64
			(ushort)Mnemonic.Cmovb,// Cmovb_r16_rm16
			(ushort)Mnemonic.Cmovb,// Cmovb_r32_rm32
			(ushort)Mnemonic.Cmovb,// Cmovb_r64_rm64
			(ushort)Mnemonic.Cmovae,// Cmovae_r16_rm16
			(ushort)Mnemonic.Cmovae,// Cmovae_r32_rm32
			(ushort)Mnemonic.Cmovae,// Cmovae_r64_rm64
			(ushort)Mnemonic.Cmove,// Cmove_r16_rm16
			(ushort)Mnemonic.Cmove,// Cmove_r32_rm32
			(ushort)Mnemonic.Cmove,// Cmove_r64_rm64
			(ushort)Mnemonic.Cmovne,// Cmovne_r16_rm16
			(ushort)Mnemonic.Cmovne,// Cmovne_r32_rm32
			(ushort)Mnemonic.Cmovne,// Cmovne_r64_rm64
			(ushort)Mnemonic.Cmovbe,// Cmovbe_r16_rm16
			(ushort)Mnemonic.Cmovbe,// Cmovbe_r32_rm32
			(ushort)Mnemonic.Cmovbe,// Cmovbe_r64_rm64
			(ushort)Mnemonic.Cmova,// Cmova_r16_rm16
			(ushort)Mnemonic.Cmova,// Cmova_r32_rm32
			(ushort)Mnemonic.Cmova,// Cmova_r64_rm64
			(ushort)Mnemonic.Cmovs,// Cmovs_r16_rm16
			(ushort)Mnemonic.Cmovs,// Cmovs_r32_rm32
			(ushort)Mnemonic.Cmovs,// Cmovs_r64_rm64
			(ushort)Mnemonic.Cmovns,// Cmovns_r16_rm16
			(ushort)Mnemonic.Cmovns,// Cmovns_r32_rm32
			(ushort)Mnemonic.Cmovns,// Cmovns_r64_rm64
			(ushort)Mnemonic.Cmovp,// Cmovp_r16_rm16
			(ushort)Mnemonic.Cmovp,// Cmovp_r32_rm32
			(ushort)Mnemonic.Cmovp,// Cmovp_r64_rm64
			(ushort)Mnemonic.Cmovnp,// Cmovnp_r16_rm16
			(ushort)Mnemonic.Cmovnp,// Cmovnp_r32_rm32
			(ushort)Mnemonic.Cmovnp,// Cmovnp_r64_rm64
			(ushort)Mnemonic.Cmovl,// Cmovl_r16_rm16
			(ushort)Mnemonic.Cmovl,// Cmovl_r32_rm32
			(ushort)Mnemonic.Cmovl,// Cmovl_r64_rm64
			(ushort)Mnemonic.Cmovge,// Cmovge_r16_rm16
			(ushort)Mnemonic.Cmovge,// Cmovge_r32_rm32
			(ushort)Mnemonic.Cmovge,// Cmovge_r64_rm64
			(ushort)Mnemonic.Cmovle,// Cmovle_r16_rm16
			(ushort)Mnemonic.Cmovle,// Cmovle_r32_rm32
			(ushort)Mnemonic.Cmovle,// Cmovle_r64_rm64
			(ushort)Mnemonic.Cmovg,// Cmovg_r16_rm16
			(ushort)Mnemonic.Cmovg,// Cmovg_r32_rm32
			(ushort)Mnemonic.Cmovg,// Cmovg_r64_rm64
			(ushort)Mnemonic.Kandw,// VEX_Kandw_k_k_k
			(ushort)Mnemonic.Kandq,// VEX_Kandq_k_k_k
			(ushort)Mnemonic.Kandb,// VEX_Kandb_k_k_k
			(ushort)Mnemonic.Kandd,// VEX_Kandd_k_k_k
			(ushort)Mnemonic.Kandnw,// VEX_Kandnw_k_k_k
			(ushort)Mnemonic.Kandnq,// VEX_Kandnq_k_k_k
			(ushort)Mnemonic.Kandnb,// VEX_Kandnb_k_k_k
			(ushort)Mnemonic.Kandnd,// VEX_Kandnd_k_k_k
			(ushort)Mnemonic.Knotw,// VEX_Knotw_k_k
			(ushort)Mnemonic.Knotq,// VEX_Knotq_k_k
			(ushort)Mnemonic.Knotb,// VEX_Knotb_k_k
			(ushort)Mnemonic.Knotd,// VEX_Knotd_k_k
			(ushort)Mnemonic.Korw,// VEX_Korw_k_k_k
			(ushort)Mnemonic.Korq,// VEX_Korq_k_k_k
			(ushort)Mnemonic.Korb,// VEX_Korb_k_k_k
			(ushort)Mnemonic.Kord,// VEX_Kord_k_k_k
			(ushort)Mnemonic.Kxnorw,// VEX_Kxnorw_k_k_k
			(ushort)Mnemonic.Kxnorq,// VEX_Kxnorq_k_k_k
			(ushort)Mnemonic.Kxnorb,// VEX_Kxnorb_k_k_k
			(ushort)Mnemonic.Kxnord,// VEX_Kxnord_k_k_k
			(ushort)Mnemonic.Kxorw,// VEX_Kxorw_k_k_k
			(ushort)Mnemonic.Kxorq,// VEX_Kxorq_k_k_k
			(ushort)Mnemonic.Kxorb,// VEX_Kxorb_k_k_k
			(ushort)Mnemonic.Kxord,// VEX_Kxord_k_k_k
			(ushort)Mnemonic.Kaddw,// VEX_Kaddw_k_k_k
			(ushort)Mnemonic.Kaddq,// VEX_Kaddq_k_k_k
			(ushort)Mnemonic.Kaddb,// VEX_Kaddb_k_k_k
			(ushort)Mnemonic.Kaddd,// VEX_Kaddd_k_k_k
			(ushort)Mnemonic.Kunpckwd,// VEX_Kunpckwd_k_k_k
			(ushort)Mnemonic.Kunpckdq,// VEX_Kunpckdq_k_k_k
			(ushort)Mnemonic.Kunpckbw,// VEX_Kunpckbw_k_k_k
			(ushort)Mnemonic.Movmskps,// Movmskps_r32_xmm
			(ushort)Mnemonic.Movmskps,// Movmskps_r64_xmm
			(ushort)Mnemonic.Vmovmskps,// VEX_Vmovmskps_r32_xmm
			(ushort)Mnemonic.Vmovmskps,// VEX_Vmovmskps_r64_xmm
			(ushort)Mnemonic.Vmovmskps,// VEX_Vmovmskps_r32_ymm
			(ushort)Mnemonic.Vmovmskps,// VEX_Vmovmskps_r64_ymm
			(ushort)Mnemonic.Movmskpd,// Movmskpd_r32_xmm
			(ushort)Mnemonic.Movmskpd,// Movmskpd_r64_xmm
			(ushort)Mnemonic.Vmovmskpd,// VEX_Vmovmskpd_r32_xmm
			(ushort)Mnemonic.Vmovmskpd,// VEX_Vmovmskpd_r64_xmm
			(ushort)Mnemonic.Vmovmskpd,// VEX_Vmovmskpd_r32_ymm
			(ushort)Mnemonic.Vmovmskpd,// VEX_Vmovmskpd_r64_ymm
			(ushort)Mnemonic.Sqrtps,// Sqrtps_xmm_xmmm128
			(ushort)Mnemonic.Vsqrtps,// VEX_Vsqrtps_xmm_xmmm128
			(ushort)Mnemonic.Vsqrtps,// VEX_Vsqrtps_ymm_ymmm256
			(ushort)Mnemonic.Vsqrtps,// EVEX_Vsqrtps_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vsqrtps,// EVEX_Vsqrtps_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vsqrtps,// EVEX_Vsqrtps_zmm_k1z_zmmm512b32_er
			(ushort)Mnemonic.Sqrtpd,// Sqrtpd_xmm_xmmm128
			(ushort)Mnemonic.Vsqrtpd,// VEX_Vsqrtpd_xmm_xmmm128
			(ushort)Mnemonic.Vsqrtpd,// VEX_Vsqrtpd_ymm_ymmm256
			(ushort)Mnemonic.Vsqrtpd,// EVEX_Vsqrtpd_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vsqrtpd,// EVEX_Vsqrtpd_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vsqrtpd,// EVEX_Vsqrtpd_zmm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Sqrtss,// Sqrtss_xmm_xmmm32
			(ushort)Mnemonic.Vsqrtss,// VEX_Vsqrtss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vsqrtss,// EVEX_Vsqrtss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Sqrtsd,// Sqrtsd_xmm_xmmm64
			(ushort)Mnemonic.Vsqrtsd,// VEX_Vsqrtsd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vsqrtsd,// EVEX_Vsqrtsd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Rsqrtps,// Rsqrtps_xmm_xmmm128
			(ushort)Mnemonic.Vrsqrtps,// VEX_Vrsqrtps_xmm_xmmm128
			(ushort)Mnemonic.Vrsqrtps,// VEX_Vrsqrtps_ymm_ymmm256
			(ushort)Mnemonic.Rsqrtss,// Rsqrtss_xmm_xmmm32
			(ushort)Mnemonic.Vrsqrtss,// VEX_Vrsqrtss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Rcpps,// Rcpps_xmm_xmmm128
			(ushort)Mnemonic.Vrcpps,// VEX_Vrcpps_xmm_xmmm128
			(ushort)Mnemonic.Vrcpps,// VEX_Vrcpps_ymm_ymmm256
			(ushort)Mnemonic.Rcpss,// Rcpss_xmm_xmmm32
			(ushort)Mnemonic.Vrcpss,// VEX_Vrcpss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Andps,// Andps_xmm_xmmm128
			(ushort)Mnemonic.Vandps,// VEX_Vandps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vandps,// VEX_Vandps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vandps,// EVEX_Vandps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vandps,// EVEX_Vandps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vandps,// EVEX_Vandps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Andpd,// Andpd_xmm_xmmm128
			(ushort)Mnemonic.Vandpd,// VEX_Vandpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vandpd,// VEX_Vandpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vandpd,// EVEX_Vandpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vandpd,// EVEX_Vandpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vandpd,// EVEX_Vandpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Andnps,// Andnps_xmm_xmmm128
			(ushort)Mnemonic.Vandnps,// VEX_Vandnps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vandnps,// VEX_Vandnps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vandnps,// EVEX_Vandnps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vandnps,// EVEX_Vandnps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vandnps,// EVEX_Vandnps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Andnpd,// Andnpd_xmm_xmmm128
			(ushort)Mnemonic.Vandnpd,// VEX_Vandnpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vandnpd,// VEX_Vandnpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vandnpd,// EVEX_Vandnpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vandnpd,// EVEX_Vandnpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vandnpd,// EVEX_Vandnpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Orps,// Orps_xmm_xmmm128
			(ushort)Mnemonic.Vorps,// VEX_Vorps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vorps,// VEX_Vorps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vorps,// EVEX_Vorps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vorps,// EVEX_Vorps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vorps,// EVEX_Vorps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Orpd,// Orpd_xmm_xmmm128
			(ushort)Mnemonic.Vorpd,// VEX_Vorpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vorpd,// VEX_Vorpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vorpd,// EVEX_Vorpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vorpd,// EVEX_Vorpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vorpd,// EVEX_Vorpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Xorps,// Xorps_xmm_xmmm128
			(ushort)Mnemonic.Vxorps,// VEX_Vxorps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vxorps,// VEX_Vxorps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vxorps,// EVEX_Vxorps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vxorps,// EVEX_Vxorps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vxorps,// EVEX_Vxorps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Xorpd,// Xorpd_xmm_xmmm128
			(ushort)Mnemonic.Vxorpd,// VEX_Vxorpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vxorpd,// VEX_Vxorpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vxorpd,// EVEX_Vxorpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vxorpd,// EVEX_Vxorpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vxorpd,// EVEX_Vxorpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Addps,// Addps_xmm_xmmm128
			(ushort)Mnemonic.Vaddps,// VEX_Vaddps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaddps,// VEX_Vaddps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaddps,// EVEX_Vaddps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vaddps,// EVEX_Vaddps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vaddps,// EVEX_Vaddps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Addpd,// Addpd_xmm_xmmm128
			(ushort)Mnemonic.Vaddpd,// VEX_Vaddpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaddpd,// VEX_Vaddpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaddpd,// EVEX_Vaddpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vaddpd,// EVEX_Vaddpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vaddpd,// EVEX_Vaddpd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Addss,// Addss_xmm_xmmm32
			(ushort)Mnemonic.Vaddss,// VEX_Vaddss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vaddss,// EVEX_Vaddss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Addsd,// Addsd_xmm_xmmm64
			(ushort)Mnemonic.Vaddsd,// VEX_Vaddsd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vaddsd,// EVEX_Vaddsd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Mulps,// Mulps_xmm_xmmm128
			(ushort)Mnemonic.Vmulps,// VEX_Vmulps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vmulps,// VEX_Vmulps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vmulps,// EVEX_Vmulps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vmulps,// EVEX_Vmulps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vmulps,// EVEX_Vmulps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Mulpd,// Mulpd_xmm_xmmm128
			(ushort)Mnemonic.Vmulpd,// VEX_Vmulpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vmulpd,// VEX_Vmulpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vmulpd,// EVEX_Vmulpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vmulpd,// EVEX_Vmulpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vmulpd,// EVEX_Vmulpd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Mulss,// Mulss_xmm_xmmm32
			(ushort)Mnemonic.Vmulss,// VEX_Vmulss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vmulss,// EVEX_Vmulss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Mulsd,// Mulsd_xmm_xmmm64
			(ushort)Mnemonic.Vmulsd,// VEX_Vmulsd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vmulsd,// EVEX_Vmulsd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Cvtps2pd,// Cvtps2pd_xmm_xmmm64
			(ushort)Mnemonic.Vcvtps2pd,// VEX_Vcvtps2pd_xmm_xmmm64
			(ushort)Mnemonic.Vcvtps2pd,// VEX_Vcvtps2pd_ymm_xmmm128
			(ushort)Mnemonic.Vcvtps2pd,// EVEX_Vcvtps2pd_xmm_k1z_xmmm64b32
			(ushort)Mnemonic.Vcvtps2pd,// EVEX_Vcvtps2pd_ymm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtps2pd,// EVEX_Vcvtps2pd_zmm_k1z_ymmm256b32_sae
			(ushort)Mnemonic.Cvtpd2ps,// Cvtpd2ps_xmm_xmmm128
			(ushort)Mnemonic.Vcvtpd2ps,// VEX_Vcvtpd2ps_xmm_xmmm128
			(ushort)Mnemonic.Vcvtpd2ps,// VEX_Vcvtpd2ps_xmm_ymmm256
			(ushort)Mnemonic.Vcvtpd2ps,// EVEX_Vcvtpd2ps_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtpd2ps,// EVEX_Vcvtpd2ps_xmm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtpd2ps,// EVEX_Vcvtpd2ps_ymm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Cvtss2sd,// Cvtss2sd_xmm_xmmm32
			(ushort)Mnemonic.Vcvtss2sd,// VEX_Vcvtss2sd_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vcvtss2sd,// EVEX_Vcvtss2sd_xmm_k1z_xmm_xmmm32_sae
			(ushort)Mnemonic.Cvtsd2ss,// Cvtsd2ss_xmm_xmmm64
			(ushort)Mnemonic.Vcvtsd2ss,// VEX_Vcvtsd2ss_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vcvtsd2ss,// EVEX_Vcvtsd2ss_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Cvtdq2ps,// Cvtdq2ps_xmm_xmmm128
			(ushort)Mnemonic.Vcvtdq2ps,// VEX_Vcvtdq2ps_xmm_xmmm128
			(ushort)Mnemonic.Vcvtdq2ps,// VEX_Vcvtdq2ps_ymm_ymmm256
			(ushort)Mnemonic.Vcvtdq2ps,// EVEX_Vcvtdq2ps_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtdq2ps,// EVEX_Vcvtdq2ps_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvtdq2ps,// EVEX_Vcvtdq2ps_zmm_k1z_zmmm512b32_er
			(ushort)Mnemonic.Vcvtqq2ps,// EVEX_Vcvtqq2ps_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtqq2ps,// EVEX_Vcvtqq2ps_xmm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtqq2ps,// EVEX_Vcvtqq2ps_ymm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Cvtps2dq,// Cvtps2dq_xmm_xmmm128
			(ushort)Mnemonic.Vcvtps2dq,// VEX_Vcvtps2dq_xmm_xmmm128
			(ushort)Mnemonic.Vcvtps2dq,// VEX_Vcvtps2dq_ymm_ymmm256
			(ushort)Mnemonic.Vcvtps2dq,// EVEX_Vcvtps2dq_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtps2dq,// EVEX_Vcvtps2dq_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvtps2dq,// EVEX_Vcvtps2dq_zmm_k1z_zmmm512b32_er
			(ushort)Mnemonic.Cvttps2dq,// Cvttps2dq_xmm_xmmm128
			(ushort)Mnemonic.Vcvttps2dq,// VEX_Vcvttps2dq_xmm_xmmm128
			(ushort)Mnemonic.Vcvttps2dq,// VEX_Vcvttps2dq_ymm_ymmm256
			(ushort)Mnemonic.Vcvttps2dq,// EVEX_Vcvttps2dq_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvttps2dq,// EVEX_Vcvttps2dq_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvttps2dq,// EVEX_Vcvttps2dq_zmm_k1z_zmmm512b32_sae
			(ushort)Mnemonic.Subps,// Subps_xmm_xmmm128
			(ushort)Mnemonic.Vsubps,// VEX_Vsubps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vsubps,// VEX_Vsubps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vsubps,// EVEX_Vsubps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vsubps,// EVEX_Vsubps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vsubps,// EVEX_Vsubps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Subpd,// Subpd_xmm_xmmm128
			(ushort)Mnemonic.Vsubpd,// VEX_Vsubpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vsubpd,// VEX_Vsubpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vsubpd,// EVEX_Vsubpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vsubpd,// EVEX_Vsubpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vsubpd,// EVEX_Vsubpd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Subss,// Subss_xmm_xmmm32
			(ushort)Mnemonic.Vsubss,// VEX_Vsubss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vsubss,// EVEX_Vsubss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Subsd,// Subsd_xmm_xmmm64
			(ushort)Mnemonic.Vsubsd,// VEX_Vsubsd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vsubsd,// EVEX_Vsubsd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Minps,// Minps_xmm_xmmm128
			(ushort)Mnemonic.Vminps,// VEX_Vminps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vminps,// VEX_Vminps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vminps,// EVEX_Vminps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vminps,// EVEX_Vminps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vminps,// EVEX_Vminps_zmm_k1z_zmm_zmmm512b32_sae
			(ushort)Mnemonic.Minpd,// Minpd_xmm_xmmm128
			(ushort)Mnemonic.Vminpd,// VEX_Vminpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vminpd,// VEX_Vminpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vminpd,// EVEX_Vminpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vminpd,// EVEX_Vminpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vminpd,// EVEX_Vminpd_zmm_k1z_zmm_zmmm512b64_sae
			(ushort)Mnemonic.Minss,// Minss_xmm_xmmm32
			(ushort)Mnemonic.Vminss,// VEX_Vminss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vminss,// EVEX_Vminss_xmm_k1z_xmm_xmmm32_sae
			(ushort)Mnemonic.Minsd,// Minsd_xmm_xmmm64
			(ushort)Mnemonic.Vminsd,// VEX_Vminsd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vminsd,// EVEX_Vminsd_xmm_k1z_xmm_xmmm64_sae
			(ushort)Mnemonic.Divps,// Divps_xmm_xmmm128
			(ushort)Mnemonic.Vdivps,// VEX_Vdivps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vdivps,// VEX_Vdivps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vdivps,// EVEX_Vdivps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vdivps,// EVEX_Vdivps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vdivps,// EVEX_Vdivps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Divpd,// Divpd_xmm_xmmm128
			(ushort)Mnemonic.Vdivpd,// VEX_Vdivpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vdivpd,// VEX_Vdivpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vdivpd,// EVEX_Vdivpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vdivpd,// EVEX_Vdivpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vdivpd,// EVEX_Vdivpd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Divss,// Divss_xmm_xmmm32
			(ushort)Mnemonic.Vdivss,// VEX_Vdivss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vdivss,// EVEX_Vdivss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Divsd,// Divsd_xmm_xmmm64
			(ushort)Mnemonic.Vdivsd,// VEX_Vdivsd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vdivsd,// EVEX_Vdivsd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Maxps,// Maxps_xmm_xmmm128
			(ushort)Mnemonic.Vmaxps,// VEX_Vmaxps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vmaxps,// VEX_Vmaxps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vmaxps,// EVEX_Vmaxps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vmaxps,// EVEX_Vmaxps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vmaxps,// EVEX_Vmaxps_zmm_k1z_zmm_zmmm512b32_sae
			(ushort)Mnemonic.Maxpd,// Maxpd_xmm_xmmm128
			(ushort)Mnemonic.Vmaxpd,// VEX_Vmaxpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vmaxpd,// VEX_Vmaxpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vmaxpd,// EVEX_Vmaxpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vmaxpd,// EVEX_Vmaxpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vmaxpd,// EVEX_Vmaxpd_zmm_k1z_zmm_zmmm512b64_sae
			(ushort)Mnemonic.Maxss,// Maxss_xmm_xmmm32
			(ushort)Mnemonic.Vmaxss,// VEX_Vmaxss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vmaxss,// EVEX_Vmaxss_xmm_k1z_xmm_xmmm32_sae
			(ushort)Mnemonic.Maxsd,// Maxsd_xmm_xmmm64
			(ushort)Mnemonic.Vmaxsd,// VEX_Vmaxsd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vmaxsd,// EVEX_Vmaxsd_xmm_k1z_xmm_xmmm64_sae
			(ushort)Mnemonic.Punpcklbw,// Punpcklbw_mm_mmm32
			(ushort)Mnemonic.Punpcklbw,// Punpcklbw_xmm_xmmm128
			(ushort)Mnemonic.Vpunpcklbw,// VEX_Vpunpcklbw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpunpcklbw,// VEX_Vpunpcklbw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpunpcklbw,// EVEX_Vpunpcklbw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpunpcklbw,// EVEX_Vpunpcklbw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpunpcklbw,// EVEX_Vpunpcklbw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Punpcklwd,// Punpcklwd_mm_mmm32
			(ushort)Mnemonic.Punpcklwd,// Punpcklwd_xmm_xmmm128
			(ushort)Mnemonic.Vpunpcklwd,// VEX_Vpunpcklwd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpunpcklwd,// VEX_Vpunpcklwd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpunpcklwd,// EVEX_Vpunpcklwd_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpunpcklwd,// EVEX_Vpunpcklwd_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpunpcklwd,// EVEX_Vpunpcklwd_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Punpckldq,// Punpckldq_mm_mmm32
			(ushort)Mnemonic.Punpckldq,// Punpckldq_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckldq,// VEX_Vpunpckldq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckldq,// VEX_Vpunpckldq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpunpckldq,// EVEX_Vpunpckldq_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpunpckldq,// EVEX_Vpunpckldq_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpunpckldq,// EVEX_Vpunpckldq_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Packsswb,// Packsswb_mm_mmm64
			(ushort)Mnemonic.Packsswb,// Packsswb_xmm_xmmm128
			(ushort)Mnemonic.Vpacksswb,// VEX_Vpacksswb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpacksswb,// VEX_Vpacksswb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpacksswb,// EVEX_Vpacksswb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpacksswb,// EVEX_Vpacksswb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpacksswb,// EVEX_Vpacksswb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pcmpgtb,// Pcmpgtb_mm_mmm64
			(ushort)Mnemonic.Pcmpgtb,// Pcmpgtb_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtb,// VEX_Vpcmpgtb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtb,// VEX_Vpcmpgtb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpgtb,// EVEX_Vpcmpgtb_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtb,// EVEX_Vpcmpgtb_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpgtb,// EVEX_Vpcmpgtb_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Pcmpgtw,// Pcmpgtw_mm_mmm64
			(ushort)Mnemonic.Pcmpgtw,// Pcmpgtw_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtw,// VEX_Vpcmpgtw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtw,// VEX_Vpcmpgtw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpgtw,// EVEX_Vpcmpgtw_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtw,// EVEX_Vpcmpgtw_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpgtw,// EVEX_Vpcmpgtw_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Pcmpgtd,// Pcmpgtd_mm_mmm64
			(ushort)Mnemonic.Pcmpgtd,// Pcmpgtd_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtd,// VEX_Vpcmpgtd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtd,// VEX_Vpcmpgtd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpgtd,// EVEX_Vpcmpgtd_k_k1_xmm_xmmm128b32
			(ushort)Mnemonic.Vpcmpgtd,// EVEX_Vpcmpgtd_k_k1_ymm_ymmm256b32
			(ushort)Mnemonic.Vpcmpgtd,// EVEX_Vpcmpgtd_k_k1_zmm_zmmm512b32
			(ushort)Mnemonic.Packuswb,// Packuswb_mm_mmm64
			(ushort)Mnemonic.Packuswb,// Packuswb_xmm_xmmm128
			(ushort)Mnemonic.Vpackuswb,// VEX_Vpackuswb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpackuswb,// VEX_Vpackuswb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpackuswb,// EVEX_Vpackuswb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpackuswb,// EVEX_Vpackuswb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpackuswb,// EVEX_Vpackuswb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Punpckhbw,// Punpckhbw_mm_mmm64
			(ushort)Mnemonic.Punpckhbw,// Punpckhbw_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhbw,// VEX_Vpunpckhbw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhbw,// VEX_Vpunpckhbw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpunpckhbw,// EVEX_Vpunpckhbw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhbw,// EVEX_Vpunpckhbw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpunpckhbw,// EVEX_Vpunpckhbw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Punpckhwd,// Punpckhwd_mm_mmm64
			(ushort)Mnemonic.Punpckhwd,// Punpckhwd_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhwd,// VEX_Vpunpckhwd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhwd,// VEX_Vpunpckhwd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpunpckhwd,// EVEX_Vpunpckhwd_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhwd,// EVEX_Vpunpckhwd_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpunpckhwd,// EVEX_Vpunpckhwd_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Punpckhdq,// Punpckhdq_mm_mmm64
			(ushort)Mnemonic.Punpckhdq,// Punpckhdq_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhdq,// VEX_Vpunpckhdq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhdq,// VEX_Vpunpckhdq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpunpckhdq,// EVEX_Vpunpckhdq_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpunpckhdq,// EVEX_Vpunpckhdq_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpunpckhdq,// EVEX_Vpunpckhdq_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Packssdw,// Packssdw_mm_mmm64
			(ushort)Mnemonic.Packssdw,// Packssdw_xmm_xmmm128
			(ushort)Mnemonic.Vpackssdw,// VEX_Vpackssdw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpackssdw,// VEX_Vpackssdw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpackssdw,// EVEX_Vpackssdw_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpackssdw,// EVEX_Vpackssdw_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpackssdw,// EVEX_Vpackssdw_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Punpcklqdq,// Punpcklqdq_xmm_xmmm128
			(ushort)Mnemonic.Vpunpcklqdq,// VEX_Vpunpcklqdq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpunpcklqdq,// VEX_Vpunpcklqdq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpunpcklqdq,// EVEX_Vpunpcklqdq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpunpcklqdq,// EVEX_Vpunpcklqdq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpunpcklqdq,// EVEX_Vpunpcklqdq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Punpckhqdq,// Punpckhqdq_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhqdq,// VEX_Vpunpckhqdq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpunpckhqdq,// VEX_Vpunpckhqdq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpunpckhqdq,// EVEX_Vpunpckhqdq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpunpckhqdq,// EVEX_Vpunpckhqdq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpunpckhqdq,// EVEX_Vpunpckhqdq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Movd,// Movd_mm_rm32
			(ushort)Mnemonic.Movq,// Movq_mm_rm64
			(ushort)Mnemonic.Movd,// Movd_xmm_rm32
			(ushort)Mnemonic.Movq,// Movq_xmm_rm64
			(ushort)Mnemonic.Vmovd,// VEX_Vmovd_xmm_rm32
			(ushort)Mnemonic.Vmovq,// VEX_Vmovq_xmm_rm64
			(ushort)Mnemonic.Vmovd,// EVEX_Vmovd_xmm_rm32
			(ushort)Mnemonic.Vmovq,// EVEX_Vmovq_xmm_rm64
			(ushort)Mnemonic.Movq,// Movq_mm_mmm64
			(ushort)Mnemonic.Movdqa,// Movdqa_xmm_xmmm128
			(ushort)Mnemonic.Vmovdqa,// VEX_Vmovdqa_xmm_xmmm128
			(ushort)Mnemonic.Vmovdqa,// VEX_Vmovdqa_ymm_ymmm256
			(ushort)Mnemonic.Vmovdqa32,// EVEX_Vmovdqa32_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovdqa32,// EVEX_Vmovdqa32_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovdqa32,// EVEX_Vmovdqa32_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vmovdqa64,// EVEX_Vmovdqa64_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovdqa64,// EVEX_Vmovdqa64_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovdqa64,// EVEX_Vmovdqa64_zmm_k1z_zmmm512
			(ushort)Mnemonic.Movdqu,// Movdqu_xmm_xmmm128
			(ushort)Mnemonic.Vmovdqu,// VEX_Vmovdqu_xmm_xmmm128
			(ushort)Mnemonic.Vmovdqu,// VEX_Vmovdqu_ymm_ymmm256
			(ushort)Mnemonic.Vmovdqu32,// EVEX_Vmovdqu32_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovdqu32,// EVEX_Vmovdqu32_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovdqu32,// EVEX_Vmovdqu32_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vmovdqu64,// EVEX_Vmovdqu64_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovdqu64,// EVEX_Vmovdqu64_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovdqu64,// EVEX_Vmovdqu64_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vmovdqu8,// EVEX_Vmovdqu8_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovdqu8,// EVEX_Vmovdqu8_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovdqu8,// EVEX_Vmovdqu8_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vmovdqu16,// EVEX_Vmovdqu16_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vmovdqu16,// EVEX_Vmovdqu16_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vmovdqu16,// EVEX_Vmovdqu16_zmm_k1z_zmmm512
			(ushort)Mnemonic.Pshufw,// Pshufw_mm_mmm64_imm8
			(ushort)Mnemonic.Pshufd,// Pshufd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpshufd,// VEX_Vpshufd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpshufd,// VEX_Vpshufd_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpshufd,// EVEX_Vpshufd_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vpshufd,// EVEX_Vpshufd_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vpshufd,// EVEX_Vpshufd_zmm_k1z_zmmm512b32_imm8
			(ushort)Mnemonic.Pshufhw,// Pshufhw_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpshufhw,// VEX_Vpshufhw_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpshufhw,// VEX_Vpshufhw_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpshufhw,// EVEX_Vpshufhw_xmm_k1z_xmmm128_imm8
			(ushort)Mnemonic.Vpshufhw,// EVEX_Vpshufhw_ymm_k1z_ymmm256_imm8
			(ushort)Mnemonic.Vpshufhw,// EVEX_Vpshufhw_zmm_k1z_zmmm512_imm8
			(ushort)Mnemonic.Pshuflw,// Pshuflw_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpshuflw,// VEX_Vpshuflw_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpshuflw,// VEX_Vpshuflw_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpshuflw,// EVEX_Vpshuflw_xmm_k1z_xmmm128_imm8
			(ushort)Mnemonic.Vpshuflw,// EVEX_Vpshuflw_ymm_k1z_ymmm256_imm8
			(ushort)Mnemonic.Vpshuflw,// EVEX_Vpshuflw_zmm_k1z_zmmm512_imm8
			(ushort)Mnemonic.Psrlw,// Psrlw_mm_imm8
			(ushort)Mnemonic.Psrlw,// Psrlw_xmm_imm8
			(ushort)Mnemonic.Vpsrlw,// VEX_Vpsrlw_xmm_xmm_imm8
			(ushort)Mnemonic.Vpsrlw,// VEX_Vpsrlw_ymm_ymm_imm8
			(ushort)Mnemonic.Vpsrlw,// EVEX_Vpsrlw_xmm_k1z_xmmm128_imm8
			(ushort)Mnemonic.Vpsrlw,// EVEX_Vpsrlw_ymm_k1z_ymmm256_imm8
			(ushort)Mnemonic.Vpsrlw,// EVEX_Vpsrlw_zmm_k1z_zmmm512_imm8
			(ushort)Mnemonic.Psraw,// Psraw_mm_imm8
			(ushort)Mnemonic.Psraw,// Psraw_xmm_imm8
			(ushort)Mnemonic.Vpsraw,// VEX_Vpsraw_xmm_xmm_imm8
			(ushort)Mnemonic.Vpsraw,// VEX_Vpsraw_ymm_ymm_imm8
			(ushort)Mnemonic.Vpsraw,// EVEX_Vpsraw_xmm_k1z_xmmm128_imm8
			(ushort)Mnemonic.Vpsraw,// EVEX_Vpsraw_ymm_k1z_ymmm256_imm8
			(ushort)Mnemonic.Vpsraw,// EVEX_Vpsraw_zmm_k1z_zmmm512_imm8
			(ushort)Mnemonic.Psllw,// Psllw_mm_imm8
			(ushort)Mnemonic.Psllw,// Psllw_xmm_imm8
			(ushort)Mnemonic.Vpsllw,// VEX_Vpsllw_xmm_xmm_imm8
			(ushort)Mnemonic.Vpsllw,// VEX_Vpsllw_ymm_ymm_imm8
			(ushort)Mnemonic.Vpsllw,// EVEX_Vpsllw_xmm_k1z_xmmm128_imm8
			(ushort)Mnemonic.Vpsllw,// EVEX_Vpsllw_ymm_k1z_ymmm256_imm8
			(ushort)Mnemonic.Vpsllw,// EVEX_Vpsllw_zmm_k1z_zmmm512_imm8
			(ushort)Mnemonic.Vprord,// EVEX_Vprord_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vprord,// EVEX_Vprord_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vprord,// EVEX_Vprord_zmm_k1z_zmmm512b32_imm8
			(ushort)Mnemonic.Vprorq,// EVEX_Vprorq_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vprorq,// EVEX_Vprorq_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vprorq,// EVEX_Vprorq_zmm_k1z_zmmm512b64_imm8
			(ushort)Mnemonic.Vprold,// EVEX_Vprold_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vprold,// EVEX_Vprold_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vprold,// EVEX_Vprold_zmm_k1z_zmmm512b32_imm8
			(ushort)Mnemonic.Vprolq,// EVEX_Vprolq_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vprolq,// EVEX_Vprolq_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vprolq,// EVEX_Vprolq_zmm_k1z_zmmm512b64_imm8
			(ushort)Mnemonic.Psrld,// Psrld_mm_imm8
			(ushort)Mnemonic.Psrld,// Psrld_xmm_imm8
			(ushort)Mnemonic.Vpsrld,// VEX_Vpsrld_xmm_xmm_imm8
			(ushort)Mnemonic.Vpsrld,// VEX_Vpsrld_ymm_ymm_imm8
			(ushort)Mnemonic.Vpsrld,// EVEX_Vpsrld_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vpsrld,// EVEX_Vpsrld_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vpsrld,// EVEX_Vpsrld_zmm_k1z_zmmm512b32_imm8
			(ushort)Mnemonic.Psrad,// Psrad_mm_imm8
			(ushort)Mnemonic.Psrad,// Psrad_xmm_imm8
			(ushort)Mnemonic.Vpsrad,// VEX_Vpsrad_xmm_xmm_imm8
			(ushort)Mnemonic.Vpsrad,// VEX_Vpsrad_ymm_ymm_imm8
			(ushort)Mnemonic.Vpsrad,// EVEX_Vpsrad_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vpsrad,// EVEX_Vpsrad_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vpsrad,// EVEX_Vpsrad_zmm_k1z_zmmm512b32_imm8
			(ushort)Mnemonic.Vpsraq,// EVEX_Vpsraq_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vpsraq,// EVEX_Vpsraq_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vpsraq,// EVEX_Vpsraq_zmm_k1z_zmmm512b64_imm8
			(ushort)Mnemonic.Pslld,// Pslld_mm_imm8
			(ushort)Mnemonic.Pslld,// Pslld_xmm_imm8
			(ushort)Mnemonic.Vpslld,// VEX_Vpslld_xmm_xmm_imm8
			(ushort)Mnemonic.Vpslld,// VEX_Vpslld_ymm_ymm_imm8
			(ushort)Mnemonic.Vpslld,// EVEX_Vpslld_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vpslld,// EVEX_Vpslld_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vpslld,// EVEX_Vpslld_zmm_k1z_zmmm512b32_imm8
			(ushort)Mnemonic.Psrlq,// Psrlq_mm_imm8
			(ushort)Mnemonic.Psrlq,// Psrlq_xmm_imm8
			(ushort)Mnemonic.Vpsrlq,// VEX_Vpsrlq_xmm_xmm_imm8
			(ushort)Mnemonic.Vpsrlq,// VEX_Vpsrlq_ymm_ymm_imm8
			(ushort)Mnemonic.Vpsrlq,// EVEX_Vpsrlq_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vpsrlq,// EVEX_Vpsrlq_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vpsrlq,// EVEX_Vpsrlq_zmm_k1z_zmmm512b64_imm8
			(ushort)Mnemonic.Psrldq,// Psrldq_xmm_imm8
			(ushort)Mnemonic.Vpsrldq,// VEX_Vpsrldq_xmm_xmm_imm8
			(ushort)Mnemonic.Vpsrldq,// VEX_Vpsrldq_ymm_ymm_imm8
			(ushort)Mnemonic.Vpsrldq,// EVEX_Vpsrldq_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpsrldq,// EVEX_Vpsrldq_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpsrldq,// EVEX_Vpsrldq_zmm_zmmm512_imm8
			(ushort)Mnemonic.Psllq,// Psllq_mm_imm8
			(ushort)Mnemonic.Psllq,// Psllq_xmm_imm8
			(ushort)Mnemonic.Vpsllq,// VEX_Vpsllq_xmm_xmm_imm8
			(ushort)Mnemonic.Vpsllq,// VEX_Vpsllq_ymm_ymm_imm8
			(ushort)Mnemonic.Vpsllq,// EVEX_Vpsllq_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vpsllq,// EVEX_Vpsllq_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vpsllq,// EVEX_Vpsllq_zmm_k1z_zmmm512b64_imm8
			(ushort)Mnemonic.Pslldq,// Pslldq_xmm_imm8
			(ushort)Mnemonic.Vpslldq,// VEX_Vpslldq_xmm_xmm_imm8
			(ushort)Mnemonic.Vpslldq,// VEX_Vpslldq_ymm_ymm_imm8
			(ushort)Mnemonic.Vpslldq,// EVEX_Vpslldq_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpslldq,// EVEX_Vpslldq_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpslldq,// EVEX_Vpslldq_zmm_zmmm512_imm8
			(ushort)Mnemonic.Pcmpeqb,// Pcmpeqb_mm_mmm64
			(ushort)Mnemonic.Pcmpeqb,// Pcmpeqb_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqb,// VEX_Vpcmpeqb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqb,// VEX_Vpcmpeqb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpeqb,// EVEX_Vpcmpeqb_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqb,// EVEX_Vpcmpeqb_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpeqb,// EVEX_Vpcmpeqb_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Pcmpeqw,// Pcmpeqw_mm_mmm64
			(ushort)Mnemonic.Pcmpeqw,// Pcmpeqw_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqw,// VEX_Vpcmpeqw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqw,// VEX_Vpcmpeqw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpeqw,// EVEX_Vpcmpeqw_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqw,// EVEX_Vpcmpeqw_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpeqw,// EVEX_Vpcmpeqw_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Pcmpeqd,// Pcmpeqd_mm_mmm64
			(ushort)Mnemonic.Pcmpeqd,// Pcmpeqd_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqd,// VEX_Vpcmpeqd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqd,// VEX_Vpcmpeqd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpeqd,// EVEX_Vpcmpeqd_k_k1_xmm_xmmm128b32
			(ushort)Mnemonic.Vpcmpeqd,// EVEX_Vpcmpeqd_k_k1_ymm_ymmm256b32
			(ushort)Mnemonic.Vpcmpeqd,// EVEX_Vpcmpeqd_k_k1_zmm_zmmm512b32
			(ushort)Mnemonic.Emms,// Emms
			(ushort)Mnemonic.Vzeroupper,// VEX_Vzeroupper
			(ushort)Mnemonic.Vzeroall,// VEX_Vzeroall
			(ushort)Mnemonic.Vmread,// Vmread_rm32_r32
			(ushort)Mnemonic.Vmread,// Vmread_rm64_r64
			(ushort)Mnemonic.Vcvttps2udq,// EVEX_Vcvttps2udq_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvttps2udq,// EVEX_Vcvttps2udq_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvttps2udq,// EVEX_Vcvttps2udq_zmm_k1z_zmmm512b32_sae
			(ushort)Mnemonic.Vcvttpd2udq,// EVEX_Vcvttpd2udq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvttpd2udq,// EVEX_Vcvttpd2udq_xmm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvttpd2udq,// EVEX_Vcvttpd2udq_ymm_k1z_zmmm512b64_sae
			(ushort)Mnemonic.Extrq,// Extrq_xmm_imm8_imm8
			(ushort)Mnemonic.Vcvttps2uqq,// EVEX_Vcvttps2uqq_xmm_k1z_xmmm64b32
			(ushort)Mnemonic.Vcvttps2uqq,// EVEX_Vcvttps2uqq_ymm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvttps2uqq,// EVEX_Vcvttps2uqq_zmm_k1z_ymmm256b32_sae
			(ushort)Mnemonic.Vcvttpd2uqq,// EVEX_Vcvttpd2uqq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvttpd2uqq,// EVEX_Vcvttpd2uqq_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvttpd2uqq,// EVEX_Vcvttpd2uqq_zmm_k1z_zmmm512b64_sae
			(ushort)Mnemonic.Vcvttss2usi,// EVEX_Vcvttss2usi_r32_xmmm32_sae
			(ushort)Mnemonic.Vcvttss2usi,// EVEX_Vcvttss2usi_r64_xmmm32_sae
			(ushort)Mnemonic.Insertq,// Insertq_xmm_xmm_imm8_imm8
			(ushort)Mnemonic.Vcvttsd2usi,// EVEX_Vcvttsd2usi_r32_xmmm64_sae
			(ushort)Mnemonic.Vcvttsd2usi,// EVEX_Vcvttsd2usi_r64_xmmm64_sae
			(ushort)Mnemonic.Vmwrite,// Vmwrite_r32_rm32
			(ushort)Mnemonic.Vmwrite,// Vmwrite_r64_rm64
			(ushort)Mnemonic.Vcvtps2udq,// EVEX_Vcvtps2udq_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtps2udq,// EVEX_Vcvtps2udq_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvtps2udq,// EVEX_Vcvtps2udq_zmm_k1z_zmmm512b32_er
			(ushort)Mnemonic.Vcvtpd2udq,// EVEX_Vcvtpd2udq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtpd2udq,// EVEX_Vcvtpd2udq_xmm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtpd2udq,// EVEX_Vcvtpd2udq_ymm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Extrq,// Extrq_xmm_xmm
			(ushort)Mnemonic.Vcvtps2uqq,// EVEX_Vcvtps2uqq_xmm_k1z_xmmm64b32
			(ushort)Mnemonic.Vcvtps2uqq,// EVEX_Vcvtps2uqq_ymm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtps2uqq,// EVEX_Vcvtps2uqq_zmm_k1z_ymmm256b32_er
			(ushort)Mnemonic.Vcvtpd2uqq,// EVEX_Vcvtpd2uqq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtpd2uqq,// EVEX_Vcvtpd2uqq_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtpd2uqq,// EVEX_Vcvtpd2uqq_zmm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Vcvtss2usi,// EVEX_Vcvtss2usi_r32_xmmm32_er
			(ushort)Mnemonic.Vcvtss2usi,// EVEX_Vcvtss2usi_r64_xmmm32_er
			(ushort)Mnemonic.Insertq,// Insertq_xmm_xmm
			(ushort)Mnemonic.Vcvtsd2usi,// EVEX_Vcvtsd2usi_r32_xmmm64_er
			(ushort)Mnemonic.Vcvtsd2usi,// EVEX_Vcvtsd2usi_r64_xmmm64_er
			(ushort)Mnemonic.Vcvttps2qq,// EVEX_Vcvttps2qq_xmm_k1z_xmmm64b32
			(ushort)Mnemonic.Vcvttps2qq,// EVEX_Vcvttps2qq_ymm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvttps2qq,// EVEX_Vcvttps2qq_zmm_k1z_ymmm256b32_sae
			(ushort)Mnemonic.Vcvttpd2qq,// EVEX_Vcvttpd2qq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvttpd2qq,// EVEX_Vcvttpd2qq_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvttpd2qq,// EVEX_Vcvttpd2qq_zmm_k1z_zmmm512b64_sae
			(ushort)Mnemonic.Vcvtudq2pd,// EVEX_Vcvtudq2pd_xmm_k1z_xmmm64b32
			(ushort)Mnemonic.Vcvtudq2pd,// EVEX_Vcvtudq2pd_ymm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtudq2pd,// EVEX_Vcvtudq2pd_zmm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvtuqq2pd,// EVEX_Vcvtuqq2pd_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtuqq2pd,// EVEX_Vcvtuqq2pd_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtuqq2pd,// EVEX_Vcvtuqq2pd_zmm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Vcvtudq2ps,// EVEX_Vcvtudq2ps_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtudq2ps,// EVEX_Vcvtudq2ps_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvtudq2ps,// EVEX_Vcvtudq2ps_zmm_k1z_zmmm512b32_er
			(ushort)Mnemonic.Vcvtuqq2ps,// EVEX_Vcvtuqq2ps_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtuqq2ps,// EVEX_Vcvtuqq2ps_xmm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtuqq2ps,// EVEX_Vcvtuqq2ps_ymm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Vcvtps2qq,// EVEX_Vcvtps2qq_xmm_k1z_xmmm64b32
			(ushort)Mnemonic.Vcvtps2qq,// EVEX_Vcvtps2qq_ymm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtps2qq,// EVEX_Vcvtps2qq_zmm_k1z_ymmm256b32_er
			(ushort)Mnemonic.Vcvtpd2qq,// EVEX_Vcvtpd2qq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtpd2qq,// EVEX_Vcvtpd2qq_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtpd2qq,// EVEX_Vcvtpd2qq_zmm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Vcvtusi2ss,// EVEX_Vcvtusi2ss_xmm_xmm_rm32_er
			(ushort)Mnemonic.Vcvtusi2ss,// EVEX_Vcvtusi2ss_xmm_xmm_rm64_er
			(ushort)Mnemonic.Vcvtusi2sd,// EVEX_Vcvtusi2sd_xmm_xmm_rm32_er
			(ushort)Mnemonic.Vcvtusi2sd,// EVEX_Vcvtusi2sd_xmm_xmm_rm64_er
			(ushort)Mnemonic.Haddpd,// Haddpd_xmm_xmmm128
			(ushort)Mnemonic.Vhaddpd,// VEX_Vhaddpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vhaddpd,// VEX_Vhaddpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Haddps,// Haddps_xmm_xmmm128
			(ushort)Mnemonic.Vhaddps,// VEX_Vhaddps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vhaddps,// VEX_Vhaddps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Hsubpd,// Hsubpd_xmm_xmmm128
			(ushort)Mnemonic.Vhsubpd,// VEX_Vhsubpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vhsubpd,// VEX_Vhsubpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Hsubps,// Hsubps_xmm_xmmm128
			(ushort)Mnemonic.Vhsubps,// VEX_Vhsubps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vhsubps,// VEX_Vhsubps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Movd,// Movd_rm32_mm
			(ushort)Mnemonic.Movq,// Movq_rm64_mm
			(ushort)Mnemonic.Movd,// Movd_rm32_xmm
			(ushort)Mnemonic.Movq,// Movq_rm64_xmm
			(ushort)Mnemonic.Vmovd,// VEX_Vmovd_rm32_xmm
			(ushort)Mnemonic.Vmovq,// VEX_Vmovq_rm64_xmm
			(ushort)Mnemonic.Vmovd,// EVEX_Vmovd_rm32_xmm
			(ushort)Mnemonic.Vmovq,// EVEX_Vmovq_rm64_xmm
			(ushort)Mnemonic.Movq,// Movq_xmm_xmmm64
			(ushort)Mnemonic.Vmovq,// VEX_Vmovq_xmm_xmmm64
			(ushort)Mnemonic.Vmovq,// EVEX_Vmovq_xmm_xmmm64
			(ushort)Mnemonic.Movq,// Movq_mmm64_mm
			(ushort)Mnemonic.Movdqa,// Movdqa_xmmm128_xmm
			(ushort)Mnemonic.Vmovdqa,// VEX_Vmovdqa_xmmm128_xmm
			(ushort)Mnemonic.Vmovdqa,// VEX_Vmovdqa_ymmm256_ymm
			(ushort)Mnemonic.Vmovdqa32,// EVEX_Vmovdqa32_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovdqa32,// EVEX_Vmovdqa32_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovdqa32,// EVEX_Vmovdqa32_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vmovdqa64,// EVEX_Vmovdqa64_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovdqa64,// EVEX_Vmovdqa64_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovdqa64,// EVEX_Vmovdqa64_zmmm512_k1z_zmm
			(ushort)Mnemonic.Movdqu,// Movdqu_xmmm128_xmm
			(ushort)Mnemonic.Vmovdqu,// VEX_Vmovdqu_xmmm128_xmm
			(ushort)Mnemonic.Vmovdqu,// VEX_Vmovdqu_ymmm256_ymm
			(ushort)Mnemonic.Vmovdqu32,// EVEX_Vmovdqu32_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovdqu32,// EVEX_Vmovdqu32_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovdqu32,// EVEX_Vmovdqu32_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vmovdqu64,// EVEX_Vmovdqu64_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovdqu64,// EVEX_Vmovdqu64_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovdqu64,// EVEX_Vmovdqu64_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vmovdqu8,// EVEX_Vmovdqu8_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovdqu8,// EVEX_Vmovdqu8_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovdqu8,// EVEX_Vmovdqu8_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vmovdqu16,// EVEX_Vmovdqu16_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vmovdqu16,// EVEX_Vmovdqu16_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vmovdqu16,// EVEX_Vmovdqu16_zmmm512_k1z_zmm
			(ushort)Mnemonic.Jo,// Jo_rel16
			(ushort)Mnemonic.Jo,// Jo_rel32_32
			(ushort)Mnemonic.Jo,// Jo_rel32_64
			(ushort)Mnemonic.Jno,// Jno_rel16
			(ushort)Mnemonic.Jno,// Jno_rel32_32
			(ushort)Mnemonic.Jno,// Jno_rel32_64
			(ushort)Mnemonic.Jb,// Jb_rel16
			(ushort)Mnemonic.Jb,// Jb_rel32_32
			(ushort)Mnemonic.Jb,// Jb_rel32_64
			(ushort)Mnemonic.Jae,// Jae_rel16
			(ushort)Mnemonic.Jae,// Jae_rel32_32
			(ushort)Mnemonic.Jae,// Jae_rel32_64
			(ushort)Mnemonic.Je,// Je_rel16
			(ushort)Mnemonic.Je,// Je_rel32_32
			(ushort)Mnemonic.Je,// Je_rel32_64
			(ushort)Mnemonic.Jne,// Jne_rel16
			(ushort)Mnemonic.Jne,// Jne_rel32_32
			(ushort)Mnemonic.Jne,// Jne_rel32_64
			(ushort)Mnemonic.Jbe,// Jbe_rel16
			(ushort)Mnemonic.Jbe,// Jbe_rel32_32
			(ushort)Mnemonic.Jbe,// Jbe_rel32_64
			(ushort)Mnemonic.Ja,// Ja_rel16
			(ushort)Mnemonic.Ja,// Ja_rel32_32
			(ushort)Mnemonic.Ja,// Ja_rel32_64
			(ushort)Mnemonic.Js,// Js_rel16
			(ushort)Mnemonic.Js,// Js_rel32_32
			(ushort)Mnemonic.Js,// Js_rel32_64
			(ushort)Mnemonic.Jns,// Jns_rel16
			(ushort)Mnemonic.Jns,// Jns_rel32_32
			(ushort)Mnemonic.Jns,// Jns_rel32_64
			(ushort)Mnemonic.Jp,// Jp_rel16
			(ushort)Mnemonic.Jp,// Jp_rel32_32
			(ushort)Mnemonic.Jp,// Jp_rel32_64
			(ushort)Mnemonic.Jnp,// Jnp_rel16
			(ushort)Mnemonic.Jnp,// Jnp_rel32_32
			(ushort)Mnemonic.Jnp,// Jnp_rel32_64
			(ushort)Mnemonic.Jl,// Jl_rel16
			(ushort)Mnemonic.Jl,// Jl_rel32_32
			(ushort)Mnemonic.Jl,// Jl_rel32_64
			(ushort)Mnemonic.Jge,// Jge_rel16
			(ushort)Mnemonic.Jge,// Jge_rel32_32
			(ushort)Mnemonic.Jge,// Jge_rel32_64
			(ushort)Mnemonic.Jle,// Jle_rel16
			(ushort)Mnemonic.Jle,// Jle_rel32_32
			(ushort)Mnemonic.Jle,// Jle_rel32_64
			(ushort)Mnemonic.Jg,// Jg_rel16
			(ushort)Mnemonic.Jg,// Jg_rel32_32
			(ushort)Mnemonic.Jg,// Jg_rel32_64
			(ushort)Mnemonic.Seto,// Seto_rm8
			(ushort)Mnemonic.Setno,// Setno_rm8
			(ushort)Mnemonic.Setb,// Setb_rm8
			(ushort)Mnemonic.Setae,// Setae_rm8
			(ushort)Mnemonic.Sete,// Sete_rm8
			(ushort)Mnemonic.Setne,// Setne_rm8
			(ushort)Mnemonic.Setbe,// Setbe_rm8
			(ushort)Mnemonic.Seta,// Seta_rm8
			(ushort)Mnemonic.Sets,// Sets_rm8
			(ushort)Mnemonic.Setns,// Setns_rm8
			(ushort)Mnemonic.Setp,// Setp_rm8
			(ushort)Mnemonic.Setnp,// Setnp_rm8
			(ushort)Mnemonic.Setl,// Setl_rm8
			(ushort)Mnemonic.Setge,// Setge_rm8
			(ushort)Mnemonic.Setle,// Setle_rm8
			(ushort)Mnemonic.Setg,// Setg_rm8
			(ushort)Mnemonic.Kmovw,// VEX_Kmovw_k_km16
			(ushort)Mnemonic.Kmovq,// VEX_Kmovq_k_km64
			(ushort)Mnemonic.Kmovb,// VEX_Kmovb_k_km8
			(ushort)Mnemonic.Kmovd,// VEX_Kmovd_k_km32
			(ushort)Mnemonic.Kmovw,// VEX_Kmovw_m16_k
			(ushort)Mnemonic.Kmovq,// VEX_Kmovq_m64_k
			(ushort)Mnemonic.Kmovb,// VEX_Kmovb_m8_k
			(ushort)Mnemonic.Kmovd,// VEX_Kmovd_m32_k
			(ushort)Mnemonic.Kmovw,// VEX_Kmovw_k_r32
			(ushort)Mnemonic.Kmovb,// VEX_Kmovb_k_r32
			(ushort)Mnemonic.Kmovd,// VEX_Kmovd_k_r32
			(ushort)Mnemonic.Kmovq,// VEX_Kmovq_k_r64
			(ushort)Mnemonic.Kmovw,// VEX_Kmovw_r32_k
			(ushort)Mnemonic.Kmovb,// VEX_Kmovb_r32_k
			(ushort)Mnemonic.Kmovd,// VEX_Kmovd_r32_k
			(ushort)Mnemonic.Kmovq,// VEX_Kmovq_r64_k
			(ushort)Mnemonic.Kortestw,// VEX_Kortestw_k_k
			(ushort)Mnemonic.Kortestq,// VEX_Kortestq_k_k
			(ushort)Mnemonic.Kortestb,// VEX_Kortestb_k_k
			(ushort)Mnemonic.Kortestd,// VEX_Kortestd_k_k
			(ushort)Mnemonic.Ktestw,// VEX_Ktestw_k_k
			(ushort)Mnemonic.Ktestq,// VEX_Ktestq_k_k
			(ushort)Mnemonic.Ktestb,// VEX_Ktestb_k_k
			(ushort)Mnemonic.Ktestd,// VEX_Ktestd_k_k
			(ushort)Mnemonic.Push,// Pushw_FS
			(ushort)Mnemonic.Push,// Pushd_FS
			(ushort)Mnemonic.Push,// Pushq_FS
			(ushort)Mnemonic.Pop,// Popw_FS
			(ushort)Mnemonic.Pop,// Popd_FS
			(ushort)Mnemonic.Pop,// Popq_FS
			(ushort)Mnemonic.Cpuid,// Cpuid
			(ushort)Mnemonic.Bt,// Bt_rm16_r16
			(ushort)Mnemonic.Bt,// Bt_rm32_r32
			(ushort)Mnemonic.Bt,// Bt_rm64_r64
			(ushort)Mnemonic.Shld,// Shld_rm16_r16_imm8
			(ushort)Mnemonic.Shld,// Shld_rm32_r32_imm8
			(ushort)Mnemonic.Shld,// Shld_rm64_r64_imm8
			(ushort)Mnemonic.Shld,// Shld_rm16_r16_CL
			(ushort)Mnemonic.Shld,// Shld_rm32_r32_CL
			(ushort)Mnemonic.Shld,// Shld_rm64_r64_CL
			(ushort)Mnemonic.Montmul,// Montmul_16
			(ushort)Mnemonic.Montmul,// Montmul_32
			(ushort)Mnemonic.Montmul,// Montmul_64
			(ushort)Mnemonic.Xsha1,// Xsha1_16
			(ushort)Mnemonic.Xsha1,// Xsha1_32
			(ushort)Mnemonic.Xsha1,// Xsha1_64
			(ushort)Mnemonic.Xsha256,// Xsha256_16
			(ushort)Mnemonic.Xsha256,// Xsha256_32
			(ushort)Mnemonic.Xsha256,// Xsha256_64
			(ushort)Mnemonic.Xbts,// Xbts_r16_rm16
			(ushort)Mnemonic.Xbts,// Xbts_r32_rm32
			(ushort)Mnemonic.Xstore,// Xstore_16
			(ushort)Mnemonic.Xstore,// Xstore_32
			(ushort)Mnemonic.Xstore,// Xstore_64
			(ushort)Mnemonic.Xcryptecb,// XcryptEcb_16
			(ushort)Mnemonic.Xcryptecb,// XcryptEcb_32
			(ushort)Mnemonic.Xcryptecb,// XcryptEcb_64
			(ushort)Mnemonic.Xcryptcbc,// XcryptCbc_16
			(ushort)Mnemonic.Xcryptcbc,// XcryptCbc_32
			(ushort)Mnemonic.Xcryptcbc,// XcryptCbc_64
			(ushort)Mnemonic.Xcryptctr,// XcryptCtr_16
			(ushort)Mnemonic.Xcryptctr,// XcryptCtr_32
			(ushort)Mnemonic.Xcryptctr,// XcryptCtr_64
			(ushort)Mnemonic.Xcryptcfb,// XcryptCfb_16
			(ushort)Mnemonic.Xcryptcfb,// XcryptCfb_32
			(ushort)Mnemonic.Xcryptcfb,// XcryptCfb_64
			(ushort)Mnemonic.Xcryptofb,// XcryptOfb_16
			(ushort)Mnemonic.Xcryptofb,// XcryptOfb_32
			(ushort)Mnemonic.Xcryptofb,// XcryptOfb_64
			(ushort)Mnemonic.Ibts,// Ibts_rm16_r16
			(ushort)Mnemonic.Ibts,// Ibts_rm32_r32
			(ushort)Mnemonic.Cmpxchg,// Cmpxchg486_rm8_r8
			(ushort)Mnemonic.Cmpxchg,// Cmpxchg486_rm16_r16
			(ushort)Mnemonic.Cmpxchg,// Cmpxchg486_rm32_r32
			(ushort)Mnemonic.Push,// Pushw_GS
			(ushort)Mnemonic.Push,// Pushd_GS
			(ushort)Mnemonic.Push,// Pushq_GS
			(ushort)Mnemonic.Pop,// Popw_GS
			(ushort)Mnemonic.Pop,// Popd_GS
			(ushort)Mnemonic.Pop,// Popq_GS
			(ushort)Mnemonic.Rsm,// Rsm
			(ushort)Mnemonic.Bts,// Bts_rm16_r16
			(ushort)Mnemonic.Bts,// Bts_rm32_r32
			(ushort)Mnemonic.Bts,// Bts_rm64_r64
			(ushort)Mnemonic.Shrd,// Shrd_rm16_r16_imm8
			(ushort)Mnemonic.Shrd,// Shrd_rm32_r32_imm8
			(ushort)Mnemonic.Shrd,// Shrd_rm64_r64_imm8
			(ushort)Mnemonic.Shrd,// Shrd_rm16_r16_CL
			(ushort)Mnemonic.Shrd,// Shrd_rm32_r32_CL
			(ushort)Mnemonic.Shrd,// Shrd_rm64_r64_CL
			(ushort)Mnemonic.Fxsave,// Fxsave_m512byte
			(ushort)Mnemonic.Fxsave64,// Fxsave64_m512byte
			(ushort)Mnemonic.Rdfsbase,// Rdfsbase_r32
			(ushort)Mnemonic.Rdfsbase,// Rdfsbase_r64
			(ushort)Mnemonic.Fxrstor,// Fxrstor_m512byte
			(ushort)Mnemonic.Fxrstor64,// Fxrstor64_m512byte
			(ushort)Mnemonic.Rdgsbase,// Rdgsbase_r32
			(ushort)Mnemonic.Rdgsbase,// Rdgsbase_r64
			(ushort)Mnemonic.Ldmxcsr,// Ldmxcsr_m32
			(ushort)Mnemonic.Wrfsbase,// Wrfsbase_r32
			(ushort)Mnemonic.Wrfsbase,// Wrfsbase_r64
			(ushort)Mnemonic.Vldmxcsr,// VEX_Vldmxcsr_m32
			(ushort)Mnemonic.Stmxcsr,// Stmxcsr_m32
			(ushort)Mnemonic.Wrgsbase,// Wrgsbase_r32
			(ushort)Mnemonic.Wrgsbase,// Wrgsbase_r64
			(ushort)Mnemonic.Vstmxcsr,// VEX_Vstmxcsr_m32
			(ushort)Mnemonic.Xsave,// Xsave_mem
			(ushort)Mnemonic.Xsave64,// Xsave64_mem
			(ushort)Mnemonic.Ptwrite,// Ptwrite_rm32
			(ushort)Mnemonic.Ptwrite,// Ptwrite_rm64
			(ushort)Mnemonic.Xrstor,// Xrstor_mem
			(ushort)Mnemonic.Xrstor64,// Xrstor64_mem
			(ushort)Mnemonic.Incsspd,// Incsspd_r32
			(ushort)Mnemonic.Incsspq,// Incsspq_r64
			(ushort)Mnemonic.Xsaveopt,// Xsaveopt_mem
			(ushort)Mnemonic.Xsaveopt64,// Xsaveopt64_mem
			(ushort)Mnemonic.Clwb,// Clwb_m8
			(ushort)Mnemonic.Tpause,// Tpause_r32
			(ushort)Mnemonic.Tpause,// Tpause_r64
			(ushort)Mnemonic.Clrssbsy,// Clrssbsy_m64
			(ushort)Mnemonic.Umonitor,// Umonitor_r16
			(ushort)Mnemonic.Umonitor,// Umonitor_r32
			(ushort)Mnemonic.Umonitor,// Umonitor_r64
			(ushort)Mnemonic.Umwait,// Umwait_r32
			(ushort)Mnemonic.Umwait,// Umwait_r64
			(ushort)Mnemonic.Clflush,// Clflush_m8
			(ushort)Mnemonic.Clflushopt,// Clflushopt_m8
			(ushort)Mnemonic.Lfence,// Lfence
			(ushort)Mnemonic.Lfence,// Lfence_E9
			(ushort)Mnemonic.Lfence,// Lfence_EA
			(ushort)Mnemonic.Lfence,// Lfence_EB
			(ushort)Mnemonic.Lfence,// Lfence_EC
			(ushort)Mnemonic.Lfence,// Lfence_ED
			(ushort)Mnemonic.Lfence,// Lfence_EE
			(ushort)Mnemonic.Lfence,// Lfence_EF
			(ushort)Mnemonic.Mfence,// Mfence
			(ushort)Mnemonic.Mfence,// Mfence_F1
			(ushort)Mnemonic.Mfence,// Mfence_F2
			(ushort)Mnemonic.Mfence,// Mfence_F3
			(ushort)Mnemonic.Mfence,// Mfence_F4
			(ushort)Mnemonic.Mfence,// Mfence_F5
			(ushort)Mnemonic.Mfence,// Mfence_F6
			(ushort)Mnemonic.Mfence,// Mfence_F7
			(ushort)Mnemonic.Sfence,// Sfence
			(ushort)Mnemonic.Sfence,// Sfence_F9
			(ushort)Mnemonic.Sfence,// Sfence_FA
			(ushort)Mnemonic.Sfence,// Sfence_FB
			(ushort)Mnemonic.Sfence,// Sfence_FC
			(ushort)Mnemonic.Sfence,// Sfence_FD
			(ushort)Mnemonic.Sfence,// Sfence_FE
			(ushort)Mnemonic.Sfence,// Sfence_FF
			(ushort)Mnemonic.Pcommit,// Pcommit
			(ushort)Mnemonic.Imul,// Imul_r16_rm16
			(ushort)Mnemonic.Imul,// Imul_r32_rm32
			(ushort)Mnemonic.Imul,// Imul_r64_rm64
			(ushort)Mnemonic.Cmpxchg,// Cmpxchg_rm8_r8
			(ushort)Mnemonic.Cmpxchg,// Cmpxchg_rm16_r16
			(ushort)Mnemonic.Cmpxchg,// Cmpxchg_rm32_r32
			(ushort)Mnemonic.Cmpxchg,// Cmpxchg_rm64_r64
			(ushort)Mnemonic.Lss,// Lss_r16_m1616
			(ushort)Mnemonic.Lss,// Lss_r32_m1632
			(ushort)Mnemonic.Lss,// Lss_r64_m1664
			(ushort)Mnemonic.Btr,// Btr_rm16_r16
			(ushort)Mnemonic.Btr,// Btr_rm32_r32
			(ushort)Mnemonic.Btr,// Btr_rm64_r64
			(ushort)Mnemonic.Lfs,// Lfs_r16_m1616
			(ushort)Mnemonic.Lfs,// Lfs_r32_m1632
			(ushort)Mnemonic.Lfs,// Lfs_r64_m1664
			(ushort)Mnemonic.Lgs,// Lgs_r16_m1616
			(ushort)Mnemonic.Lgs,// Lgs_r32_m1632
			(ushort)Mnemonic.Lgs,// Lgs_r64_m1664
			(ushort)Mnemonic.Movzx,// Movzx_r16_rm8
			(ushort)Mnemonic.Movzx,// Movzx_r32_rm8
			(ushort)Mnemonic.Movzx,// Movzx_r64_rm8
			(ushort)Mnemonic.Movzx,// Movzx_r16_rm16
			(ushort)Mnemonic.Movzx,// Movzx_r32_rm16
			(ushort)Mnemonic.Movzx,// Movzx_r64_rm16
			(ushort)Mnemonic.Jmpe,// Jmpe_disp16
			(ushort)Mnemonic.Jmpe,// Jmpe_disp32
			(ushort)Mnemonic.Popcnt,// Popcnt_r16_rm16
			(ushort)Mnemonic.Popcnt,// Popcnt_r32_rm32
			(ushort)Mnemonic.Popcnt,// Popcnt_r64_rm64
			(ushort)Mnemonic.Ud1,// Ud1_r16_rm16
			(ushort)Mnemonic.Ud1,// Ud1_r32_rm32
			(ushort)Mnemonic.Ud1,// Ud1_r64_rm64
			(ushort)Mnemonic.Bt,// Bt_rm16_imm8
			(ushort)Mnemonic.Bt,// Bt_rm32_imm8
			(ushort)Mnemonic.Bt,// Bt_rm64_imm8
			(ushort)Mnemonic.Bts,// Bts_rm16_imm8
			(ushort)Mnemonic.Bts,// Bts_rm32_imm8
			(ushort)Mnemonic.Bts,// Bts_rm64_imm8
			(ushort)Mnemonic.Btr,// Btr_rm16_imm8
			(ushort)Mnemonic.Btr,// Btr_rm32_imm8
			(ushort)Mnemonic.Btr,// Btr_rm64_imm8
			(ushort)Mnemonic.Btc,// Btc_rm16_imm8
			(ushort)Mnemonic.Btc,// Btc_rm32_imm8
			(ushort)Mnemonic.Btc,// Btc_rm64_imm8
			(ushort)Mnemonic.Btc,// Btc_rm16_r16
			(ushort)Mnemonic.Btc,// Btc_rm32_r32
			(ushort)Mnemonic.Btc,// Btc_rm64_r64
			(ushort)Mnemonic.Bsf,// Bsf_r16_rm16
			(ushort)Mnemonic.Bsf,// Bsf_r32_rm32
			(ushort)Mnemonic.Bsf,// Bsf_r64_rm64
			(ushort)Mnemonic.Tzcnt,// Tzcnt_r16_rm16
			(ushort)Mnemonic.Tzcnt,// Tzcnt_r32_rm32
			(ushort)Mnemonic.Tzcnt,// Tzcnt_r64_rm64
			(ushort)Mnemonic.Bsr,// Bsr_r16_rm16
			(ushort)Mnemonic.Bsr,// Bsr_r32_rm32
			(ushort)Mnemonic.Bsr,// Bsr_r64_rm64
			(ushort)Mnemonic.Lzcnt,// Lzcnt_r16_rm16
			(ushort)Mnemonic.Lzcnt,// Lzcnt_r32_rm32
			(ushort)Mnemonic.Lzcnt,// Lzcnt_r64_rm64
			(ushort)Mnemonic.Movsx,// Movsx_r16_rm8
			(ushort)Mnemonic.Movsx,// Movsx_r32_rm8
			(ushort)Mnemonic.Movsx,// Movsx_r64_rm8
			(ushort)Mnemonic.Movsx,// Movsx_r16_rm16
			(ushort)Mnemonic.Movsx,// Movsx_r32_rm16
			(ushort)Mnemonic.Movsx,// Movsx_r64_rm16
			(ushort)Mnemonic.Xadd,// Xadd_rm8_r8
			(ushort)Mnemonic.Xadd,// Xadd_rm16_r16
			(ushort)Mnemonic.Xadd,// Xadd_rm32_r32
			(ushort)Mnemonic.Xadd,// Xadd_rm64_r64
			(ushort)Mnemonic.Cmpps,// Cmpps_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vcmpps,// VEX_Vcmpps_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vcmpps,// VEX_Vcmpps_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vcmpps,// EVEX_Vcmpps_k_k1_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vcmpps,// EVEX_Vcmpps_k_k1_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vcmpps,// EVEX_Vcmpps_k_k1_zmm_zmmm512b32_imm8_sae
			(ushort)Mnemonic.Cmppd,// Cmppd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vcmppd,// VEX_Vcmppd_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vcmppd,// VEX_Vcmppd_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vcmppd,// EVEX_Vcmppd_k_k1_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vcmppd,// EVEX_Vcmppd_k_k1_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vcmppd,// EVEX_Vcmppd_k_k1_zmm_zmmm512b64_imm8_sae
			(ushort)Mnemonic.Cmpss,// Cmpss_xmm_xmmm32_imm8
			(ushort)Mnemonic.Vcmpss,// VEX_Vcmpss_xmm_xmm_xmmm32_imm8
			(ushort)Mnemonic.Vcmpss,// EVEX_Vcmpss_k_k1_xmm_xmmm32_imm8_sae
			(ushort)Mnemonic.Cmpsd,// Cmpsd_xmm_xmmm64_imm8
			(ushort)Mnemonic.Vcmpsd,// VEX_Vcmpsd_xmm_xmm_xmmm64_imm8
			(ushort)Mnemonic.Vcmpsd,// EVEX_Vcmpsd_k_k1_xmm_xmmm64_imm8_sae
			(ushort)Mnemonic.Movnti,// Movnti_m32_r32
			(ushort)Mnemonic.Movnti,// Movnti_m64_r64
			(ushort)Mnemonic.Pinsrw,// Pinsrw_mm_r32m16_imm8
			(ushort)Mnemonic.Pinsrw,// Pinsrw_mm_r64m16_imm8
			(ushort)Mnemonic.Pinsrw,// Pinsrw_xmm_r32m16_imm8
			(ushort)Mnemonic.Pinsrw,// Pinsrw_xmm_r64m16_imm8
			(ushort)Mnemonic.Vpinsrw,// VEX_Vpinsrw_xmm_xmm_r32m16_imm8
			(ushort)Mnemonic.Vpinsrw,// VEX_Vpinsrw_xmm_xmm_r64m16_imm8
			(ushort)Mnemonic.Vpinsrw,// EVEX_Vpinsrw_xmm_xmm_r32m16_imm8
			(ushort)Mnemonic.Vpinsrw,// EVEX_Vpinsrw_xmm_xmm_r64m16_imm8
			(ushort)Mnemonic.Pextrw,// Pextrw_r32_mm_imm8
			(ushort)Mnemonic.Pextrw,// Pextrw_r64_mm_imm8
			(ushort)Mnemonic.Pextrw,// Pextrw_r32_xmm_imm8
			(ushort)Mnemonic.Pextrw,// Pextrw_r64_xmm_imm8
			(ushort)Mnemonic.Vpextrw,// VEX_Vpextrw_r32_xmm_imm8
			(ushort)Mnemonic.Vpextrw,// VEX_Vpextrw_r64_xmm_imm8
			(ushort)Mnemonic.Vpextrw,// EVEX_Vpextrw_r32_xmm_imm8
			(ushort)Mnemonic.Vpextrw,// EVEX_Vpextrw_r64_xmm_imm8
			(ushort)Mnemonic.Shufps,// Shufps_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vshufps,// VEX_Vshufps_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vshufps,// VEX_Vshufps_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vshufps,// EVEX_Vshufps_xmm_k1z_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vshufps,// EVEX_Vshufps_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vshufps,// EVEX_Vshufps_zmm_k1z_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Shufpd,// Shufpd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vshufpd,// VEX_Vshufpd_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vshufpd,// VEX_Vshufpd_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vshufpd,// EVEX_Vshufpd_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vshufpd,// EVEX_Vshufpd_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vshufpd,// EVEX_Vshufpd_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Cmpxchg8b,// Cmpxchg8b_m64
			(ushort)Mnemonic.Cmpxchg16b,// Cmpxchg16b_m128
			(ushort)Mnemonic.Xrstors,// Xrstors_mem
			(ushort)Mnemonic.Xrstors64,// Xrstors64_mem
			(ushort)Mnemonic.Xsavec,// Xsavec_mem
			(ushort)Mnemonic.Xsavec64,// Xsavec64_mem
			(ushort)Mnemonic.Xsaves,// Xsaves_mem
			(ushort)Mnemonic.Xsaves64,// Xsaves64_mem
			(ushort)Mnemonic.Vmptrld,// Vmptrld_m64
			(ushort)Mnemonic.Vmclear,// Vmclear_m64
			(ushort)Mnemonic.Vmxon,// Vmxon_m64
			(ushort)Mnemonic.Rdrand,// Rdrand_r16
			(ushort)Mnemonic.Rdrand,// Rdrand_r32
			(ushort)Mnemonic.Rdrand,// Rdrand_r64
			(ushort)Mnemonic.Vmptrst,// Vmptrst_m64
			(ushort)Mnemonic.Rdseed,// Rdseed_r16
			(ushort)Mnemonic.Rdseed,// Rdseed_r32
			(ushort)Mnemonic.Rdseed,// Rdseed_r64
			(ushort)Mnemonic.Rdpid,// Rdpid_r32
			(ushort)Mnemonic.Rdpid,// Rdpid_r64
			(ushort)Mnemonic.Bswap,// Bswap_r16
			(ushort)Mnemonic.Bswap,// Bswap_r32
			(ushort)Mnemonic.Bswap,// Bswap_r64
			(ushort)Mnemonic.Addsubpd,// Addsubpd_xmm_xmmm128
			(ushort)Mnemonic.Vaddsubpd,// VEX_Vaddsubpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaddsubpd,// VEX_Vaddsubpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Addsubps,// Addsubps_xmm_xmmm128
			(ushort)Mnemonic.Vaddsubps,// VEX_Vaddsubps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaddsubps,// VEX_Vaddsubps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Psrlw,// Psrlw_mm_mmm64
			(ushort)Mnemonic.Psrlw,// Psrlw_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlw,// VEX_Vpsrlw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlw,// VEX_Vpsrlw_ymm_ymm_xmmm128
			(ushort)Mnemonic.Vpsrlw,// EVEX_Vpsrlw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlw,// EVEX_Vpsrlw_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpsrlw,// EVEX_Vpsrlw_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Psrld,// Psrld_mm_mmm64
			(ushort)Mnemonic.Psrld,// Psrld_xmm_xmmm128
			(ushort)Mnemonic.Vpsrld,// VEX_Vpsrld_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsrld,// VEX_Vpsrld_ymm_ymm_xmmm128
			(ushort)Mnemonic.Vpsrld,// EVEX_Vpsrld_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsrld,// EVEX_Vpsrld_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpsrld,// EVEX_Vpsrld_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Psrlq,// Psrlq_mm_mmm64
			(ushort)Mnemonic.Psrlq,// Psrlq_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlq,// VEX_Vpsrlq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlq,// VEX_Vpsrlq_ymm_ymm_xmmm128
			(ushort)Mnemonic.Vpsrlq,// EVEX_Vpsrlq_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlq,// EVEX_Vpsrlq_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpsrlq,// EVEX_Vpsrlq_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Paddq,// Paddq_mm_mmm64
			(ushort)Mnemonic.Paddq,// Paddq_xmm_xmmm128
			(ushort)Mnemonic.Vpaddq,// VEX_Vpaddq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpaddq,// VEX_Vpaddq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpaddq,// EVEX_Vpaddq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpaddq,// EVEX_Vpaddq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpaddq,// EVEX_Vpaddq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Pmullw,// Pmullw_mm_mmm64
			(ushort)Mnemonic.Pmullw,// Pmullw_xmm_xmmm128
			(ushort)Mnemonic.Vpmullw,// VEX_Vpmullw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmullw,// VEX_Vpmullw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmullw,// EVEX_Vpmullw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmullw,// EVEX_Vpmullw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmullw,// EVEX_Vpmullw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Movq,// Movq_xmmm64_xmm
			(ushort)Mnemonic.Vmovq,// VEX_Vmovq_xmmm64_xmm
			(ushort)Mnemonic.Vmovq,// EVEX_Vmovq_xmmm64_xmm
			(ushort)Mnemonic.Movq2dq,// Movq2dq_xmm_mm
			(ushort)Mnemonic.Movdq2q,// Movdq2q_mm_xmm
			(ushort)Mnemonic.Pmovmskb,// Pmovmskb_r32_mm
			(ushort)Mnemonic.Pmovmskb,// Pmovmskb_r64_mm
			(ushort)Mnemonic.Pmovmskb,// Pmovmskb_r32_xmm
			(ushort)Mnemonic.Pmovmskb,// Pmovmskb_r64_xmm
			(ushort)Mnemonic.Vpmovmskb,// VEX_Vpmovmskb_r32_xmm
			(ushort)Mnemonic.Vpmovmskb,// VEX_Vpmovmskb_r64_xmm
			(ushort)Mnemonic.Vpmovmskb,// VEX_Vpmovmskb_r32_ymm
			(ushort)Mnemonic.Vpmovmskb,// VEX_Vpmovmskb_r64_ymm
			(ushort)Mnemonic.Psubusb,// Psubusb_mm_mmm64
			(ushort)Mnemonic.Psubusb,// Psubusb_xmm_xmmm128
			(ushort)Mnemonic.Vpsubusb,// VEX_Vpsubusb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsubusb,// VEX_Vpsubusb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsubusb,// EVEX_Vpsubusb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsubusb,// EVEX_Vpsubusb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsubusb,// EVEX_Vpsubusb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Psubusw,// Psubusw_mm_mmm64
			(ushort)Mnemonic.Psubusw,// Psubusw_xmm_xmmm128
			(ushort)Mnemonic.Vpsubusw,// VEX_Vpsubusw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsubusw,// VEX_Vpsubusw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsubusw,// EVEX_Vpsubusw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsubusw,// EVEX_Vpsubusw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsubusw,// EVEX_Vpsubusw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pminub,// Pminub_mm_mmm64
			(ushort)Mnemonic.Pminub,// Pminub_xmm_xmmm128
			(ushort)Mnemonic.Vpminub,// VEX_Vpminub_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpminub,// VEX_Vpminub_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpminub,// EVEX_Vpminub_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpminub,// EVEX_Vpminub_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpminub,// EVEX_Vpminub_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pand,// Pand_mm_mmm64
			(ushort)Mnemonic.Pand,// Pand_xmm_xmmm128
			(ushort)Mnemonic.Vpand,// VEX_Vpand_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpand,// VEX_Vpand_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpandd,// EVEX_Vpandd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpandd,// EVEX_Vpandd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpandd,// EVEX_Vpandd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpandq,// EVEX_Vpandq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpandq,// EVEX_Vpandq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpandq,// EVEX_Vpandq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Paddusb,// Paddusb_mm_mmm64
			(ushort)Mnemonic.Paddusb,// Paddusb_xmm_xmmm128
			(ushort)Mnemonic.Vpaddusb,// VEX_Vpaddusb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpaddusb,// VEX_Vpaddusb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpaddusb,// EVEX_Vpaddusb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpaddusb,// EVEX_Vpaddusb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpaddusb,// EVEX_Vpaddusb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Paddusw,// Paddusw_mm_mmm64
			(ushort)Mnemonic.Paddusw,// Paddusw_xmm_xmmm128
			(ushort)Mnemonic.Vpaddusw,// VEX_Vpaddusw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpaddusw,// VEX_Vpaddusw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpaddusw,// EVEX_Vpaddusw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpaddusw,// EVEX_Vpaddusw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpaddusw,// EVEX_Vpaddusw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pmaxub,// Pmaxub_mm_mmm64
			(ushort)Mnemonic.Pmaxub,// Pmaxub_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxub,// VEX_Vpmaxub_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxub,// VEX_Vpmaxub_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxub,// EVEX_Vpmaxub_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxub,// EVEX_Vpmaxub_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxub,// EVEX_Vpmaxub_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pandn,// Pandn_mm_mmm64
			(ushort)Mnemonic.Pandn,// Pandn_xmm_xmmm128
			(ushort)Mnemonic.Vpandn,// VEX_Vpandn_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpandn,// VEX_Vpandn_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpandnd,// EVEX_Vpandnd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpandnd,// EVEX_Vpandnd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpandnd,// EVEX_Vpandnd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpandnq,// EVEX_Vpandnq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpandnq,// EVEX_Vpandnq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpandnq,// EVEX_Vpandnq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Pavgb,// Pavgb_mm_mmm64
			(ushort)Mnemonic.Pavgb,// Pavgb_xmm_xmmm128
			(ushort)Mnemonic.Vpavgb,// VEX_Vpavgb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpavgb,// VEX_Vpavgb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpavgb,// EVEX_Vpavgb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpavgb,// EVEX_Vpavgb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpavgb,// EVEX_Vpavgb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Psraw,// Psraw_mm_mmm64
			(ushort)Mnemonic.Psraw,// Psraw_xmm_xmmm128
			(ushort)Mnemonic.Vpsraw,// VEX_Vpsraw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsraw,// VEX_Vpsraw_ymm_ymm_xmmm128
			(ushort)Mnemonic.Vpsraw,// EVEX_Vpsraw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsraw,// EVEX_Vpsraw_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpsraw,// EVEX_Vpsraw_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Psrad,// Psrad_mm_mmm64
			(ushort)Mnemonic.Psrad,// Psrad_xmm_xmmm128
			(ushort)Mnemonic.Vpsrad,// VEX_Vpsrad_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsrad,// VEX_Vpsrad_ymm_ymm_xmmm128
			(ushort)Mnemonic.Vpsrad,// EVEX_Vpsrad_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsrad,// EVEX_Vpsrad_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpsrad,// EVEX_Vpsrad_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Vpsraq,// EVEX_Vpsraq_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsraq,// EVEX_Vpsraq_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpsraq,// EVEX_Vpsraq_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Pavgw,// Pavgw_mm_mmm64
			(ushort)Mnemonic.Pavgw,// Pavgw_xmm_xmmm128
			(ushort)Mnemonic.Vpavgw,// VEX_Vpavgw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpavgw,// VEX_Vpavgw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpavgw,// EVEX_Vpavgw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpavgw,// EVEX_Vpavgw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpavgw,// EVEX_Vpavgw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pmulhuw,// Pmulhuw_mm_mmm64
			(ushort)Mnemonic.Pmulhuw,// Pmulhuw_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhuw,// VEX_Vpmulhuw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhuw,// VEX_Vpmulhuw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmulhuw,// EVEX_Vpmulhuw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhuw,// EVEX_Vpmulhuw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmulhuw,// EVEX_Vpmulhuw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pmulhw,// Pmulhw_mm_mmm64
			(ushort)Mnemonic.Pmulhw,// Pmulhw_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhw,// VEX_Vpmulhw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhw,// VEX_Vpmulhw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmulhw,// EVEX_Vpmulhw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhw,// EVEX_Vpmulhw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmulhw,// EVEX_Vpmulhw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Cvttpd2dq,// Cvttpd2dq_xmm_xmmm128
			(ushort)Mnemonic.Vcvttpd2dq,// VEX_Vcvttpd2dq_xmm_xmmm128
			(ushort)Mnemonic.Vcvttpd2dq,// VEX_Vcvttpd2dq_xmm_ymmm256
			(ushort)Mnemonic.Vcvttpd2dq,// EVEX_Vcvttpd2dq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvttpd2dq,// EVEX_Vcvttpd2dq_xmm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvttpd2dq,// EVEX_Vcvttpd2dq_ymm_k1z_zmmm512b64_sae
			(ushort)Mnemonic.Cvtdq2pd,// Cvtdq2pd_xmm_xmmm64
			(ushort)Mnemonic.Vcvtdq2pd,// VEX_Vcvtdq2pd_xmm_xmmm64
			(ushort)Mnemonic.Vcvtdq2pd,// VEX_Vcvtdq2pd_ymm_xmmm128
			(ushort)Mnemonic.Vcvtdq2pd,// EVEX_Vcvtdq2pd_xmm_k1z_xmmm64b32
			(ushort)Mnemonic.Vcvtdq2pd,// EVEX_Vcvtdq2pd_ymm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtdq2pd,// EVEX_Vcvtdq2pd_zmm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvtqq2pd,// EVEX_Vcvtqq2pd_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtqq2pd,// EVEX_Vcvtqq2pd_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtqq2pd,// EVEX_Vcvtqq2pd_zmm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Cvtpd2dq,// Cvtpd2dq_xmm_xmmm128
			(ushort)Mnemonic.Vcvtpd2dq,// VEX_Vcvtpd2dq_xmm_xmmm128
			(ushort)Mnemonic.Vcvtpd2dq,// VEX_Vcvtpd2dq_xmm_ymmm256
			(ushort)Mnemonic.Vcvtpd2dq,// EVEX_Vcvtpd2dq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vcvtpd2dq,// EVEX_Vcvtpd2dq_xmm_k1z_ymmm256b64
			(ushort)Mnemonic.Vcvtpd2dq,// EVEX_Vcvtpd2dq_ymm_k1z_zmmm512b64_er
			(ushort)Mnemonic.Movntq,// Movntq_m64_mm
			(ushort)Mnemonic.Movntdq,// Movntdq_m128_xmm
			(ushort)Mnemonic.Vmovntdq,// VEX_Vmovntdq_m128_xmm
			(ushort)Mnemonic.Vmovntdq,// VEX_Vmovntdq_m256_ymm
			(ushort)Mnemonic.Vmovntdq,// EVEX_Vmovntdq_m128_xmm
			(ushort)Mnemonic.Vmovntdq,// EVEX_Vmovntdq_m256_ymm
			(ushort)Mnemonic.Vmovntdq,// EVEX_Vmovntdq_m512_zmm
			(ushort)Mnemonic.Psubsb,// Psubsb_mm_mmm64
			(ushort)Mnemonic.Psubsb,// Psubsb_xmm_xmmm128
			(ushort)Mnemonic.Vpsubsb,// VEX_Vpsubsb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsubsb,// VEX_Vpsubsb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsubsb,// EVEX_Vpsubsb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsubsb,// EVEX_Vpsubsb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsubsb,// EVEX_Vpsubsb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Psubsw,// Psubsw_mm_mmm64
			(ushort)Mnemonic.Psubsw,// Psubsw_xmm_xmmm128
			(ushort)Mnemonic.Vpsubsw,// VEX_Vpsubsw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsubsw,// VEX_Vpsubsw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsubsw,// EVEX_Vpsubsw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsubsw,// EVEX_Vpsubsw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsubsw,// EVEX_Vpsubsw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pminsw,// Pminsw_mm_mmm64
			(ushort)Mnemonic.Pminsw,// Pminsw_xmm_xmmm128
			(ushort)Mnemonic.Vpminsw,// VEX_Vpminsw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpminsw,// VEX_Vpminsw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpminsw,// EVEX_Vpminsw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpminsw,// EVEX_Vpminsw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpminsw,// EVEX_Vpminsw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Por,// Por_mm_mmm64
			(ushort)Mnemonic.Por,// Por_xmm_xmmm128
			(ushort)Mnemonic.Vpor,// VEX_Vpor_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpor,// VEX_Vpor_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpord,// EVEX_Vpord_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpord,// EVEX_Vpord_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpord,// EVEX_Vpord_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vporq,// EVEX_Vporq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vporq,// EVEX_Vporq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vporq,// EVEX_Vporq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Paddsb,// Paddsb_mm_mmm64
			(ushort)Mnemonic.Paddsb,// Paddsb_xmm_xmmm128
			(ushort)Mnemonic.Vpaddsb,// VEX_Vpaddsb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpaddsb,// VEX_Vpaddsb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpaddsb,// EVEX_Vpaddsb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpaddsb,// EVEX_Vpaddsb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpaddsb,// EVEX_Vpaddsb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Paddsw,// Paddsw_mm_mmm64
			(ushort)Mnemonic.Paddsw,// Paddsw_xmm_xmmm128
			(ushort)Mnemonic.Vpaddsw,// VEX_Vpaddsw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpaddsw,// VEX_Vpaddsw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpaddsw,// EVEX_Vpaddsw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpaddsw,// EVEX_Vpaddsw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpaddsw,// EVEX_Vpaddsw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pmaxsw,// Pmaxsw_mm_mmm64
			(ushort)Mnemonic.Pmaxsw,// Pmaxsw_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxsw,// VEX_Vpmaxsw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxsw,// VEX_Vpmaxsw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxsw,// EVEX_Vpmaxsw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxsw,// EVEX_Vpmaxsw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxsw,// EVEX_Vpmaxsw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pxor,// Pxor_mm_mmm64
			(ushort)Mnemonic.Pxor,// Pxor_xmm_xmmm128
			(ushort)Mnemonic.Vpxor,// VEX_Vpxor_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpxor,// VEX_Vpxor_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpxord,// EVEX_Vpxord_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpxord,// EVEX_Vpxord_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpxord,// EVEX_Vpxord_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpxorq,// EVEX_Vpxorq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpxorq,// EVEX_Vpxorq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpxorq,// EVEX_Vpxorq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Lddqu,// Lddqu_xmm_m128
			(ushort)Mnemonic.Vlddqu,// VEX_Vlddqu_xmm_m128
			(ushort)Mnemonic.Vlddqu,// VEX_Vlddqu_ymm_m256
			(ushort)Mnemonic.Psllw,// Psllw_mm_mmm64
			(ushort)Mnemonic.Psllw,// Psllw_xmm_xmmm128
			(ushort)Mnemonic.Vpsllw,// VEX_Vpsllw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsllw,// VEX_Vpsllw_ymm_ymm_xmmm128
			(ushort)Mnemonic.Vpsllw,// EVEX_Vpsllw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsllw,// EVEX_Vpsllw_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpsllw,// EVEX_Vpsllw_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Pslld,// Pslld_mm_mmm64
			(ushort)Mnemonic.Pslld,// Pslld_xmm_xmmm128
			(ushort)Mnemonic.Vpslld,// VEX_Vpslld_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpslld,// VEX_Vpslld_ymm_ymm_xmmm128
			(ushort)Mnemonic.Vpslld,// EVEX_Vpslld_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpslld,// EVEX_Vpslld_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpslld,// EVEX_Vpslld_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Psllq,// Psllq_mm_mmm64
			(ushort)Mnemonic.Psllq,// Psllq_xmm_xmmm128
			(ushort)Mnemonic.Vpsllq,// VEX_Vpsllq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsllq,// VEX_Vpsllq_ymm_ymm_xmmm128
			(ushort)Mnemonic.Vpsllq,// EVEX_Vpsllq_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsllq,// EVEX_Vpsllq_ymm_k1z_ymm_xmmm128
			(ushort)Mnemonic.Vpsllq,// EVEX_Vpsllq_zmm_k1z_zmm_xmmm128
			(ushort)Mnemonic.Pmuludq,// Pmuludq_mm_mmm64
			(ushort)Mnemonic.Pmuludq,// Pmuludq_xmm_xmmm128
			(ushort)Mnemonic.Vpmuludq,// VEX_Vpmuludq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmuludq,// VEX_Vpmuludq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmuludq,// EVEX_Vpmuludq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpmuludq,// EVEX_Vpmuludq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpmuludq,// EVEX_Vpmuludq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Pmaddwd,// Pmaddwd_mm_mmm64
			(ushort)Mnemonic.Pmaddwd,// Pmaddwd_xmm_xmmm128
			(ushort)Mnemonic.Vpmaddwd,// VEX_Vpmaddwd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmaddwd,// VEX_Vpmaddwd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmaddwd,// EVEX_Vpmaddwd_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmaddwd,// EVEX_Vpmaddwd_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmaddwd,// EVEX_Vpmaddwd_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Psadbw,// Psadbw_mm_mmm64
			(ushort)Mnemonic.Psadbw,// Psadbw_xmm_xmmm128
			(ushort)Mnemonic.Vpsadbw,// VEX_Vpsadbw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsadbw,// VEX_Vpsadbw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsadbw,// EVEX_Vpsadbw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsadbw,// EVEX_Vpsadbw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsadbw,// EVEX_Vpsadbw_zmm_zmm_zmmm512
			(ushort)Mnemonic.Maskmovq,// Maskmovq_rDI_mm_mm
			(ushort)Mnemonic.Maskmovdqu,// Maskmovdqu_rDI_xmm_xmm
			(ushort)Mnemonic.Vmaskmovdqu,// VEX_Vmaskmovdqu_rDI_xmm_xmm
			(ushort)Mnemonic.Psubb,// Psubb_mm_mmm64
			(ushort)Mnemonic.Psubb,// Psubb_xmm_xmmm128
			(ushort)Mnemonic.Vpsubb,// VEX_Vpsubb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsubb,// VEX_Vpsubb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsubb,// EVEX_Vpsubb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsubb,// EVEX_Vpsubb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsubb,// EVEX_Vpsubb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Psubw,// Psubw_mm_mmm64
			(ushort)Mnemonic.Psubw,// Psubw_xmm_xmmm128
			(ushort)Mnemonic.Vpsubw,// VEX_Vpsubw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsubw,// VEX_Vpsubw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsubw,// EVEX_Vpsubw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsubw,// EVEX_Vpsubw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsubw,// EVEX_Vpsubw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Psubd,// Psubd_mm_mmm64
			(ushort)Mnemonic.Psubd,// Psubd_xmm_xmmm128
			(ushort)Mnemonic.Vpsubd,// VEX_Vpsubd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsubd,// VEX_Vpsubd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsubd,// EVEX_Vpsubd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpsubd,// EVEX_Vpsubd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpsubd,// EVEX_Vpsubd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Psubq,// Psubq_mm_mmm64
			(ushort)Mnemonic.Psubq,// Psubq_xmm_xmmm128
			(ushort)Mnemonic.Vpsubq,// VEX_Vpsubq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsubq,// VEX_Vpsubq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsubq,// EVEX_Vpsubq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpsubq,// EVEX_Vpsubq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpsubq,// EVEX_Vpsubq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Paddb,// Paddb_mm_mmm64
			(ushort)Mnemonic.Paddb,// Paddb_xmm_xmmm128
			(ushort)Mnemonic.Vpaddb,// VEX_Vpaddb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpaddb,// VEX_Vpaddb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpaddb,// EVEX_Vpaddb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpaddb,// EVEX_Vpaddb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpaddb,// EVEX_Vpaddb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Paddw,// Paddw_mm_mmm64
			(ushort)Mnemonic.Paddw,// Paddw_xmm_xmmm128
			(ushort)Mnemonic.Vpaddw,// VEX_Vpaddw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpaddw,// VEX_Vpaddw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpaddw,// EVEX_Vpaddw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpaddw,// EVEX_Vpaddw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpaddw,// EVEX_Vpaddw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Paddd,// Paddd_mm_mmm64
			(ushort)Mnemonic.Paddd,// Paddd_xmm_xmmm128
			(ushort)Mnemonic.Vpaddd,// VEX_Vpaddd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpaddd,// VEX_Vpaddd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpaddd,// EVEX_Vpaddd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpaddd,// EVEX_Vpaddd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpaddd,// EVEX_Vpaddd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Ud0,// Ud0_r16_rm16
			(ushort)Mnemonic.Ud0,// Ud0_r32_rm32
			(ushort)Mnemonic.Ud0,// Ud0_r64_rm64
			(ushort)Mnemonic.Pshufb,// Pshufb_mm_mmm64
			(ushort)Mnemonic.Pshufb,// Pshufb_xmm_xmmm128
			(ushort)Mnemonic.Vpshufb,// VEX_Vpshufb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshufb,// VEX_Vpshufb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpshufb,// EVEX_Vpshufb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpshufb,// EVEX_Vpshufb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpshufb,// EVEX_Vpshufb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Phaddw,// Phaddw_mm_mmm64
			(ushort)Mnemonic.Phaddw,// Phaddw_xmm_xmmm128
			(ushort)Mnemonic.Vphaddw,// VEX_Vphaddw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vphaddw,// VEX_Vphaddw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Phaddd,// Phaddd_mm_mmm64
			(ushort)Mnemonic.Phaddd,// Phaddd_xmm_xmmm128
			(ushort)Mnemonic.Vphaddd,// VEX_Vphaddd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vphaddd,// VEX_Vphaddd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Phaddsw,// Phaddsw_mm_mmm64
			(ushort)Mnemonic.Phaddsw,// Phaddsw_xmm_xmmm128
			(ushort)Mnemonic.Vphaddsw,// VEX_Vphaddsw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vphaddsw,// VEX_Vphaddsw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Pmaddubsw,// Pmaddubsw_mm_mmm64
			(ushort)Mnemonic.Pmaddubsw,// Pmaddubsw_xmm_xmmm128
			(ushort)Mnemonic.Vpmaddubsw,// VEX_Vpmaddubsw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmaddubsw,// VEX_Vpmaddubsw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmaddubsw,// EVEX_Vpmaddubsw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmaddubsw,// EVEX_Vpmaddubsw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmaddubsw,// EVEX_Vpmaddubsw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Phsubw,// Phsubw_mm_mmm64
			(ushort)Mnemonic.Phsubw,// Phsubw_xmm_xmmm128
			(ushort)Mnemonic.Vphsubw,// VEX_Vphsubw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vphsubw,// VEX_Vphsubw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Phsubd,// Phsubd_mm_mmm64
			(ushort)Mnemonic.Phsubd,// Phsubd_xmm_xmmm128
			(ushort)Mnemonic.Vphsubd,// VEX_Vphsubd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vphsubd,// VEX_Vphsubd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Phsubsw,// Phsubsw_mm_mmm64
			(ushort)Mnemonic.Phsubsw,// Phsubsw_xmm_xmmm128
			(ushort)Mnemonic.Vphsubsw,// VEX_Vphsubsw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vphsubsw,// VEX_Vphsubsw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Psignb,// Psignb_mm_mmm64
			(ushort)Mnemonic.Psignb,// Psignb_xmm_xmmm128
			(ushort)Mnemonic.Vpsignb,// VEX_Vpsignb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsignb,// VEX_Vpsignb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Psignw,// Psignw_mm_mmm64
			(ushort)Mnemonic.Psignw,// Psignw_xmm_xmmm128
			(ushort)Mnemonic.Vpsignw,// VEX_Vpsignw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsignw,// VEX_Vpsignw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Psignd,// Psignd_mm_mmm64
			(ushort)Mnemonic.Psignd,// Psignd_xmm_xmmm128
			(ushort)Mnemonic.Vpsignd,// VEX_Vpsignd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsignd,// VEX_Vpsignd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Pmulhrsw,// Pmulhrsw_mm_mmm64
			(ushort)Mnemonic.Pmulhrsw,// Pmulhrsw_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhrsw,// VEX_Vpmulhrsw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhrsw,// VEX_Vpmulhrsw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmulhrsw,// EVEX_Vpmulhrsw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmulhrsw,// EVEX_Vpmulhrsw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmulhrsw,// EVEX_Vpmulhrsw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpermilps,// VEX_Vpermilps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpermilps,// VEX_Vpermilps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpermilps,// EVEX_Vpermilps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpermilps,// EVEX_Vpermilps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpermilps,// EVEX_Vpermilps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpermilpd,// VEX_Vpermilpd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpermilpd,// VEX_Vpermilpd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpermilpd,// EVEX_Vpermilpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpermilpd,// EVEX_Vpermilpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpermilpd,// EVEX_Vpermilpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vtestps,// VEX_Vtestps_xmm_xmmm128
			(ushort)Mnemonic.Vtestps,// VEX_Vtestps_ymm_ymmm256
			(ushort)Mnemonic.Vtestpd,// VEX_Vtestpd_xmm_xmmm128
			(ushort)Mnemonic.Vtestpd,// VEX_Vtestpd_ymm_ymmm256
			(ushort)Mnemonic.Pblendvb,// Pblendvb_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlvw,// EVEX_Vpsrlvw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlvw,// EVEX_Vpsrlvw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsrlvw,// EVEX_Vpsrlvw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpmovuswb,// EVEX_Vpmovuswb_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovuswb,// EVEX_Vpmovuswb_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovuswb,// EVEX_Vpmovuswb_ymmm256_k1z_zmm
			(ushort)Mnemonic.Vpsravw,// EVEX_Vpsravw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsravw,// EVEX_Vpsravw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsravw,// EVEX_Vpsravw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpmovusdb,// EVEX_Vpmovusdb_xmmm32_k1z_xmm
			(ushort)Mnemonic.Vpmovusdb,// EVEX_Vpmovusdb_xmmm64_k1z_ymm
			(ushort)Mnemonic.Vpmovusdb,// EVEX_Vpmovusdb_xmmm128_k1z_zmm
			(ushort)Mnemonic.Vpsllvw,// EVEX_Vpsllvw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpsllvw,// EVEX_Vpsllvw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpsllvw,// EVEX_Vpsllvw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpmovusqb,// EVEX_Vpmovusqb_xmmm16_k1z_xmm
			(ushort)Mnemonic.Vpmovusqb,// EVEX_Vpmovusqb_xmmm32_k1z_ymm
			(ushort)Mnemonic.Vpmovusqb,// EVEX_Vpmovusqb_xmmm64_k1z_zmm
			(ushort)Mnemonic.Vcvtph2ps,// VEX_Vcvtph2ps_xmm_xmmm64
			(ushort)Mnemonic.Vcvtph2ps,// VEX_Vcvtph2ps_ymm_xmmm128
			(ushort)Mnemonic.Vcvtph2ps,// EVEX_Vcvtph2ps_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vcvtph2ps,// EVEX_Vcvtph2ps_ymm_k1z_xmmm128
			(ushort)Mnemonic.Vcvtph2ps,// EVEX_Vcvtph2ps_zmm_k1z_ymmm256_sae
			(ushort)Mnemonic.Vpmovusdw,// EVEX_Vpmovusdw_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovusdw,// EVEX_Vpmovusdw_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovusdw,// EVEX_Vpmovusdw_ymmm256_k1z_zmm
			(ushort)Mnemonic.Blendvps,// Blendvps_xmm_xmmm128
			(ushort)Mnemonic.Vprorvd,// EVEX_Vprorvd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vprorvd,// EVEX_Vprorvd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vprorvd,// EVEX_Vprorvd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vprorvq,// EVEX_Vprorvq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vprorvq,// EVEX_Vprorvq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vprorvq,// EVEX_Vprorvq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpmovusqw,// EVEX_Vpmovusqw_xmmm32_k1z_xmm
			(ushort)Mnemonic.Vpmovusqw,// EVEX_Vpmovusqw_xmmm64_k1z_ymm
			(ushort)Mnemonic.Vpmovusqw,// EVEX_Vpmovusqw_xmmm128_k1z_zmm
			(ushort)Mnemonic.Blendvpd,// Blendvpd_xmm_xmmm128
			(ushort)Mnemonic.Vprolvd,// EVEX_Vprolvd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vprolvd,// EVEX_Vprolvd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vprolvd,// EVEX_Vprolvd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vprolvq,// EVEX_Vprolvq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vprolvq,// EVEX_Vprolvq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vprolvq,// EVEX_Vprolvq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpmovusqd,// EVEX_Vpmovusqd_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovusqd,// EVEX_Vpmovusqd_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovusqd,// EVEX_Vpmovusqd_ymmm256_k1z_zmm
			(ushort)Mnemonic.Vpermps,// VEX_Vpermps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpermps,// EVEX_Vpermps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpermps,// EVEX_Vpermps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpermpd,// EVEX_Vpermpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpermpd,// EVEX_Vpermpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Ptest,// Ptest_xmm_xmmm128
			(ushort)Mnemonic.Vptest,// VEX_Vptest_xmm_xmmm128
			(ushort)Mnemonic.Vptest,// VEX_Vptest_ymm_ymmm256
			(ushort)Mnemonic.Vbroadcastss,// VEX_Vbroadcastss_xmm_xmmm32
			(ushort)Mnemonic.Vbroadcastss,// VEX_Vbroadcastss_ymm_xmmm32
			(ushort)Mnemonic.Vbroadcastss,// EVEX_Vbroadcastss_xmm_k1z_xmmm32
			(ushort)Mnemonic.Vbroadcastss,// EVEX_Vbroadcastss_ymm_k1z_xmmm32
			(ushort)Mnemonic.Vbroadcastss,// EVEX_Vbroadcastss_zmm_k1z_xmmm32
			(ushort)Mnemonic.Vbroadcastsd,// VEX_Vbroadcastsd_ymm_xmmm64
			(ushort)Mnemonic.Vbroadcastf32x2,// EVEX_Vbroadcastf32x2_ymm_k1z_xmmm64
			(ushort)Mnemonic.Vbroadcastf32x2,// EVEX_Vbroadcastf32x2_zmm_k1z_xmmm64
			(ushort)Mnemonic.Vbroadcastsd,// EVEX_Vbroadcastsd_ymm_k1z_xmmm64
			(ushort)Mnemonic.Vbroadcastsd,// EVEX_Vbroadcastsd_zmm_k1z_xmmm64
			(ushort)Mnemonic.Vbroadcastf128,// VEX_Vbroadcastf128_ymm_m128
			(ushort)Mnemonic.Vbroadcastf32x4,// EVEX_Vbroadcastf32x4_ymm_k1z_m128
			(ushort)Mnemonic.Vbroadcastf32x4,// EVEX_Vbroadcastf32x4_zmm_k1z_m128
			(ushort)Mnemonic.Vbroadcastf64x2,// EVEX_Vbroadcastf64x2_ymm_k1z_m128
			(ushort)Mnemonic.Vbroadcastf64x2,// EVEX_Vbroadcastf64x2_zmm_k1z_m128
			(ushort)Mnemonic.Vbroadcastf32x8,// EVEX_Vbroadcastf32x8_zmm_k1z_m256
			(ushort)Mnemonic.Vbroadcastf64x4,// EVEX_Vbroadcastf64x4_zmm_k1z_m256
			(ushort)Mnemonic.Pabsb,// Pabsb_mm_mmm64
			(ushort)Mnemonic.Pabsb,// Pabsb_xmm_xmmm128
			(ushort)Mnemonic.Vpabsb,// VEX_Vpabsb_xmm_xmmm128
			(ushort)Mnemonic.Vpabsb,// VEX_Vpabsb_ymm_ymmm256
			(ushort)Mnemonic.Vpabsb,// EVEX_Vpabsb_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vpabsb,// EVEX_Vpabsb_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vpabsb,// EVEX_Vpabsb_zmm_k1z_zmmm512
			(ushort)Mnemonic.Pabsw,// Pabsw_mm_mmm64
			(ushort)Mnemonic.Pabsw,// Pabsw_xmm_xmmm128
			(ushort)Mnemonic.Vpabsw,// VEX_Vpabsw_xmm_xmmm128
			(ushort)Mnemonic.Vpabsw,// VEX_Vpabsw_ymm_ymmm256
			(ushort)Mnemonic.Vpabsw,// EVEX_Vpabsw_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vpabsw,// EVEX_Vpabsw_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vpabsw,// EVEX_Vpabsw_zmm_k1z_zmmm512
			(ushort)Mnemonic.Pabsd,// Pabsd_mm_mmm64
			(ushort)Mnemonic.Pabsd,// Pabsd_xmm_xmmm128
			(ushort)Mnemonic.Vpabsd,// VEX_Vpabsd_xmm_xmmm128
			(ushort)Mnemonic.Vpabsd,// VEX_Vpabsd_ymm_ymmm256
			(ushort)Mnemonic.Vpabsd,// EVEX_Vpabsd_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vpabsd,// EVEX_Vpabsd_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vpabsd,// EVEX_Vpabsd_zmm_k1z_zmmm512b32
			(ushort)Mnemonic.Vpabsq,// EVEX_Vpabsq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vpabsq,// EVEX_Vpabsq_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vpabsq,// EVEX_Vpabsq_zmm_k1z_zmmm512b64
			(ushort)Mnemonic.Pmovsxbw,// Pmovsxbw_xmm_xmmm64
			(ushort)Mnemonic.Vpmovsxbw,// VEX_Vpmovsxbw_xmm_xmmm64
			(ushort)Mnemonic.Vpmovsxbw,// VEX_Vpmovsxbw_ymm_xmmm128
			(ushort)Mnemonic.Vpmovsxbw,// EVEX_Vpmovsxbw_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovsxbw,// EVEX_Vpmovsxbw_ymm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovsxbw,// EVEX_Vpmovsxbw_zmm_k1z_ymmm256
			(ushort)Mnemonic.Vpmovswb,// EVEX_Vpmovswb_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovswb,// EVEX_Vpmovswb_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovswb,// EVEX_Vpmovswb_ymmm256_k1z_zmm
			(ushort)Mnemonic.Pmovsxbd,// Pmovsxbd_xmm_xmmm32
			(ushort)Mnemonic.Vpmovsxbd,// VEX_Vpmovsxbd_xmm_xmmm32
			(ushort)Mnemonic.Vpmovsxbd,// VEX_Vpmovsxbd_ymm_xmmm64
			(ushort)Mnemonic.Vpmovsxbd,// EVEX_Vpmovsxbd_xmm_k1z_xmmm32
			(ushort)Mnemonic.Vpmovsxbd,// EVEX_Vpmovsxbd_ymm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovsxbd,// EVEX_Vpmovsxbd_zmm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovsdb,// EVEX_Vpmovsdb_xmmm32_k1z_xmm
			(ushort)Mnemonic.Vpmovsdb,// EVEX_Vpmovsdb_xmmm64_k1z_ymm
			(ushort)Mnemonic.Vpmovsdb,// EVEX_Vpmovsdb_xmmm128_k1z_zmm
			(ushort)Mnemonic.Pmovsxbq,// Pmovsxbq_xmm_xmmm16
			(ushort)Mnemonic.Vpmovsxbq,// VEX_Vpmovsxbq_xmm_xmmm16
			(ushort)Mnemonic.Vpmovsxbq,// VEX_Vpmovsxbq_ymm_xmmm32
			(ushort)Mnemonic.Vpmovsxbq,// EVEX_Vpmovsxbq_xmm_k1z_xmmm16
			(ushort)Mnemonic.Vpmovsxbq,// EVEX_Vpmovsxbq_ymm_k1z_xmmm32
			(ushort)Mnemonic.Vpmovsxbq,// EVEX_Vpmovsxbq_zmm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovsqb,// EVEX_Vpmovsqb_xmmm16_k1z_xmm
			(ushort)Mnemonic.Vpmovsqb,// EVEX_Vpmovsqb_xmmm32_k1z_ymm
			(ushort)Mnemonic.Vpmovsqb,// EVEX_Vpmovsqb_xmmm64_k1z_zmm
			(ushort)Mnemonic.Pmovsxwd,// Pmovsxwd_xmm_xmmm64
			(ushort)Mnemonic.Vpmovsxwd,// VEX_Vpmovsxwd_xmm_xmmm64
			(ushort)Mnemonic.Vpmovsxwd,// VEX_Vpmovsxwd_ymm_xmmm128
			(ushort)Mnemonic.Vpmovsxwd,// EVEX_Vpmovsxwd_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovsxwd,// EVEX_Vpmovsxwd_ymm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovsxwd,// EVEX_Vpmovsxwd_zmm_k1z_ymmm256
			(ushort)Mnemonic.Vpmovsdw,// EVEX_Vpmovsdw_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovsdw,// EVEX_Vpmovsdw_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovsdw,// EVEX_Vpmovsdw_ymmm256_k1z_zmm
			(ushort)Mnemonic.Pmovsxwq,// Pmovsxwq_xmm_xmmm32
			(ushort)Mnemonic.Vpmovsxwq,// VEX_Vpmovsxwq_xmm_xmmm32
			(ushort)Mnemonic.Vpmovsxwq,// VEX_Vpmovsxwq_ymm_xmmm64
			(ushort)Mnemonic.Vpmovsxwq,// EVEX_Vpmovsxwq_xmm_k1z_xmmm32
			(ushort)Mnemonic.Vpmovsxwq,// EVEX_Vpmovsxwq_ymm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovsxwq,// EVEX_Vpmovsxwq_zmm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovsqw,// EVEX_Vpmovsqw_xmmm32_k1z_xmm
			(ushort)Mnemonic.Vpmovsqw,// EVEX_Vpmovsqw_xmmm64_k1z_ymm
			(ushort)Mnemonic.Vpmovsqw,// EVEX_Vpmovsqw_xmmm128_k1z_zmm
			(ushort)Mnemonic.Pmovsxdq,// Pmovsxdq_xmm_xmmm64
			(ushort)Mnemonic.Vpmovsxdq,// VEX_Vpmovsxdq_xmm_xmmm64
			(ushort)Mnemonic.Vpmovsxdq,// VEX_Vpmovsxdq_ymm_xmmm128
			(ushort)Mnemonic.Vpmovsxdq,// EVEX_Vpmovsxdq_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovsxdq,// EVEX_Vpmovsxdq_ymm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovsxdq,// EVEX_Vpmovsxdq_zmm_k1z_ymmm256
			(ushort)Mnemonic.Vpmovsqd,// EVEX_Vpmovsqd_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovsqd,// EVEX_Vpmovsqd_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovsqd,// EVEX_Vpmovsqd_ymmm256_k1z_zmm
			(ushort)Mnemonic.Vptestmb,// EVEX_Vptestmb_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vptestmb,// EVEX_Vptestmb_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vptestmb,// EVEX_Vptestmb_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Vptestmw,// EVEX_Vptestmw_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vptestmw,// EVEX_Vptestmw_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vptestmw,// EVEX_Vptestmw_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Vptestnmb,// EVEX_Vptestnmb_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vptestnmb,// EVEX_Vptestnmb_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vptestnmb,// EVEX_Vptestnmb_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Vptestnmw,// EVEX_Vptestnmw_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vptestnmw,// EVEX_Vptestnmw_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vptestnmw,// EVEX_Vptestnmw_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Vptestmd,// EVEX_Vptestmd_k_k1_xmm_xmmm128b32
			(ushort)Mnemonic.Vptestmd,// EVEX_Vptestmd_k_k1_ymm_ymmm256b32
			(ushort)Mnemonic.Vptestmd,// EVEX_Vptestmd_k_k1_zmm_zmmm512b32
			(ushort)Mnemonic.Vptestmq,// EVEX_Vptestmq_k_k1_xmm_xmmm128b64
			(ushort)Mnemonic.Vptestmq,// EVEX_Vptestmq_k_k1_ymm_ymmm256b64
			(ushort)Mnemonic.Vptestmq,// EVEX_Vptestmq_k_k1_zmm_zmmm512b64
			(ushort)Mnemonic.Vptestnmd,// EVEX_Vptestnmd_k_k1_xmm_xmmm128b32
			(ushort)Mnemonic.Vptestnmd,// EVEX_Vptestnmd_k_k1_ymm_ymmm256b32
			(ushort)Mnemonic.Vptestnmd,// EVEX_Vptestnmd_k_k1_zmm_zmmm512b32
			(ushort)Mnemonic.Vptestnmq,// EVEX_Vptestnmq_k_k1_xmm_xmmm128b64
			(ushort)Mnemonic.Vptestnmq,// EVEX_Vptestnmq_k_k1_ymm_ymmm256b64
			(ushort)Mnemonic.Vptestnmq,// EVEX_Vptestnmq_k_k1_zmm_zmmm512b64
			(ushort)Mnemonic.Pmuldq,// Pmuldq_xmm_xmmm128
			(ushort)Mnemonic.Vpmuldq,// VEX_Vpmuldq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmuldq,// VEX_Vpmuldq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmuldq,// EVEX_Vpmuldq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpmuldq,// EVEX_Vpmuldq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpmuldq,// EVEX_Vpmuldq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpmovm2b,// EVEX_Vpmovm2b_xmm_k
			(ushort)Mnemonic.Vpmovm2b,// EVEX_Vpmovm2b_ymm_k
			(ushort)Mnemonic.Vpmovm2b,// EVEX_Vpmovm2b_zmm_k
			(ushort)Mnemonic.Vpmovm2w,// EVEX_Vpmovm2w_xmm_k
			(ushort)Mnemonic.Vpmovm2w,// EVEX_Vpmovm2w_ymm_k
			(ushort)Mnemonic.Vpmovm2w,// EVEX_Vpmovm2w_zmm_k
			(ushort)Mnemonic.Pcmpeqq,// Pcmpeqq_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqq,// VEX_Vpcmpeqq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpeqq,// VEX_Vpcmpeqq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpeqq,// EVEX_Vpcmpeqq_k_k1_xmm_xmmm128b64
			(ushort)Mnemonic.Vpcmpeqq,// EVEX_Vpcmpeqq_k_k1_ymm_ymmm256b64
			(ushort)Mnemonic.Vpcmpeqq,// EVEX_Vpcmpeqq_k_k1_zmm_zmmm512b64
			(ushort)Mnemonic.Vpmovb2m,// EVEX_Vpmovb2m_k_xmm
			(ushort)Mnemonic.Vpmovb2m,// EVEX_Vpmovb2m_k_ymm
			(ushort)Mnemonic.Vpmovb2m,// EVEX_Vpmovb2m_k_zmm
			(ushort)Mnemonic.Vpmovw2m,// EVEX_Vpmovw2m_k_xmm
			(ushort)Mnemonic.Vpmovw2m,// EVEX_Vpmovw2m_k_ymm
			(ushort)Mnemonic.Vpmovw2m,// EVEX_Vpmovw2m_k_zmm
			(ushort)Mnemonic.Movntdqa,// Movntdqa_xmm_m128
			(ushort)Mnemonic.Vmovntdqa,// VEX_Vmovntdqa_xmm_m128
			(ushort)Mnemonic.Vmovntdqa,// VEX_Vmovntdqa_ymm_m256
			(ushort)Mnemonic.Vmovntdqa,// EVEX_Vmovntdqa_xmm_m128
			(ushort)Mnemonic.Vmovntdqa,// EVEX_Vmovntdqa_ymm_m256
			(ushort)Mnemonic.Vmovntdqa,// EVEX_Vmovntdqa_zmm_m512
			(ushort)Mnemonic.Vpbroadcastmb2q,// EVEX_Vpbroadcastmb2q_xmm_k
			(ushort)Mnemonic.Vpbroadcastmb2q,// EVEX_Vpbroadcastmb2q_ymm_k
			(ushort)Mnemonic.Vpbroadcastmb2q,// EVEX_Vpbroadcastmb2q_zmm_k
			(ushort)Mnemonic.Packusdw,// Packusdw_xmm_xmmm128
			(ushort)Mnemonic.Vpackusdw,// VEX_Vpackusdw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpackusdw,// VEX_Vpackusdw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpackusdw,// EVEX_Vpackusdw_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpackusdw,// EVEX_Vpackusdw_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpackusdw,// EVEX_Vpackusdw_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vmaskmovps,// VEX_Vmaskmovps_xmm_xmm_m128
			(ushort)Mnemonic.Vmaskmovps,// VEX_Vmaskmovps_ymm_ymm_m256
			(ushort)Mnemonic.Vscalefps,// EVEX_Vscalefps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vscalefps,// EVEX_Vscalefps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vscalefps,// EVEX_Vscalefps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vscalefpd,// EVEX_Vscalefpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vscalefpd,// EVEX_Vscalefpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vscalefpd,// EVEX_Vscalefpd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vmaskmovpd,// VEX_Vmaskmovpd_xmm_xmm_m128
			(ushort)Mnemonic.Vmaskmovpd,// VEX_Vmaskmovpd_ymm_ymm_m256
			(ushort)Mnemonic.Vscalefss,// EVEX_Vscalefss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vscalefsd,// EVEX_Vscalefsd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vmaskmovps,// VEX_Vmaskmovps_m128_xmm_xmm
			(ushort)Mnemonic.Vmaskmovps,// VEX_Vmaskmovps_m256_ymm_ymm
			(ushort)Mnemonic.Vmaskmovpd,// VEX_Vmaskmovpd_m128_xmm_xmm
			(ushort)Mnemonic.Vmaskmovpd,// VEX_Vmaskmovpd_m256_ymm_ymm
			(ushort)Mnemonic.Pmovzxbw,// Pmovzxbw_xmm_xmmm64
			(ushort)Mnemonic.Vpmovzxbw,// VEX_Vpmovzxbw_xmm_xmmm64
			(ushort)Mnemonic.Vpmovzxbw,// VEX_Vpmovzxbw_ymm_xmmm128
			(ushort)Mnemonic.Vpmovzxbw,// EVEX_Vpmovzxbw_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovzxbw,// EVEX_Vpmovzxbw_ymm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovzxbw,// EVEX_Vpmovzxbw_zmm_k1z_ymmm256
			(ushort)Mnemonic.Vpmovwb,// EVEX_Vpmovwb_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovwb,// EVEX_Vpmovwb_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovwb,// EVEX_Vpmovwb_ymmm256_k1z_zmm
			(ushort)Mnemonic.Pmovzxbd,// Pmovzxbd_xmm_xmmm32
			(ushort)Mnemonic.Vpmovzxbd,// VEX_Vpmovzxbd_xmm_xmmm32
			(ushort)Mnemonic.Vpmovzxbd,// VEX_Vpmovzxbd_ymm_xmmm64
			(ushort)Mnemonic.Vpmovzxbd,// EVEX_Vpmovzxbd_xmm_k1z_xmmm32
			(ushort)Mnemonic.Vpmovzxbd,// EVEX_Vpmovzxbd_ymm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovzxbd,// EVEX_Vpmovzxbd_zmm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovdb,// EVEX_Vpmovdb_xmmm32_k1z_xmm
			(ushort)Mnemonic.Vpmovdb,// EVEX_Vpmovdb_xmmm64_k1z_ymm
			(ushort)Mnemonic.Vpmovdb,// EVEX_Vpmovdb_xmmm128_k1z_zmm
			(ushort)Mnemonic.Pmovzxbq,// Pmovzxbq_xmm_xmmm16
			(ushort)Mnemonic.Vpmovzxbq,// VEX_Vpmovzxbq_xmm_xmmm16
			(ushort)Mnemonic.Vpmovzxbq,// VEX_Vpmovzxbq_ymm_xmmm32
			(ushort)Mnemonic.Vpmovzxbq,// EVEX_Vpmovzxbq_xmm_k1z_xmmm16
			(ushort)Mnemonic.Vpmovzxbq,// EVEX_Vpmovzxbq_ymm_k1z_xmmm32
			(ushort)Mnemonic.Vpmovzxbq,// EVEX_Vpmovzxbq_zmm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovqb,// EVEX_Vpmovqb_xmmm16_k1z_xmm
			(ushort)Mnemonic.Vpmovqb,// EVEX_Vpmovqb_xmmm32_k1z_ymm
			(ushort)Mnemonic.Vpmovqb,// EVEX_Vpmovqb_xmmm64_k1z_zmm
			(ushort)Mnemonic.Pmovzxwd,// Pmovzxwd_xmm_xmmm64
			(ushort)Mnemonic.Vpmovzxwd,// VEX_Vpmovzxwd_xmm_xmmm64
			(ushort)Mnemonic.Vpmovzxwd,// VEX_Vpmovzxwd_ymm_xmmm128
			(ushort)Mnemonic.Vpmovzxwd,// EVEX_Vpmovzxwd_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovzxwd,// EVEX_Vpmovzxwd_ymm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovzxwd,// EVEX_Vpmovzxwd_zmm_k1z_ymmm256
			(ushort)Mnemonic.Vpmovdw,// EVEX_Vpmovdw_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovdw,// EVEX_Vpmovdw_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovdw,// EVEX_Vpmovdw_ymmm256_k1z_zmm
			(ushort)Mnemonic.Pmovzxwq,// Pmovzxwq_xmm_xmmm32
			(ushort)Mnemonic.Vpmovzxwq,// VEX_Vpmovzxwq_xmm_xmmm32
			(ushort)Mnemonic.Vpmovzxwq,// VEX_Vpmovzxwq_ymm_xmmm64
			(ushort)Mnemonic.Vpmovzxwq,// EVEX_Vpmovzxwq_xmm_k1z_xmmm32
			(ushort)Mnemonic.Vpmovzxwq,// EVEX_Vpmovzxwq_ymm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovzxwq,// EVEX_Vpmovzxwq_zmm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovqw,// EVEX_Vpmovqw_xmmm32_k1z_xmm
			(ushort)Mnemonic.Vpmovqw,// EVEX_Vpmovqw_xmmm64_k1z_ymm
			(ushort)Mnemonic.Vpmovqw,// EVEX_Vpmovqw_xmmm128_k1z_zmm
			(ushort)Mnemonic.Pmovzxdq,// Pmovzxdq_xmm_xmmm64
			(ushort)Mnemonic.Vpmovzxdq,// VEX_Vpmovzxdq_xmm_xmmm64
			(ushort)Mnemonic.Vpmovzxdq,// VEX_Vpmovzxdq_ymm_xmmm128
			(ushort)Mnemonic.Vpmovzxdq,// EVEX_Vpmovzxdq_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vpmovzxdq,// EVEX_Vpmovzxdq_ymm_k1z_xmmm128
			(ushort)Mnemonic.Vpmovzxdq,// EVEX_Vpmovzxdq_zmm_k1z_ymmm256
			(ushort)Mnemonic.Vpmovqd,// EVEX_Vpmovqd_xmmm64_k1z_xmm
			(ushort)Mnemonic.Vpmovqd,// EVEX_Vpmovqd_xmmm128_k1z_ymm
			(ushort)Mnemonic.Vpmovqd,// EVEX_Vpmovqd_ymmm256_k1z_zmm
			(ushort)Mnemonic.Vpermd,// VEX_Vpermd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpermd,// EVEX_Vpermd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpermd,// EVEX_Vpermd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpermq,// EVEX_Vpermq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpermq,// EVEX_Vpermq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Pcmpgtq,// Pcmpgtq_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtq,// VEX_Vpcmpgtq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmpgtq,// VEX_Vpcmpgtq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpcmpgtq,// EVEX_Vpcmpgtq_k_k1_xmm_xmmm128b64
			(ushort)Mnemonic.Vpcmpgtq,// EVEX_Vpcmpgtq_k_k1_ymm_ymmm256b64
			(ushort)Mnemonic.Vpcmpgtq,// EVEX_Vpcmpgtq_k_k1_zmm_zmmm512b64
			(ushort)Mnemonic.Pminsb,// Pminsb_xmm_xmmm128
			(ushort)Mnemonic.Vpminsb,// VEX_Vpminsb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpminsb,// VEX_Vpminsb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpminsb,// EVEX_Vpminsb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpminsb,// EVEX_Vpminsb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpminsb,// EVEX_Vpminsb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpmovm2d,// EVEX_Vpmovm2d_xmm_k
			(ushort)Mnemonic.Vpmovm2d,// EVEX_Vpmovm2d_ymm_k
			(ushort)Mnemonic.Vpmovm2d,// EVEX_Vpmovm2d_zmm_k
			(ushort)Mnemonic.Vpmovm2q,// EVEX_Vpmovm2q_xmm_k
			(ushort)Mnemonic.Vpmovm2q,// EVEX_Vpmovm2q_ymm_k
			(ushort)Mnemonic.Vpmovm2q,// EVEX_Vpmovm2q_zmm_k
			(ushort)Mnemonic.Pminsd,// Pminsd_xmm_xmmm128
			(ushort)Mnemonic.Vpminsd,// VEX_Vpminsd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpminsd,// VEX_Vpminsd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpminsd,// EVEX_Vpminsd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpminsd,// EVEX_Vpminsd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpminsd,// EVEX_Vpminsd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpminsq,// EVEX_Vpminsq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpminsq,// EVEX_Vpminsq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpminsq,// EVEX_Vpminsq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpmovd2m,// EVEX_Vpmovd2m_k_xmm
			(ushort)Mnemonic.Vpmovd2m,// EVEX_Vpmovd2m_k_ymm
			(ushort)Mnemonic.Vpmovd2m,// EVEX_Vpmovd2m_k_zmm
			(ushort)Mnemonic.Vpmovq2m,// EVEX_Vpmovq2m_k_xmm
			(ushort)Mnemonic.Vpmovq2m,// EVEX_Vpmovq2m_k_ymm
			(ushort)Mnemonic.Vpmovq2m,// EVEX_Vpmovq2m_k_zmm
			(ushort)Mnemonic.Pminuw,// Pminuw_xmm_xmmm128
			(ushort)Mnemonic.Vpminuw,// VEX_Vpminuw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpminuw,// VEX_Vpminuw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpminuw,// EVEX_Vpminuw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpminuw,// EVEX_Vpminuw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpminuw,// EVEX_Vpminuw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpbroadcastmw2d,// EVEX_Vpbroadcastmw2d_xmm_k
			(ushort)Mnemonic.Vpbroadcastmw2d,// EVEX_Vpbroadcastmw2d_ymm_k
			(ushort)Mnemonic.Vpbroadcastmw2d,// EVEX_Vpbroadcastmw2d_zmm_k
			(ushort)Mnemonic.Pminud,// Pminud_xmm_xmmm128
			(ushort)Mnemonic.Vpminud,// VEX_Vpminud_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpminud,// VEX_Vpminud_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpminud,// EVEX_Vpminud_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpminud,// EVEX_Vpminud_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpminud,// EVEX_Vpminud_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpminuq,// EVEX_Vpminuq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpminuq,// EVEX_Vpminuq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpminuq,// EVEX_Vpminuq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Pmaxsb,// Pmaxsb_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxsb,// VEX_Vpmaxsb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxsb,// VEX_Vpmaxsb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxsb,// EVEX_Vpmaxsb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxsb,// EVEX_Vpmaxsb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxsb,// EVEX_Vpmaxsb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pmaxsd,// Pmaxsd_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxsd,// VEX_Vpmaxsd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxsd,// VEX_Vpmaxsd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxsd,// EVEX_Vpmaxsd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpmaxsd,// EVEX_Vpmaxsd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpmaxsd,// EVEX_Vpmaxsd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpmaxsq,// EVEX_Vpmaxsq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpmaxsq,// EVEX_Vpmaxsq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpmaxsq,// EVEX_Vpmaxsq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Pmaxuw,// Pmaxuw_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxuw,// VEX_Vpmaxuw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxuw,// VEX_Vpmaxuw_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxuw,// EVEX_Vpmaxuw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxuw,// EVEX_Vpmaxuw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxuw,// EVEX_Vpmaxuw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Pmaxud,// Pmaxud_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxud,// VEX_Vpmaxud_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmaxud,// VEX_Vpmaxud_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmaxud,// EVEX_Vpmaxud_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpmaxud,// EVEX_Vpmaxud_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpmaxud,// EVEX_Vpmaxud_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpmaxuq,// EVEX_Vpmaxuq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpmaxuq,// EVEX_Vpmaxuq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpmaxuq,// EVEX_Vpmaxuq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Pmulld,// Pmulld_xmm_xmmm128
			(ushort)Mnemonic.Vpmulld,// VEX_Vpmulld_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmulld,// VEX_Vpmulld_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpmulld,// EVEX_Vpmulld_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpmulld,// EVEX_Vpmulld_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpmulld,// EVEX_Vpmulld_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpmullq,// EVEX_Vpmullq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpmullq,// EVEX_Vpmullq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpmullq,// EVEX_Vpmullq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Phminposuw,// Phminposuw_xmm_xmmm128
			(ushort)Mnemonic.Vphminposuw,// VEX_Vphminposuw_xmm_xmmm128
			(ushort)Mnemonic.Vgetexpps,// EVEX_Vgetexpps_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vgetexpps,// EVEX_Vgetexpps_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vgetexpps,// EVEX_Vgetexpps_zmm_k1z_zmmm512b32_sae
			(ushort)Mnemonic.Vgetexppd,// EVEX_Vgetexppd_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vgetexppd,// EVEX_Vgetexppd_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vgetexppd,// EVEX_Vgetexppd_zmm_k1z_zmmm512b64_sae
			(ushort)Mnemonic.Vgetexpss,// EVEX_Vgetexpss_xmm_k1z_xmm_xmmm32_sae
			(ushort)Mnemonic.Vgetexpsd,// EVEX_Vgetexpsd_xmm_k1z_xmm_xmmm64_sae
			(ushort)Mnemonic.Vplzcntd,// EVEX_Vplzcntd_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vplzcntd,// EVEX_Vplzcntd_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vplzcntd,// EVEX_Vplzcntd_zmm_k1z_zmmm512b32
			(ushort)Mnemonic.Vplzcntq,// EVEX_Vplzcntq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vplzcntq,// EVEX_Vplzcntq_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vplzcntq,// EVEX_Vplzcntq_zmm_k1z_zmmm512b64
			(ushort)Mnemonic.Vpsrlvd,// VEX_Vpsrlvd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlvd,// VEX_Vpsrlvd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsrlvq,// VEX_Vpsrlvq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsrlvq,// VEX_Vpsrlvq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsrlvd,// EVEX_Vpsrlvd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpsrlvd,// EVEX_Vpsrlvd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpsrlvd,// EVEX_Vpsrlvd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpsrlvq,// EVEX_Vpsrlvq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpsrlvq,// EVEX_Vpsrlvq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpsrlvq,// EVEX_Vpsrlvq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpsravd,// VEX_Vpsravd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsravd,// VEX_Vpsravd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsravd,// EVEX_Vpsravd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpsravd,// EVEX_Vpsravd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpsravd,// EVEX_Vpsravd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpsravq,// EVEX_Vpsravq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpsravq,// EVEX_Vpsravq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpsravq,// EVEX_Vpsravq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpsllvd,// VEX_Vpsllvd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsllvd,// VEX_Vpsllvd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsllvq,// VEX_Vpsllvq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpsllvq,// VEX_Vpsllvq_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpsllvd,// EVEX_Vpsllvd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpsllvd,// EVEX_Vpsllvd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpsllvd,// EVEX_Vpsllvd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpsllvq,// EVEX_Vpsllvq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpsllvq,// EVEX_Vpsllvq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpsllvq,// EVEX_Vpsllvq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vrcp14ps,// EVEX_Vrcp14ps_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vrcp14ps,// EVEX_Vrcp14ps_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vrcp14ps,// EVEX_Vrcp14ps_zmm_k1z_zmmm512b32
			(ushort)Mnemonic.Vrcp14pd,// EVEX_Vrcp14pd_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vrcp14pd,// EVEX_Vrcp14pd_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vrcp14pd,// EVEX_Vrcp14pd_zmm_k1z_zmmm512b64
			(ushort)Mnemonic.Vrcp14ss,// EVEX_Vrcp14ss_xmm_k1z_xmm_xmmm32
			(ushort)Mnemonic.Vrcp14sd,// EVEX_Vrcp14sd_xmm_k1z_xmm_xmmm64
			(ushort)Mnemonic.Vrsqrt14ps,// EVEX_Vrsqrt14ps_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vrsqrt14ps,// EVEX_Vrsqrt14ps_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vrsqrt14ps,// EVEX_Vrsqrt14ps_zmm_k1z_zmmm512b32
			(ushort)Mnemonic.Vrsqrt14pd,// EVEX_Vrsqrt14pd_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vrsqrt14pd,// EVEX_Vrsqrt14pd_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vrsqrt14pd,// EVEX_Vrsqrt14pd_zmm_k1z_zmmm512b64
			(ushort)Mnemonic.Vrsqrt14ss,// EVEX_Vrsqrt14ss_xmm_k1z_xmm_xmmm32
			(ushort)Mnemonic.Vrsqrt14sd,// EVEX_Vrsqrt14sd_xmm_k1z_xmm_xmmm64
			(ushort)Mnemonic.Vpdpbusd,// EVEX_Vpdpbusd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpdpbusd,// EVEX_Vpdpbusd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpdpbusd,// EVEX_Vpdpbusd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpdpbusds,// EVEX_Vpdpbusds_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpdpbusds,// EVEX_Vpdpbusds_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpdpbusds,// EVEX_Vpdpbusds_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpdpwssd,// EVEX_Vpdpwssd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpdpwssd,// EVEX_Vpdpwssd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpdpwssd,// EVEX_Vpdpwssd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vdpbf16ps,// EVEX_Vdpbf16ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vdpbf16ps,// EVEX_Vdpbf16ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vdpbf16ps,// EVEX_Vdpbf16ps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vp4dpwssd,// EVEX_Vp4dpwssd_zmm_k1z_zmmp3_m128
			(ushort)Mnemonic.Vpdpwssds,// EVEX_Vpdpwssds_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpdpwssds,// EVEX_Vpdpwssds_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpdpwssds,// EVEX_Vpdpwssds_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vp4dpwssds,// EVEX_Vp4dpwssds_zmm_k1z_zmmp3_m128
			(ushort)Mnemonic.Vpopcntb,// EVEX_Vpopcntb_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vpopcntb,// EVEX_Vpopcntb_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vpopcntb,// EVEX_Vpopcntb_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vpopcntw,// EVEX_Vpopcntw_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vpopcntw,// EVEX_Vpopcntw_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vpopcntw,// EVEX_Vpopcntw_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vpopcntd,// EVEX_Vpopcntd_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vpopcntd,// EVEX_Vpopcntd_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vpopcntd,// EVEX_Vpopcntd_zmm_k1z_zmmm512b32
			(ushort)Mnemonic.Vpopcntq,// EVEX_Vpopcntq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vpopcntq,// EVEX_Vpopcntq_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vpopcntq,// EVEX_Vpopcntq_zmm_k1z_zmmm512b64
			(ushort)Mnemonic.Vpbroadcastd,// VEX_Vpbroadcastd_xmm_xmmm32
			(ushort)Mnemonic.Vpbroadcastd,// VEX_Vpbroadcastd_ymm_xmmm32
			(ushort)Mnemonic.Vpbroadcastd,// EVEX_Vpbroadcastd_xmm_k1z_xmmm32
			(ushort)Mnemonic.Vpbroadcastd,// EVEX_Vpbroadcastd_ymm_k1z_xmmm32
			(ushort)Mnemonic.Vpbroadcastd,// EVEX_Vpbroadcastd_zmm_k1z_xmmm32
			(ushort)Mnemonic.Vpbroadcastq,// VEX_Vpbroadcastq_xmm_xmmm64
			(ushort)Mnemonic.Vpbroadcastq,// VEX_Vpbroadcastq_ymm_xmmm64
			(ushort)Mnemonic.Vbroadcasti32x2,// EVEX_Vbroadcasti32x2_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vbroadcasti32x2,// EVEX_Vbroadcasti32x2_ymm_k1z_xmmm64
			(ushort)Mnemonic.Vbroadcasti32x2,// EVEX_Vbroadcasti32x2_zmm_k1z_xmmm64
			(ushort)Mnemonic.Vpbroadcastq,// EVEX_Vpbroadcastq_xmm_k1z_xmmm64
			(ushort)Mnemonic.Vpbroadcastq,// EVEX_Vpbroadcastq_ymm_k1z_xmmm64
			(ushort)Mnemonic.Vpbroadcastq,// EVEX_Vpbroadcastq_zmm_k1z_xmmm64
			(ushort)Mnemonic.Vbroadcasti128,// VEX_Vbroadcasti128_ymm_m128
			(ushort)Mnemonic.Vbroadcasti32x4,// EVEX_Vbroadcasti32x4_ymm_k1z_m128
			(ushort)Mnemonic.Vbroadcasti32x4,// EVEX_Vbroadcasti32x4_zmm_k1z_m128
			(ushort)Mnemonic.Vbroadcasti64x2,// EVEX_Vbroadcasti64x2_ymm_k1z_m128
			(ushort)Mnemonic.Vbroadcasti64x2,// EVEX_Vbroadcasti64x2_zmm_k1z_m128
			(ushort)Mnemonic.Vbroadcasti32x8,// EVEX_Vbroadcasti32x8_zmm_k1z_m256
			(ushort)Mnemonic.Vbroadcasti64x4,// EVEX_Vbroadcasti64x4_zmm_k1z_m256
			(ushort)Mnemonic.Vpexpandb,// EVEX_Vpexpandb_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vpexpandb,// EVEX_Vpexpandb_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vpexpandb,// EVEX_Vpexpandb_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vpexpandw,// EVEX_Vpexpandw_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vpexpandw,// EVEX_Vpexpandw_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vpexpandw,// EVEX_Vpexpandw_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vpcompressb,// EVEX_Vpcompressb_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vpcompressb,// EVEX_Vpcompressb_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vpcompressb,// EVEX_Vpcompressb_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vpcompressw,// EVEX_Vpcompressw_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vpcompressw,// EVEX_Vpcompressw_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vpcompressw,// EVEX_Vpcompressw_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vpblendmd,// EVEX_Vpblendmd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpblendmd,// EVEX_Vpblendmd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpblendmd,// EVEX_Vpblendmd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpblendmq,// EVEX_Vpblendmq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpblendmq,// EVEX_Vpblendmq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpblendmq,// EVEX_Vpblendmq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vblendmps,// EVEX_Vblendmps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vblendmps,// EVEX_Vblendmps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vblendmps,// EVEX_Vblendmps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vblendmpd,// EVEX_Vblendmpd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vblendmpd,// EVEX_Vblendmpd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vblendmpd,// EVEX_Vblendmpd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpblendmb,// EVEX_Vpblendmb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpblendmb,// EVEX_Vpblendmb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpblendmb,// EVEX_Vpblendmb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpblendmw,// EVEX_Vpblendmw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpblendmw,// EVEX_Vpblendmw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpblendmw,// EVEX_Vpblendmw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vp2intersectd,// EVEX_Vp2intersectd_kp1_xmm_xmmm128b32
			(ushort)Mnemonic.Vp2intersectd,// EVEX_Vp2intersectd_kp1_ymm_ymmm256b32
			(ushort)Mnemonic.Vp2intersectd,// EVEX_Vp2intersectd_kp1_zmm_zmmm512b32
			(ushort)Mnemonic.Vp2intersectq,// EVEX_Vp2intersectq_kp1_xmm_xmmm128b64
			(ushort)Mnemonic.Vp2intersectq,// EVEX_Vp2intersectq_kp1_ymm_ymmm256b64
			(ushort)Mnemonic.Vp2intersectq,// EVEX_Vp2intersectq_kp1_zmm_zmmm512b64
			(ushort)Mnemonic.Vpshldvw,// EVEX_Vpshldvw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpshldvw,// EVEX_Vpshldvw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpshldvw,// EVEX_Vpshldvw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpshldvd,// EVEX_Vpshldvd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpshldvd,// EVEX_Vpshldvd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpshldvd,// EVEX_Vpshldvd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpshldvq,// EVEX_Vpshldvq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpshldvq,// EVEX_Vpshldvq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpshldvq,// EVEX_Vpshldvq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpshrdvw,// EVEX_Vpshrdvw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpshrdvw,// EVEX_Vpshrdvw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpshrdvw,// EVEX_Vpshrdvw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vcvtneps2bf16,// EVEX_Vcvtneps2bf16_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vcvtneps2bf16,// EVEX_Vcvtneps2bf16_xmm_k1z_ymmm256b32
			(ushort)Mnemonic.Vcvtneps2bf16,// EVEX_Vcvtneps2bf16_ymm_k1z_zmmm512b32
			(ushort)Mnemonic.Vcvtne2ps2bf16,// EVEX_Vcvtne2ps2bf16_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vcvtne2ps2bf16,// EVEX_Vcvtne2ps2bf16_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vcvtne2ps2bf16,// EVEX_Vcvtne2ps2bf16_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpshrdvd,// EVEX_Vpshrdvd_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpshrdvd,// EVEX_Vpshrdvd_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpshrdvd,// EVEX_Vpshrdvd_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpshrdvq,// EVEX_Vpshrdvq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpshrdvq,// EVEX_Vpshrdvq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpshrdvq,// EVEX_Vpshrdvq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpermi2b,// EVEX_Vpermi2b_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpermi2b,// EVEX_Vpermi2b_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpermi2b,// EVEX_Vpermi2b_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpermi2w,// EVEX_Vpermi2w_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpermi2w,// EVEX_Vpermi2w_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpermi2w,// EVEX_Vpermi2w_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpermi2d,// EVEX_Vpermi2d_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpermi2d,// EVEX_Vpermi2d_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpermi2d,// EVEX_Vpermi2d_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpermi2q,// EVEX_Vpermi2q_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpermi2q,// EVEX_Vpermi2q_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpermi2q,// EVEX_Vpermi2q_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpermi2ps,// EVEX_Vpermi2ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpermi2ps,// EVEX_Vpermi2ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpermi2ps,// EVEX_Vpermi2ps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpermi2pd,// EVEX_Vpermi2pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpermi2pd,// EVEX_Vpermi2pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpermi2pd,// EVEX_Vpermi2pd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpbroadcastb,// VEX_Vpbroadcastb_xmm_xmmm8
			(ushort)Mnemonic.Vpbroadcastb,// VEX_Vpbroadcastb_ymm_xmmm8
			(ushort)Mnemonic.Vpbroadcastb,// EVEX_Vpbroadcastb_xmm_k1z_xmmm8
			(ushort)Mnemonic.Vpbroadcastb,// EVEX_Vpbroadcastb_ymm_k1z_xmmm8
			(ushort)Mnemonic.Vpbroadcastb,// EVEX_Vpbroadcastb_zmm_k1z_xmmm8
			(ushort)Mnemonic.Vpbroadcastw,// VEX_Vpbroadcastw_xmm_xmmm16
			(ushort)Mnemonic.Vpbroadcastw,// VEX_Vpbroadcastw_ymm_xmmm16
			(ushort)Mnemonic.Vpbroadcastw,// EVEX_Vpbroadcastw_xmm_k1z_xmmm16
			(ushort)Mnemonic.Vpbroadcastw,// EVEX_Vpbroadcastw_ymm_k1z_xmmm16
			(ushort)Mnemonic.Vpbroadcastw,// EVEX_Vpbroadcastw_zmm_k1z_xmmm16
			(ushort)Mnemonic.Vpbroadcastb,// EVEX_Vpbroadcastb_xmm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastb,// EVEX_Vpbroadcastb_ymm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastb,// EVEX_Vpbroadcastb_zmm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastw,// EVEX_Vpbroadcastw_xmm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastw,// EVEX_Vpbroadcastw_ymm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastw,// EVEX_Vpbroadcastw_zmm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastd,// EVEX_Vpbroadcastd_xmm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastd,// EVEX_Vpbroadcastd_ymm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastd,// EVEX_Vpbroadcastd_zmm_k1z_r32
			(ushort)Mnemonic.Vpbroadcastq,// EVEX_Vpbroadcastq_xmm_k1z_r64
			(ushort)Mnemonic.Vpbroadcastq,// EVEX_Vpbroadcastq_ymm_k1z_r64
			(ushort)Mnemonic.Vpbroadcastq,// EVEX_Vpbroadcastq_zmm_k1z_r64
			(ushort)Mnemonic.Vpermt2b,// EVEX_Vpermt2b_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpermt2b,// EVEX_Vpermt2b_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpermt2b,// EVEX_Vpermt2b_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpermt2w,// EVEX_Vpermt2w_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpermt2w,// EVEX_Vpermt2w_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpermt2w,// EVEX_Vpermt2w_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpermt2d,// EVEX_Vpermt2d_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpermt2d,// EVEX_Vpermt2d_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpermt2d,// EVEX_Vpermt2d_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpermt2q,// EVEX_Vpermt2q_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpermt2q,// EVEX_Vpermt2q_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpermt2q,// EVEX_Vpermt2q_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpermt2ps,// EVEX_Vpermt2ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vpermt2ps,// EVEX_Vpermt2ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vpermt2ps,// EVEX_Vpermt2ps_zmm_k1z_zmm_zmmm512b32
			(ushort)Mnemonic.Vpermt2pd,// EVEX_Vpermt2pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpermt2pd,// EVEX_Vpermt2pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpermt2pd,// EVEX_Vpermt2pd_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Invept,// Invept_r32_m128
			(ushort)Mnemonic.Invept,// Invept_r64_m128
			(ushort)Mnemonic.Invvpid,// Invvpid_r32_m128
			(ushort)Mnemonic.Invvpid,// Invvpid_r64_m128
			(ushort)Mnemonic.Invpcid,// Invpcid_r32_m128
			(ushort)Mnemonic.Invpcid,// Invpcid_r64_m128
			(ushort)Mnemonic.Vpmultishiftqb,// EVEX_Vpmultishiftqb_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpmultishiftqb,// EVEX_Vpmultishiftqb_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpmultishiftqb,// EVEX_Vpmultishiftqb_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vexpandps,// EVEX_Vexpandps_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vexpandps,// EVEX_Vexpandps_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vexpandps,// EVEX_Vexpandps_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vexpandpd,// EVEX_Vexpandpd_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vexpandpd,// EVEX_Vexpandpd_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vexpandpd,// EVEX_Vexpandpd_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vpexpandd,// EVEX_Vpexpandd_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vpexpandd,// EVEX_Vpexpandd_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vpexpandd,// EVEX_Vpexpandd_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vpexpandq,// EVEX_Vpexpandq_xmm_k1z_xmmm128
			(ushort)Mnemonic.Vpexpandq,// EVEX_Vpexpandq_ymm_k1z_ymmm256
			(ushort)Mnemonic.Vpexpandq,// EVEX_Vpexpandq_zmm_k1z_zmmm512
			(ushort)Mnemonic.Vcompressps,// EVEX_Vcompressps_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vcompressps,// EVEX_Vcompressps_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vcompressps,// EVEX_Vcompressps_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vcompresspd,// EVEX_Vcompresspd_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vcompresspd,// EVEX_Vcompresspd_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vcompresspd,// EVEX_Vcompresspd_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vpcompressd,// EVEX_Vpcompressd_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vpcompressd,// EVEX_Vpcompressd_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vpcompressd,// EVEX_Vpcompressd_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vpcompressq,// EVEX_Vpcompressq_xmmm128_k1z_xmm
			(ushort)Mnemonic.Vpcompressq,// EVEX_Vpcompressq_ymmm256_k1z_ymm
			(ushort)Mnemonic.Vpcompressq,// EVEX_Vpcompressq_zmmm512_k1z_zmm
			(ushort)Mnemonic.Vpmaskmovd,// VEX_Vpmaskmovd_xmm_xmm_m128
			(ushort)Mnemonic.Vpmaskmovd,// VEX_Vpmaskmovd_ymm_ymm_m256
			(ushort)Mnemonic.Vpmaskmovq,// VEX_Vpmaskmovq_xmm_xmm_m128
			(ushort)Mnemonic.Vpmaskmovq,// VEX_Vpmaskmovq_ymm_ymm_m256
			(ushort)Mnemonic.Vpermb,// EVEX_Vpermb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpermb,// EVEX_Vpermb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpermb,// EVEX_Vpermb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpermw,// EVEX_Vpermw_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vpermw,// EVEX_Vpermw_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vpermw,// EVEX_Vpermw_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Vpmaskmovd,// VEX_Vpmaskmovd_m128_xmm_xmm
			(ushort)Mnemonic.Vpmaskmovd,// VEX_Vpmaskmovd_m256_ymm_ymm
			(ushort)Mnemonic.Vpmaskmovq,// VEX_Vpmaskmovq_m128_xmm_xmm
			(ushort)Mnemonic.Vpmaskmovq,// VEX_Vpmaskmovq_m256_ymm_ymm
			(ushort)Mnemonic.Vpshufbitqmb,// EVEX_Vpshufbitqmb_k_k1_xmm_xmmm128
			(ushort)Mnemonic.Vpshufbitqmb,// EVEX_Vpshufbitqmb_k_k1_ymm_ymmm256
			(ushort)Mnemonic.Vpshufbitqmb,// EVEX_Vpshufbitqmb_k_k1_zmm_zmmm512
			(ushort)Mnemonic.Vpgatherdd,// VEX_Vpgatherdd_xmm_vm32x_xmm
			(ushort)Mnemonic.Vpgatherdd,// VEX_Vpgatherdd_ymm_vm32y_ymm
			(ushort)Mnemonic.Vpgatherdq,// VEX_Vpgatherdq_xmm_vm32x_xmm
			(ushort)Mnemonic.Vpgatherdq,// VEX_Vpgatherdq_ymm_vm32x_ymm
			(ushort)Mnemonic.Vpgatherdd,// EVEX_Vpgatherdd_xmm_k1_vm32x
			(ushort)Mnemonic.Vpgatherdd,// EVEX_Vpgatherdd_ymm_k1_vm32y
			(ushort)Mnemonic.Vpgatherdd,// EVEX_Vpgatherdd_zmm_k1_vm32z
			(ushort)Mnemonic.Vpgatherdq,// EVEX_Vpgatherdq_xmm_k1_vm32x
			(ushort)Mnemonic.Vpgatherdq,// EVEX_Vpgatherdq_ymm_k1_vm32x
			(ushort)Mnemonic.Vpgatherdq,// EVEX_Vpgatherdq_zmm_k1_vm32y
			(ushort)Mnemonic.Vpgatherqd,// VEX_Vpgatherqd_xmm_vm64x_xmm
			(ushort)Mnemonic.Vpgatherqd,// VEX_Vpgatherqd_xmm_vm64y_xmm
			(ushort)Mnemonic.Vpgatherqq,// VEX_Vpgatherqq_xmm_vm64x_xmm
			(ushort)Mnemonic.Vpgatherqq,// VEX_Vpgatherqq_ymm_vm64y_ymm
			(ushort)Mnemonic.Vpgatherqd,// EVEX_Vpgatherqd_xmm_k1_vm64x
			(ushort)Mnemonic.Vpgatherqd,// EVEX_Vpgatherqd_xmm_k1_vm64y
			(ushort)Mnemonic.Vpgatherqd,// EVEX_Vpgatherqd_ymm_k1_vm64z
			(ushort)Mnemonic.Vpgatherqq,// EVEX_Vpgatherqq_xmm_k1_vm64x
			(ushort)Mnemonic.Vpgatherqq,// EVEX_Vpgatherqq_ymm_k1_vm64y
			(ushort)Mnemonic.Vpgatherqq,// EVEX_Vpgatherqq_zmm_k1_vm64z
			(ushort)Mnemonic.Vgatherdps,// VEX_Vgatherdps_xmm_vm32x_xmm
			(ushort)Mnemonic.Vgatherdps,// VEX_Vgatherdps_ymm_vm32y_ymm
			(ushort)Mnemonic.Vgatherdpd,// VEX_Vgatherdpd_xmm_vm32x_xmm
			(ushort)Mnemonic.Vgatherdpd,// VEX_Vgatherdpd_ymm_vm32x_ymm
			(ushort)Mnemonic.Vgatherdps,// EVEX_Vgatherdps_xmm_k1_vm32x
			(ushort)Mnemonic.Vgatherdps,// EVEX_Vgatherdps_ymm_k1_vm32y
			(ushort)Mnemonic.Vgatherdps,// EVEX_Vgatherdps_zmm_k1_vm32z
			(ushort)Mnemonic.Vgatherdpd,// EVEX_Vgatherdpd_xmm_k1_vm32x
			(ushort)Mnemonic.Vgatherdpd,// EVEX_Vgatherdpd_ymm_k1_vm32x
			(ushort)Mnemonic.Vgatherdpd,// EVEX_Vgatherdpd_zmm_k1_vm32y
			(ushort)Mnemonic.Vgatherqps,// VEX_Vgatherqps_xmm_vm64x_xmm
			(ushort)Mnemonic.Vgatherqps,// VEX_Vgatherqps_xmm_vm64y_xmm
			(ushort)Mnemonic.Vgatherqpd,// VEX_Vgatherqpd_xmm_vm64x_xmm
			(ushort)Mnemonic.Vgatherqpd,// VEX_Vgatherqpd_ymm_vm64y_ymm
			(ushort)Mnemonic.Vgatherqps,// EVEX_Vgatherqps_xmm_k1_vm64x
			(ushort)Mnemonic.Vgatherqps,// EVEX_Vgatherqps_xmm_k1_vm64y
			(ushort)Mnemonic.Vgatherqps,// EVEX_Vgatherqps_ymm_k1_vm64z
			(ushort)Mnemonic.Vgatherqpd,// EVEX_Vgatherqpd_xmm_k1_vm64x
			(ushort)Mnemonic.Vgatherqpd,// EVEX_Vgatherqpd_ymm_k1_vm64y
			(ushort)Mnemonic.Vgatherqpd,// EVEX_Vgatherqpd_zmm_k1_vm64z
			(ushort)Mnemonic.Vfmaddsub132ps,// VEX_Vfmaddsub132ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddsub132ps,// VEX_Vfmaddsub132ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddsub132pd,// VEX_Vfmaddsub132pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddsub132pd,// VEX_Vfmaddsub132pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddsub132ps,// EVEX_Vfmaddsub132ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmaddsub132ps,// EVEX_Vfmaddsub132ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmaddsub132ps,// EVEX_Vfmaddsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmaddsub132pd,// EVEX_Vfmaddsub132pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmaddsub132pd,// EVEX_Vfmaddsub132pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmaddsub132pd,// EVEX_Vfmaddsub132pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmsubadd132ps,// VEX_Vfmsubadd132ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubadd132ps,// VEX_Vfmsubadd132ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubadd132pd,// VEX_Vfmsubadd132pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubadd132pd,// VEX_Vfmsubadd132pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubadd132ps,// EVEX_Vfmsubadd132ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmsubadd132ps,// EVEX_Vfmsubadd132ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmsubadd132ps,// EVEX_Vfmsubadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmsubadd132pd,// EVEX_Vfmsubadd132pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmsubadd132pd,// EVEX_Vfmsubadd132pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmsubadd132pd,// EVEX_Vfmsubadd132pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmadd132ps,// VEX_Vfmadd132ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmadd132ps,// VEX_Vfmadd132ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmadd132pd,// VEX_Vfmadd132pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmadd132pd,// VEX_Vfmadd132pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmadd132ps,// EVEX_Vfmadd132ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmadd132ps,// EVEX_Vfmadd132ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmadd132ps,// EVEX_Vfmadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmadd132pd,// EVEX_Vfmadd132pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmadd132pd,// EVEX_Vfmadd132pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmadd132pd,// EVEX_Vfmadd132pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmadd132ss,// VEX_Vfmadd132ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfmadd132sd,// VEX_Vfmadd132sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfmadd132ss,// EVEX_Vfmadd132ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfmadd132sd,// EVEX_Vfmadd132sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vfmsub132ps,// VEX_Vfmsub132ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsub132ps,// VEX_Vfmsub132ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsub132pd,// VEX_Vfmsub132pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsub132pd,// VEX_Vfmsub132pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsub132ps,// EVEX_Vfmsub132ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmsub132ps,// EVEX_Vfmsub132ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmsub132ps,// EVEX_Vfmsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmsub132pd,// EVEX_Vfmsub132pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmsub132pd,// EVEX_Vfmsub132pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmsub132pd,// EVEX_Vfmsub132pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.V4fmaddps,// EVEX_V4fmaddps_zmm_k1z_zmmp3_m128
			(ushort)Mnemonic.Vfmsub132ss,// VEX_Vfmsub132ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfmsub132sd,// VEX_Vfmsub132sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfmsub132ss,// EVEX_Vfmsub132ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfmsub132sd,// EVEX_Vfmsub132sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.V4fmaddss,// EVEX_V4fmaddss_xmm_k1z_xmmp3_m128
			(ushort)Mnemonic.Vfnmadd132ps,// VEX_Vfnmadd132ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmadd132ps,// VEX_Vfnmadd132ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmadd132pd,// VEX_Vfnmadd132pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmadd132pd,// VEX_Vfnmadd132pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmadd132ps,// EVEX_Vfnmadd132ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfnmadd132ps,// EVEX_Vfnmadd132ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfnmadd132ps,// EVEX_Vfnmadd132ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfnmadd132pd,// EVEX_Vfnmadd132pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfnmadd132pd,// EVEX_Vfnmadd132pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfnmadd132pd,// EVEX_Vfnmadd132pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfnmadd132ss,// VEX_Vfnmadd132ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfnmadd132sd,// VEX_Vfnmadd132sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfnmadd132ss,// EVEX_Vfnmadd132ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfnmadd132sd,// EVEX_Vfnmadd132sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vfnmsub132ps,// VEX_Vfnmsub132ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmsub132ps,// VEX_Vfnmsub132ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmsub132pd,// VEX_Vfnmsub132pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmsub132pd,// VEX_Vfnmsub132pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmsub132ps,// EVEX_Vfnmsub132ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfnmsub132ps,// EVEX_Vfnmsub132ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfnmsub132ps,// EVEX_Vfnmsub132ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfnmsub132pd,// EVEX_Vfnmsub132pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfnmsub132pd,// EVEX_Vfnmsub132pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfnmsub132pd,// EVEX_Vfnmsub132pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfnmsub132ss,// VEX_Vfnmsub132ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfnmsub132sd,// VEX_Vfnmsub132sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfnmsub132ss,// EVEX_Vfnmsub132ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfnmsub132sd,// EVEX_Vfnmsub132sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vpscatterdd,// EVEX_Vpscatterdd_vm32x_k1_xmm
			(ushort)Mnemonic.Vpscatterdd,// EVEX_Vpscatterdd_vm32y_k1_ymm
			(ushort)Mnemonic.Vpscatterdd,// EVEX_Vpscatterdd_vm32z_k1_zmm
			(ushort)Mnemonic.Vpscatterdq,// EVEX_Vpscatterdq_vm32x_k1_xmm
			(ushort)Mnemonic.Vpscatterdq,// EVEX_Vpscatterdq_vm32x_k1_ymm
			(ushort)Mnemonic.Vpscatterdq,// EVEX_Vpscatterdq_vm32y_k1_zmm
			(ushort)Mnemonic.Vpscatterqd,// EVEX_Vpscatterqd_vm64x_k1_xmm
			(ushort)Mnemonic.Vpscatterqd,// EVEX_Vpscatterqd_vm64y_k1_xmm
			(ushort)Mnemonic.Vpscatterqd,// EVEX_Vpscatterqd_vm64z_k1_ymm
			(ushort)Mnemonic.Vpscatterqq,// EVEX_Vpscatterqq_vm64x_k1_xmm
			(ushort)Mnemonic.Vpscatterqq,// EVEX_Vpscatterqq_vm64y_k1_ymm
			(ushort)Mnemonic.Vpscatterqq,// EVEX_Vpscatterqq_vm64z_k1_zmm
			(ushort)Mnemonic.Vscatterdps,// EVEX_Vscatterdps_vm32x_k1_xmm
			(ushort)Mnemonic.Vscatterdps,// EVEX_Vscatterdps_vm32y_k1_ymm
			(ushort)Mnemonic.Vscatterdps,// EVEX_Vscatterdps_vm32z_k1_zmm
			(ushort)Mnemonic.Vscatterdpd,// EVEX_Vscatterdpd_vm32x_k1_xmm
			(ushort)Mnemonic.Vscatterdpd,// EVEX_Vscatterdpd_vm32x_k1_ymm
			(ushort)Mnemonic.Vscatterdpd,// EVEX_Vscatterdpd_vm32y_k1_zmm
			(ushort)Mnemonic.Vscatterqps,// EVEX_Vscatterqps_vm64x_k1_xmm
			(ushort)Mnemonic.Vscatterqps,// EVEX_Vscatterqps_vm64y_k1_xmm
			(ushort)Mnemonic.Vscatterqps,// EVEX_Vscatterqps_vm64z_k1_ymm
			(ushort)Mnemonic.Vscatterqpd,// EVEX_Vscatterqpd_vm64x_k1_xmm
			(ushort)Mnemonic.Vscatterqpd,// EVEX_Vscatterqpd_vm64y_k1_ymm
			(ushort)Mnemonic.Vscatterqpd,// EVEX_Vscatterqpd_vm64z_k1_zmm
			(ushort)Mnemonic.Vfmaddsub213ps,// VEX_Vfmaddsub213ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddsub213ps,// VEX_Vfmaddsub213ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddsub213pd,// VEX_Vfmaddsub213pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddsub213pd,// VEX_Vfmaddsub213pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddsub213ps,// EVEX_Vfmaddsub213ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmaddsub213ps,// EVEX_Vfmaddsub213ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmaddsub213ps,// EVEX_Vfmaddsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmaddsub213pd,// EVEX_Vfmaddsub213pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmaddsub213pd,// EVEX_Vfmaddsub213pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmaddsub213pd,// EVEX_Vfmaddsub213pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmsubadd213ps,// VEX_Vfmsubadd213ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubadd213ps,// VEX_Vfmsubadd213ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubadd213pd,// VEX_Vfmsubadd213pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubadd213pd,// VEX_Vfmsubadd213pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubadd213ps,// EVEX_Vfmsubadd213ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmsubadd213ps,// EVEX_Vfmsubadd213ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmsubadd213ps,// EVEX_Vfmsubadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmsubadd213pd,// EVEX_Vfmsubadd213pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmsubadd213pd,// EVEX_Vfmsubadd213pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmsubadd213pd,// EVEX_Vfmsubadd213pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmadd213ps,// VEX_Vfmadd213ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmadd213ps,// VEX_Vfmadd213ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmadd213pd,// VEX_Vfmadd213pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmadd213pd,// VEX_Vfmadd213pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmadd213ps,// EVEX_Vfmadd213ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmadd213ps,// EVEX_Vfmadd213ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmadd213ps,// EVEX_Vfmadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmadd213pd,// EVEX_Vfmadd213pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmadd213pd,// EVEX_Vfmadd213pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmadd213pd,// EVEX_Vfmadd213pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmadd213ss,// VEX_Vfmadd213ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfmadd213sd,// VEX_Vfmadd213sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfmadd213ss,// EVEX_Vfmadd213ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfmadd213sd,// EVEX_Vfmadd213sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vfmsub213ps,// VEX_Vfmsub213ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsub213ps,// VEX_Vfmsub213ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsub213pd,// VEX_Vfmsub213pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsub213pd,// VEX_Vfmsub213pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsub213ps,// EVEX_Vfmsub213ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmsub213ps,// EVEX_Vfmsub213ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmsub213ps,// EVEX_Vfmsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmsub213pd,// EVEX_Vfmsub213pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmsub213pd,// EVEX_Vfmsub213pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmsub213pd,// EVEX_Vfmsub213pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.V4fnmaddps,// EVEX_V4fnmaddps_zmm_k1z_zmmp3_m128
			(ushort)Mnemonic.Vfmsub213ss,// VEX_Vfmsub213ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfmsub213sd,// VEX_Vfmsub213sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfmsub213ss,// EVEX_Vfmsub213ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfmsub213sd,// EVEX_Vfmsub213sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.V4fnmaddss,// EVEX_V4fnmaddss_xmm_k1z_xmmp3_m128
			(ushort)Mnemonic.Vfnmadd213ps,// VEX_Vfnmadd213ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmadd213ps,// VEX_Vfnmadd213ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmadd213pd,// VEX_Vfnmadd213pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmadd213pd,// VEX_Vfnmadd213pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmadd213ps,// EVEX_Vfnmadd213ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfnmadd213ps,// EVEX_Vfnmadd213ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfnmadd213ps,// EVEX_Vfnmadd213ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfnmadd213pd,// EVEX_Vfnmadd213pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfnmadd213pd,// EVEX_Vfnmadd213pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfnmadd213pd,// EVEX_Vfnmadd213pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfnmadd213ss,// VEX_Vfnmadd213ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfnmadd213sd,// VEX_Vfnmadd213sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfnmadd213ss,// EVEX_Vfnmadd213ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfnmadd213sd,// EVEX_Vfnmadd213sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vfnmsub213ps,// VEX_Vfnmsub213ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmsub213ps,// VEX_Vfnmsub213ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmsub213pd,// VEX_Vfnmsub213pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmsub213pd,// VEX_Vfnmsub213pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmsub213ps,// EVEX_Vfnmsub213ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfnmsub213ps,// EVEX_Vfnmsub213ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfnmsub213ps,// EVEX_Vfnmsub213ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfnmsub213pd,// EVEX_Vfnmsub213pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfnmsub213pd,// EVEX_Vfnmsub213pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfnmsub213pd,// EVEX_Vfnmsub213pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfnmsub213ss,// VEX_Vfnmsub213ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfnmsub213sd,// VEX_Vfnmsub213sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfnmsub213ss,// EVEX_Vfnmsub213ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfnmsub213sd,// EVEX_Vfnmsub213sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vpmadd52luq,// EVEX_Vpmadd52luq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpmadd52luq,// EVEX_Vpmadd52luq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpmadd52luq,// EVEX_Vpmadd52luq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vpmadd52huq,// EVEX_Vpmadd52huq_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vpmadd52huq,// EVEX_Vpmadd52huq_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vpmadd52huq,// EVEX_Vpmadd52huq_zmm_k1z_zmm_zmmm512b64
			(ushort)Mnemonic.Vfmaddsub231ps,// VEX_Vfmaddsub231ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddsub231ps,// VEX_Vfmaddsub231ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddsub231pd,// VEX_Vfmaddsub231pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddsub231pd,// VEX_Vfmaddsub231pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddsub231ps,// EVEX_Vfmaddsub231ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmaddsub231ps,// EVEX_Vfmaddsub231ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmaddsub231ps,// EVEX_Vfmaddsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmaddsub231pd,// EVEX_Vfmaddsub231pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmaddsub231pd,// EVEX_Vfmaddsub231pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmaddsub231pd,// EVEX_Vfmaddsub231pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmsubadd231ps,// VEX_Vfmsubadd231ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubadd231ps,// VEX_Vfmsubadd231ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubadd231pd,// VEX_Vfmsubadd231pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubadd231pd,// VEX_Vfmsubadd231pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubadd231ps,// EVEX_Vfmsubadd231ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmsubadd231ps,// EVEX_Vfmsubadd231ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmsubadd231ps,// EVEX_Vfmsubadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmsubadd231pd,// EVEX_Vfmsubadd231pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmsubadd231pd,// EVEX_Vfmsubadd231pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmsubadd231pd,// EVEX_Vfmsubadd231pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmadd231ps,// VEX_Vfmadd231ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmadd231ps,// VEX_Vfmadd231ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmadd231pd,// VEX_Vfmadd231pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmadd231pd,// VEX_Vfmadd231pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmadd231ps,// EVEX_Vfmadd231ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmadd231ps,// EVEX_Vfmadd231ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmadd231ps,// EVEX_Vfmadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmadd231pd,// EVEX_Vfmadd231pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmadd231pd,// EVEX_Vfmadd231pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmadd231pd,// EVEX_Vfmadd231pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmadd231ss,// VEX_Vfmadd231ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfmadd231sd,// VEX_Vfmadd231sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfmadd231ss,// EVEX_Vfmadd231ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfmadd231sd,// EVEX_Vfmadd231sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vfmsub231ps,// VEX_Vfmsub231ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsub231ps,// VEX_Vfmsub231ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsub231pd,// VEX_Vfmsub231pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsub231pd,// VEX_Vfmsub231pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsub231ps,// EVEX_Vfmsub231ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfmsub231ps,// EVEX_Vfmsub231ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfmsub231ps,// EVEX_Vfmsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfmsub231pd,// EVEX_Vfmsub231pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfmsub231pd,// EVEX_Vfmsub231pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfmsub231pd,// EVEX_Vfmsub231pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfmsub231ss,// VEX_Vfmsub231ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfmsub231sd,// VEX_Vfmsub231sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfmsub231ss,// EVEX_Vfmsub231ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfmsub231sd,// EVEX_Vfmsub231sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vfnmadd231ps,// VEX_Vfnmadd231ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmadd231ps,// VEX_Vfnmadd231ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmadd231pd,// VEX_Vfnmadd231pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmadd231pd,// VEX_Vfnmadd231pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmadd231ps,// EVEX_Vfnmadd231ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfnmadd231ps,// EVEX_Vfnmadd231ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfnmadd231ps,// EVEX_Vfnmadd231ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfnmadd231pd,// EVEX_Vfnmadd231pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfnmadd231pd,// EVEX_Vfnmadd231pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfnmadd231pd,// EVEX_Vfnmadd231pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfnmadd231ss,// VEX_Vfnmadd231ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfnmadd231sd,// VEX_Vfnmadd231sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfnmadd231ss,// EVEX_Vfnmadd231ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfnmadd231sd,// EVEX_Vfnmadd231sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vfnmsub231ps,// VEX_Vfnmsub231ps_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmsub231ps,// VEX_Vfnmsub231ps_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmsub231pd,// VEX_Vfnmsub231pd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmsub231pd,// VEX_Vfnmsub231pd_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmsub231ps,// EVEX_Vfnmsub231ps_xmm_k1z_xmm_xmmm128b32
			(ushort)Mnemonic.Vfnmsub231ps,// EVEX_Vfnmsub231ps_ymm_k1z_ymm_ymmm256b32
			(ushort)Mnemonic.Vfnmsub231ps,// EVEX_Vfnmsub231ps_zmm_k1z_zmm_zmmm512b32_er
			(ushort)Mnemonic.Vfnmsub231pd,// EVEX_Vfnmsub231pd_xmm_k1z_xmm_xmmm128b64
			(ushort)Mnemonic.Vfnmsub231pd,// EVEX_Vfnmsub231pd_ymm_k1z_ymm_ymmm256b64
			(ushort)Mnemonic.Vfnmsub231pd,// EVEX_Vfnmsub231pd_zmm_k1z_zmm_zmmm512b64_er
			(ushort)Mnemonic.Vfnmsub231ss,// VEX_Vfnmsub231ss_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfnmsub231sd,// VEX_Vfnmsub231sd_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfnmsub231ss,// EVEX_Vfnmsub231ss_xmm_k1z_xmm_xmmm32_er
			(ushort)Mnemonic.Vfnmsub231sd,// EVEX_Vfnmsub231sd_xmm_k1z_xmm_xmmm64_er
			(ushort)Mnemonic.Vpconflictd,// EVEX_Vpconflictd_xmm_k1z_xmmm128b32
			(ushort)Mnemonic.Vpconflictd,// EVEX_Vpconflictd_ymm_k1z_ymmm256b32
			(ushort)Mnemonic.Vpconflictd,// EVEX_Vpconflictd_zmm_k1z_zmmm512b32
			(ushort)Mnemonic.Vpconflictq,// EVEX_Vpconflictq_xmm_k1z_xmmm128b64
			(ushort)Mnemonic.Vpconflictq,// EVEX_Vpconflictq_ymm_k1z_ymmm256b64
			(ushort)Mnemonic.Vpconflictq,// EVEX_Vpconflictq_zmm_k1z_zmmm512b64
			(ushort)Mnemonic.Vgatherpf0dps,// EVEX_Vgatherpf0dps_vm32z_k1
			(ushort)Mnemonic.Vgatherpf0dpd,// EVEX_Vgatherpf0dpd_vm32y_k1
			(ushort)Mnemonic.Vgatherpf1dps,// EVEX_Vgatherpf1dps_vm32z_k1
			(ushort)Mnemonic.Vgatherpf1dpd,// EVEX_Vgatherpf1dpd_vm32y_k1
			(ushort)Mnemonic.Vscatterpf0dps,// EVEX_Vscatterpf0dps_vm32z_k1
			(ushort)Mnemonic.Vscatterpf0dpd,// EVEX_Vscatterpf0dpd_vm32y_k1
			(ushort)Mnemonic.Vscatterpf1dps,// EVEX_Vscatterpf1dps_vm32z_k1
			(ushort)Mnemonic.Vscatterpf1dpd,// EVEX_Vscatterpf1dpd_vm32y_k1
			(ushort)Mnemonic.Vgatherpf0qps,// EVEX_Vgatherpf0qps_vm64z_k1
			(ushort)Mnemonic.Vgatherpf0qpd,// EVEX_Vgatherpf0qpd_vm64z_k1
			(ushort)Mnemonic.Vgatherpf1qps,// EVEX_Vgatherpf1qps_vm64z_k1
			(ushort)Mnemonic.Vgatherpf1qpd,// EVEX_Vgatherpf1qpd_vm64z_k1
			(ushort)Mnemonic.Vscatterpf0qps,// EVEX_Vscatterpf0qps_vm64z_k1
			(ushort)Mnemonic.Vscatterpf0qpd,// EVEX_Vscatterpf0qpd_vm64z_k1
			(ushort)Mnemonic.Vscatterpf1qps,// EVEX_Vscatterpf1qps_vm64z_k1
			(ushort)Mnemonic.Vscatterpf1qpd,// EVEX_Vscatterpf1qpd_vm64z_k1
			(ushort)Mnemonic.Sha1nexte,// Sha1nexte_xmm_xmmm128
			(ushort)Mnemonic.Vexp2ps,// EVEX_Vexp2ps_zmm_k1z_zmmm512b32_sae
			(ushort)Mnemonic.Vexp2pd,// EVEX_Vexp2pd_zmm_k1z_zmmm512b64_sae
			(ushort)Mnemonic.Sha1msg1,// Sha1msg1_xmm_xmmm128
			(ushort)Mnemonic.Sha1msg2,// Sha1msg2_xmm_xmmm128
			(ushort)Mnemonic.Vrcp28ps,// EVEX_Vrcp28ps_zmm_k1z_zmmm512b32_sae
			(ushort)Mnemonic.Vrcp28pd,// EVEX_Vrcp28pd_zmm_k1z_zmmm512b64_sae
			(ushort)Mnemonic.Sha256rnds2,// Sha256rnds2_xmm_xmmm128
			(ushort)Mnemonic.Vrcp28ss,// EVEX_Vrcp28ss_xmm_k1z_xmm_xmmm32_sae
			(ushort)Mnemonic.Vrcp28sd,// EVEX_Vrcp28sd_xmm_k1z_xmm_xmmm64_sae
			(ushort)Mnemonic.Sha256msg1,// Sha256msg1_xmm_xmmm128
			(ushort)Mnemonic.Vrsqrt28ps,// EVEX_Vrsqrt28ps_zmm_k1z_zmmm512b32_sae
			(ushort)Mnemonic.Vrsqrt28pd,// EVEX_Vrsqrt28pd_zmm_k1z_zmmm512b64_sae
			(ushort)Mnemonic.Sha256msg2,// Sha256msg2_xmm_xmmm128
			(ushort)Mnemonic.Vrsqrt28ss,// EVEX_Vrsqrt28ss_xmm_k1z_xmm_xmmm32_sae
			(ushort)Mnemonic.Vrsqrt28sd,// EVEX_Vrsqrt28sd_xmm_k1z_xmm_xmmm64_sae
			(ushort)Mnemonic.Gf2p8mulb,// Gf2p8mulb_xmm_xmmm128
			(ushort)Mnemonic.Vgf2p8mulb,// VEX_Vgf2p8mulb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vgf2p8mulb,// VEX_Vgf2p8mulb_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vgf2p8mulb,// EVEX_Vgf2p8mulb_xmm_k1z_xmm_xmmm128
			(ushort)Mnemonic.Vgf2p8mulb,// EVEX_Vgf2p8mulb_ymm_k1z_ymm_ymmm256
			(ushort)Mnemonic.Vgf2p8mulb,// EVEX_Vgf2p8mulb_zmm_k1z_zmm_zmmm512
			(ushort)Mnemonic.Aesimc,// Aesimc_xmm_xmmm128
			(ushort)Mnemonic.Vaesimc,// VEX_Vaesimc_xmm_xmmm128
			(ushort)Mnemonic.Aesenc,// Aesenc_xmm_xmmm128
			(ushort)Mnemonic.Vaesenc,// VEX_Vaesenc_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaesenc,// VEX_Vaesenc_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaesenc,// EVEX_Vaesenc_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaesenc,// EVEX_Vaesenc_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaesenc,// EVEX_Vaesenc_zmm_zmm_zmmm512
			(ushort)Mnemonic.Aesenclast,// Aesenclast_xmm_xmmm128
			(ushort)Mnemonic.Vaesenclast,// VEX_Vaesenclast_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaesenclast,// VEX_Vaesenclast_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaesenclast,// EVEX_Vaesenclast_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaesenclast,// EVEX_Vaesenclast_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaesenclast,// EVEX_Vaesenclast_zmm_zmm_zmmm512
			(ushort)Mnemonic.Aesdec,// Aesdec_xmm_xmmm128
			(ushort)Mnemonic.Vaesdec,// VEX_Vaesdec_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaesdec,// VEX_Vaesdec_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaesdec,// EVEX_Vaesdec_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaesdec,// EVEX_Vaesdec_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaesdec,// EVEX_Vaesdec_zmm_zmm_zmmm512
			(ushort)Mnemonic.Aesdeclast,// Aesdeclast_xmm_xmmm128
			(ushort)Mnemonic.Vaesdeclast,// VEX_Vaesdeclast_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaesdeclast,// VEX_Vaesdeclast_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaesdeclast,// EVEX_Vaesdeclast_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vaesdeclast,// EVEX_Vaesdeclast_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vaesdeclast,// EVEX_Vaesdeclast_zmm_zmm_zmmm512
			(ushort)Mnemonic.Movbe,// Movbe_r16_m16
			(ushort)Mnemonic.Movbe,// Movbe_r32_m32
			(ushort)Mnemonic.Movbe,// Movbe_r64_m64
			(ushort)Mnemonic.Crc32,// Crc32_r32_rm8
			(ushort)Mnemonic.Crc32,// Crc32_r64_rm8
			(ushort)Mnemonic.Movbe,// Movbe_m16_r16
			(ushort)Mnemonic.Movbe,// Movbe_m32_r32
			(ushort)Mnemonic.Movbe,// Movbe_m64_r64
			(ushort)Mnemonic.Crc32,// Crc32_r32_rm16
			(ushort)Mnemonic.Crc32,// Crc32_r32_rm32
			(ushort)Mnemonic.Crc32,// Crc32_r64_rm64
			(ushort)Mnemonic.Andn,// VEX_Andn_r32_r32_rm32
			(ushort)Mnemonic.Andn,// VEX_Andn_r64_r64_rm64
			(ushort)Mnemonic.Blsr,// VEX_Blsr_r32_rm32
			(ushort)Mnemonic.Blsr,// VEX_Blsr_r64_rm64
			(ushort)Mnemonic.Blsmsk,// VEX_Blsmsk_r32_rm32
			(ushort)Mnemonic.Blsmsk,// VEX_Blsmsk_r64_rm64
			(ushort)Mnemonic.Blsi,// VEX_Blsi_r32_rm32
			(ushort)Mnemonic.Blsi,// VEX_Blsi_r64_rm64
			(ushort)Mnemonic.Bzhi,// VEX_Bzhi_r32_rm32_r32
			(ushort)Mnemonic.Bzhi,// VEX_Bzhi_r64_rm64_r64
			(ushort)Mnemonic.Wrussd,// Wrussd_m32_r32
			(ushort)Mnemonic.Wrussq,// Wrussq_m64_r64
			(ushort)Mnemonic.Pext,// VEX_Pext_r32_r32_rm32
			(ushort)Mnemonic.Pext,// VEX_Pext_r64_r64_rm64
			(ushort)Mnemonic.Pdep,// VEX_Pdep_r32_r32_rm32
			(ushort)Mnemonic.Pdep,// VEX_Pdep_r64_r64_rm64
			(ushort)Mnemonic.Wrssd,// Wrssd_m32_r32
			(ushort)Mnemonic.Wrssq,// Wrssq_m64_r64
			(ushort)Mnemonic.Adcx,// Adcx_r32_rm32
			(ushort)Mnemonic.Adcx,// Adcx_r64_rm64
			(ushort)Mnemonic.Adox,// Adox_r32_rm32
			(ushort)Mnemonic.Adox,// Adox_r64_rm64
			(ushort)Mnemonic.Mulx,// VEX_Mulx_r32_r32_rm32
			(ushort)Mnemonic.Mulx,// VEX_Mulx_r64_r64_rm64
			(ushort)Mnemonic.Bextr,// VEX_Bextr_r32_rm32_r32
			(ushort)Mnemonic.Bextr,// VEX_Bextr_r64_rm64_r64
			(ushort)Mnemonic.Shlx,// VEX_Shlx_r32_rm32_r32
			(ushort)Mnemonic.Shlx,// VEX_Shlx_r64_rm64_r64
			(ushort)Mnemonic.Sarx,// VEX_Sarx_r32_rm32_r32
			(ushort)Mnemonic.Sarx,// VEX_Sarx_r64_rm64_r64
			(ushort)Mnemonic.Shrx,// VEX_Shrx_r32_rm32_r32
			(ushort)Mnemonic.Shrx,// VEX_Shrx_r64_rm64_r64
			(ushort)Mnemonic.Movdir64b,// Movdir64b_r16_m512
			(ushort)Mnemonic.Movdir64b,// Movdir64b_r32_m512
			(ushort)Mnemonic.Movdir64b,// Movdir64b_r64_m512
			(ushort)Mnemonic.Enqcmds,// Enqcmds_r16_m512
			(ushort)Mnemonic.Enqcmds,// Enqcmds_r32_m512
			(ushort)Mnemonic.Enqcmds,// Enqcmds_r64_m512
			(ushort)Mnemonic.Enqcmd,// Enqcmd_r16_m512
			(ushort)Mnemonic.Enqcmd,// Enqcmd_r32_m512
			(ushort)Mnemonic.Enqcmd,// Enqcmd_r64_m512
			(ushort)Mnemonic.Movdiri,// Movdiri_m32_r32
			(ushort)Mnemonic.Movdiri,// Movdiri_m64_r64
			(ushort)Mnemonic.Vpermq,// VEX_Vpermq_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpermq,// EVEX_Vpermq_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vpermq,// EVEX_Vpermq_zmm_k1z_zmmm512b64_imm8
			(ushort)Mnemonic.Vpermpd,// VEX_Vpermpd_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpermpd,// EVEX_Vpermpd_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vpermpd,// EVEX_Vpermpd_zmm_k1z_zmmm512b64_imm8
			(ushort)Mnemonic.Vpblendd,// VEX_Vpblendd_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpblendd,// VEX_Vpblendd_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Valignd,// EVEX_Valignd_xmm_k1z_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Valignd,// EVEX_Valignd_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Valignd,// EVEX_Valignd_zmm_k1z_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Valignq,// EVEX_Valignq_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Valignq,// EVEX_Valignq_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Valignq,// EVEX_Valignq_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Vpermilps,// VEX_Vpermilps_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpermilps,// VEX_Vpermilps_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpermilps,// EVEX_Vpermilps_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vpermilps,// EVEX_Vpermilps_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vpermilps,// EVEX_Vpermilps_zmm_k1z_zmmm512b32_imm8
			(ushort)Mnemonic.Vpermilpd,// VEX_Vpermilpd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpermilpd,// VEX_Vpermilpd_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpermilpd,// EVEX_Vpermilpd_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vpermilpd,// EVEX_Vpermilpd_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vpermilpd,// EVEX_Vpermilpd_zmm_k1z_zmmm512b64_imm8
			(ushort)Mnemonic.Vperm2f128,// VEX_Vperm2f128_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Roundps,// Roundps_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vroundps,// VEX_Vroundps_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vroundps,// VEX_Vroundps_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vrndscaleps,// EVEX_Vrndscaleps_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vrndscaleps,// EVEX_Vrndscaleps_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vrndscaleps,// EVEX_Vrndscaleps_zmm_k1z_zmmm512b32_imm8_sae
			(ushort)Mnemonic.Roundpd,// Roundpd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vroundpd,// VEX_Vroundpd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vroundpd,// VEX_Vroundpd_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vrndscalepd,// EVEX_Vrndscalepd_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vrndscalepd,// EVEX_Vrndscalepd_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vrndscalepd,// EVEX_Vrndscalepd_zmm_k1z_zmmm512b64_imm8_sae
			(ushort)Mnemonic.Roundss,// Roundss_xmm_xmmm32_imm8
			(ushort)Mnemonic.Vroundss,// VEX_Vroundss_xmm_xmm_xmmm32_imm8
			(ushort)Mnemonic.Vrndscaless,// EVEX_Vrndscaless_xmm_k1z_xmm_xmmm32_imm8_sae
			(ushort)Mnemonic.Roundsd,// Roundsd_xmm_xmmm64_imm8
			(ushort)Mnemonic.Vroundsd,// VEX_Vroundsd_xmm_xmm_xmmm64_imm8
			(ushort)Mnemonic.Vrndscalesd,// EVEX_Vrndscalesd_xmm_k1z_xmm_xmmm64_imm8_sae
			(ushort)Mnemonic.Blendps,// Blendps_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vblendps,// VEX_Vblendps_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vblendps,// VEX_Vblendps_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Blendpd,// Blendpd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vblendpd,// VEX_Vblendpd_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vblendpd,// VEX_Vblendpd_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Pblendw,// Pblendw_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpblendw,// VEX_Vpblendw_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpblendw,// VEX_Vpblendw_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Palignr,// Palignr_mm_mmm64_imm8
			(ushort)Mnemonic.Palignr,// Palignr_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpalignr,// VEX_Vpalignr_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpalignr,// VEX_Vpalignr_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpalignr,// EVEX_Vpalignr_xmm_k1z_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpalignr,// EVEX_Vpalignr_ymm_k1z_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpalignr,// EVEX_Vpalignr_zmm_k1z_zmm_zmmm512_imm8
			(ushort)Mnemonic.Pextrb,// Pextrb_r32m8_xmm_imm8
			(ushort)Mnemonic.Pextrb,// Pextrb_r64m8_xmm_imm8
			(ushort)Mnemonic.Vpextrb,// VEX_Vpextrb_r32m8_xmm_imm8
			(ushort)Mnemonic.Vpextrb,// VEX_Vpextrb_r64m8_xmm_imm8
			(ushort)Mnemonic.Vpextrb,// EVEX_Vpextrb_r32m8_xmm_imm8
			(ushort)Mnemonic.Vpextrb,// EVEX_Vpextrb_r64m8_xmm_imm8
			(ushort)Mnemonic.Pextrw,// Pextrw_r32m16_xmm_imm8
			(ushort)Mnemonic.Pextrw,// Pextrw_r64m16_xmm_imm8
			(ushort)Mnemonic.Vpextrw,// VEX_Vpextrw_r32m16_xmm_imm8
			(ushort)Mnemonic.Vpextrw,// VEX_Vpextrw_r64m16_xmm_imm8
			(ushort)Mnemonic.Vpextrw,// EVEX_Vpextrw_r32m16_xmm_imm8
			(ushort)Mnemonic.Vpextrw,// EVEX_Vpextrw_r64m16_xmm_imm8
			(ushort)Mnemonic.Pextrd,// Pextrd_rm32_xmm_imm8
			(ushort)Mnemonic.Pextrq,// Pextrq_rm64_xmm_imm8
			(ushort)Mnemonic.Vpextrd,// VEX_Vpextrd_rm32_xmm_imm8
			(ushort)Mnemonic.Vpextrq,// VEX_Vpextrq_rm64_xmm_imm8
			(ushort)Mnemonic.Vpextrd,// EVEX_Vpextrd_rm32_xmm_imm8
			(ushort)Mnemonic.Vpextrq,// EVEX_Vpextrq_rm64_xmm_imm8
			(ushort)Mnemonic.Extractps,// Extractps_rm32_xmm_imm8
			(ushort)Mnemonic.Extractps,// Extractps_r64m32_xmm_imm8
			(ushort)Mnemonic.Vextractps,// VEX_Vextractps_rm32_xmm_imm8
			(ushort)Mnemonic.Vextractps,// VEX_Vextractps_r64m32_xmm_imm8
			(ushort)Mnemonic.Vextractps,// EVEX_Vextractps_rm32_xmm_imm8
			(ushort)Mnemonic.Vextractps,// EVEX_Vextractps_r64m32_xmm_imm8
			(ushort)Mnemonic.Vinsertf128,// VEX_Vinsertf128_ymm_ymm_xmmm128_imm8
			(ushort)Mnemonic.Vinsertf32x4,// EVEX_Vinsertf32x4_ymm_k1z_ymm_xmmm128_imm8
			(ushort)Mnemonic.Vinsertf32x4,// EVEX_Vinsertf32x4_zmm_k1z_zmm_xmmm128_imm8
			(ushort)Mnemonic.Vinsertf64x2,// EVEX_Vinsertf64x2_ymm_k1z_ymm_xmmm128_imm8
			(ushort)Mnemonic.Vinsertf64x2,// EVEX_Vinsertf64x2_zmm_k1z_zmm_xmmm128_imm8
			(ushort)Mnemonic.Vextractf128,// VEX_Vextractf128_xmmm128_ymm_imm8
			(ushort)Mnemonic.Vextractf32x4,// EVEX_Vextractf32x4_xmmm128_k1z_ymm_imm8
			(ushort)Mnemonic.Vextractf32x4,// EVEX_Vextractf32x4_xmmm128_k1z_zmm_imm8
			(ushort)Mnemonic.Vextractf64x2,// EVEX_Vextractf64x2_xmmm128_k1z_ymm_imm8
			(ushort)Mnemonic.Vextractf64x2,// EVEX_Vextractf64x2_xmmm128_k1z_zmm_imm8
			(ushort)Mnemonic.Vinsertf32x8,// EVEX_Vinsertf32x8_zmm_k1z_zmm_ymmm256_imm8
			(ushort)Mnemonic.Vinsertf64x4,// EVEX_Vinsertf64x4_zmm_k1z_zmm_ymmm256_imm8
			(ushort)Mnemonic.Vextractf32x8,// EVEX_Vextractf32x8_ymmm256_k1z_zmm_imm8
			(ushort)Mnemonic.Vextractf64x4,// EVEX_Vextractf64x4_ymmm256_k1z_zmm_imm8
			(ushort)Mnemonic.Vcvtps2ph,// VEX_Vcvtps2ph_xmmm64_xmm_imm8
			(ushort)Mnemonic.Vcvtps2ph,// VEX_Vcvtps2ph_xmmm128_ymm_imm8
			(ushort)Mnemonic.Vcvtps2ph,// EVEX_Vcvtps2ph_xmmm64_k1z_xmm_imm8
			(ushort)Mnemonic.Vcvtps2ph,// EVEX_Vcvtps2ph_xmmm128_k1z_ymm_imm8
			(ushort)Mnemonic.Vcvtps2ph,// EVEX_Vcvtps2ph_ymmm256_k1z_zmm_imm8_sae
			(ushort)Mnemonic.Vpcmpud,// EVEX_Vpcmpud_k_k1_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vpcmpud,// EVEX_Vpcmpud_k_k1_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vpcmpud,// EVEX_Vpcmpud_k_k1_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Vpcmpuq,// EVEX_Vpcmpuq_k_k1_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vpcmpuq,// EVEX_Vpcmpuq_k_k1_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vpcmpuq,// EVEX_Vpcmpuq_k_k1_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Vpcmpd,// EVEX_Vpcmpd_k_k1_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vpcmpd,// EVEX_Vpcmpd_k_k1_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vpcmpd,// EVEX_Vpcmpd_k_k1_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Vpcmpq,// EVEX_Vpcmpq_k_k1_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vpcmpq,// EVEX_Vpcmpq_k_k1_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vpcmpq,// EVEX_Vpcmpq_k_k1_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Pinsrb,// Pinsrb_xmm_r32m8_imm8
			(ushort)Mnemonic.Pinsrb,// Pinsrb_xmm_r64m8_imm8
			(ushort)Mnemonic.Vpinsrb,// VEX_Vpinsrb_xmm_xmm_r32m8_imm8
			(ushort)Mnemonic.Vpinsrb,// VEX_Vpinsrb_xmm_xmm_r64m8_imm8
			(ushort)Mnemonic.Vpinsrb,// EVEX_Vpinsrb_xmm_xmm_r32m8_imm8
			(ushort)Mnemonic.Vpinsrb,// EVEX_Vpinsrb_xmm_xmm_r64m8_imm8
			(ushort)Mnemonic.Insertps,// Insertps_xmm_xmmm32_imm8
			(ushort)Mnemonic.Vinsertps,// VEX_Vinsertps_xmm_xmm_xmmm32_imm8
			(ushort)Mnemonic.Vinsertps,// EVEX_Vinsertps_xmm_xmm_xmmm32_imm8
			(ushort)Mnemonic.Pinsrd,// Pinsrd_xmm_rm32_imm8
			(ushort)Mnemonic.Pinsrq,// Pinsrq_xmm_rm64_imm8
			(ushort)Mnemonic.Vpinsrd,// VEX_Vpinsrd_xmm_xmm_rm32_imm8
			(ushort)Mnemonic.Vpinsrq,// VEX_Vpinsrq_xmm_xmm_rm64_imm8
			(ushort)Mnemonic.Vpinsrd,// EVEX_Vpinsrd_xmm_xmm_rm32_imm8
			(ushort)Mnemonic.Vpinsrq,// EVEX_Vpinsrq_xmm_xmm_rm64_imm8
			(ushort)Mnemonic.Vshuff32x4,// EVEX_Vshuff32x4_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vshuff32x4,// EVEX_Vshuff32x4_zmm_k1z_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Vshuff64x2,// EVEX_Vshuff64x2_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vshuff64x2,// EVEX_Vshuff64x2_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Vpternlogd,// EVEX_Vpternlogd_xmm_k1z_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vpternlogd,// EVEX_Vpternlogd_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vpternlogd,// EVEX_Vpternlogd_zmm_k1z_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Vpternlogq,// EVEX_Vpternlogq_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vpternlogq,// EVEX_Vpternlogq_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vpternlogq,// EVEX_Vpternlogq_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Vgetmantps,// EVEX_Vgetmantps_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vgetmantps,// EVEX_Vgetmantps_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vgetmantps,// EVEX_Vgetmantps_zmm_k1z_zmmm512b32_imm8_sae
			(ushort)Mnemonic.Vgetmantpd,// EVEX_Vgetmantpd_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vgetmantpd,// EVEX_Vgetmantpd_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vgetmantpd,// EVEX_Vgetmantpd_zmm_k1z_zmmm512b64_imm8_sae
			(ushort)Mnemonic.Vgetmantss,// EVEX_Vgetmantss_xmm_k1z_xmm_xmmm32_imm8_sae
			(ushort)Mnemonic.Vgetmantsd,// EVEX_Vgetmantsd_xmm_k1z_xmm_xmmm64_imm8_sae
			(ushort)Mnemonic.Kshiftrb,// VEX_Kshiftrb_k_k_imm8
			(ushort)Mnemonic.Kshiftrw,// VEX_Kshiftrw_k_k_imm8
			(ushort)Mnemonic.Kshiftrd,// VEX_Kshiftrd_k_k_imm8
			(ushort)Mnemonic.Kshiftrq,// VEX_Kshiftrq_k_k_imm8
			(ushort)Mnemonic.Kshiftlb,// VEX_Kshiftlb_k_k_imm8
			(ushort)Mnemonic.Kshiftlw,// VEX_Kshiftlw_k_k_imm8
			(ushort)Mnemonic.Kshiftld,// VEX_Kshiftld_k_k_imm8
			(ushort)Mnemonic.Kshiftlq,// VEX_Kshiftlq_k_k_imm8
			(ushort)Mnemonic.Vinserti128,// VEX_Vinserti128_ymm_ymm_xmmm128_imm8
			(ushort)Mnemonic.Vinserti32x4,// EVEX_Vinserti32x4_ymm_k1z_ymm_xmmm128_imm8
			(ushort)Mnemonic.Vinserti32x4,// EVEX_Vinserti32x4_zmm_k1z_zmm_xmmm128_imm8
			(ushort)Mnemonic.Vinserti64x2,// EVEX_Vinserti64x2_ymm_k1z_ymm_xmmm128_imm8
			(ushort)Mnemonic.Vinserti64x2,// EVEX_Vinserti64x2_zmm_k1z_zmm_xmmm128_imm8
			(ushort)Mnemonic.Vextracti128,// VEX_Vextracti128_xmmm128_ymm_imm8
			(ushort)Mnemonic.Vextracti32x4,// EVEX_Vextracti32x4_xmmm128_k1z_ymm_imm8
			(ushort)Mnemonic.Vextracti32x4,// EVEX_Vextracti32x4_xmmm128_k1z_zmm_imm8
			(ushort)Mnemonic.Vextracti64x2,// EVEX_Vextracti64x2_xmmm128_k1z_ymm_imm8
			(ushort)Mnemonic.Vextracti64x2,// EVEX_Vextracti64x2_xmmm128_k1z_zmm_imm8
			(ushort)Mnemonic.Vinserti32x8,// EVEX_Vinserti32x8_zmm_k1z_zmm_ymmm256_imm8
			(ushort)Mnemonic.Vinserti64x4,// EVEX_Vinserti64x4_zmm_k1z_zmm_ymmm256_imm8
			(ushort)Mnemonic.Vextracti32x8,// EVEX_Vextracti32x8_ymmm256_k1z_zmm_imm8
			(ushort)Mnemonic.Vextracti64x4,// EVEX_Vextracti64x4_ymmm256_k1z_zmm_imm8
			(ushort)Mnemonic.Vpcmpub,// EVEX_Vpcmpub_k_k1_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpub,// EVEX_Vpcmpub_k_k1_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpcmpub,// EVEX_Vpcmpub_k_k1_zmm_zmmm512_imm8
			(ushort)Mnemonic.Vpcmpuw,// EVEX_Vpcmpuw_k_k1_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpuw,// EVEX_Vpcmpuw_k_k1_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpcmpuw,// EVEX_Vpcmpuw_k_k1_zmm_zmmm512_imm8
			(ushort)Mnemonic.Vpcmpb,// EVEX_Vpcmpb_k_k1_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpb,// EVEX_Vpcmpb_k_k1_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpcmpb,// EVEX_Vpcmpb_k_k1_zmm_zmmm512_imm8
			(ushort)Mnemonic.Vpcmpw,// EVEX_Vpcmpw_k_k1_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpw,// EVEX_Vpcmpw_k_k1_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpcmpw,// EVEX_Vpcmpw_k_k1_zmm_zmmm512_imm8
			(ushort)Mnemonic.Dpps,// Dpps_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vdpps,// VEX_Vdpps_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vdpps,// VEX_Vdpps_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Dppd,// Dppd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vdppd,// VEX_Vdppd_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Mpsadbw,// Mpsadbw_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vmpsadbw,// VEX_Vmpsadbw_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vmpsadbw,// VEX_Vmpsadbw_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vdbpsadbw,// EVEX_Vdbpsadbw_xmm_k1z_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vdbpsadbw,// EVEX_Vdbpsadbw_ymm_k1z_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vdbpsadbw,// EVEX_Vdbpsadbw_zmm_k1z_zmm_zmmm512_imm8
			(ushort)Mnemonic.Vshufi32x4,// EVEX_Vshufi32x4_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vshufi32x4,// EVEX_Vshufi32x4_zmm_k1z_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Vshufi64x2,// EVEX_Vshufi64x2_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vshufi64x2,// EVEX_Vshufi64x2_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Pclmulqdq,// Pclmulqdq_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpclmulqdq,// VEX_Vpclmulqdq_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpclmulqdq,// VEX_Vpclmulqdq_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpclmulqdq,// EVEX_Vpclmulqdq_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpclmulqdq,// EVEX_Vpclmulqdq_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpclmulqdq,// EVEX_Vpclmulqdq_zmm_zmm_zmmm512_imm8
			(ushort)Mnemonic.Vperm2i128,// VEX_Vperm2i128_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpermil2ps,// VEX_Vpermil2ps_xmm_xmm_xmmm128_xmm_imm2
			(ushort)Mnemonic.Vpermil2ps,// VEX_Vpermil2ps_ymm_ymm_ymmm256_ymm_imm2
			(ushort)Mnemonic.Vpermil2ps,// VEX_Vpermil2ps_xmm_xmm_xmm_xmmm128_imm2
			(ushort)Mnemonic.Vpermil2ps,// VEX_Vpermil2ps_ymm_ymm_ymm_ymmm256_imm2
			(ushort)Mnemonic.Vpermil2pd,// VEX_Vpermil2pd_xmm_xmm_xmmm128_xmm_imm2
			(ushort)Mnemonic.Vpermil2pd,// VEX_Vpermil2pd_ymm_ymm_ymmm256_ymm_imm2
			(ushort)Mnemonic.Vpermil2pd,// VEX_Vpermil2pd_xmm_xmm_xmm_xmmm128_imm2
			(ushort)Mnemonic.Vpermil2pd,// VEX_Vpermil2pd_ymm_ymm_ymm_ymmm256_imm2
			(ushort)Mnemonic.Vblendvps,// VEX_Vblendvps_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vblendvps,// VEX_Vblendvps_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vblendvpd,// VEX_Vblendvpd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vblendvpd,// VEX_Vblendvpd_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vpblendvb,// VEX_Vpblendvb_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpblendvb,// VEX_Vpblendvb_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vrangeps,// EVEX_Vrangeps_xmm_k1z_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vrangeps,// EVEX_Vrangeps_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vrangeps,// EVEX_Vrangeps_zmm_k1z_zmm_zmmm512b32_imm8_sae
			(ushort)Mnemonic.Vrangepd,// EVEX_Vrangepd_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vrangepd,// EVEX_Vrangepd_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vrangepd,// EVEX_Vrangepd_zmm_k1z_zmm_zmmm512b64_imm8_sae
			(ushort)Mnemonic.Vrangess,// EVEX_Vrangess_xmm_k1z_xmm_xmmm32_imm8_sae
			(ushort)Mnemonic.Vrangesd,// EVEX_Vrangesd_xmm_k1z_xmm_xmmm64_imm8_sae
			(ushort)Mnemonic.Vfixupimmps,// EVEX_Vfixupimmps_xmm_k1z_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vfixupimmps,// EVEX_Vfixupimmps_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vfixupimmps,// EVEX_Vfixupimmps_zmm_k1z_zmm_zmmm512b32_imm8_sae
			(ushort)Mnemonic.Vfixupimmpd,// EVEX_Vfixupimmpd_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vfixupimmpd,// EVEX_Vfixupimmpd_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vfixupimmpd,// EVEX_Vfixupimmpd_zmm_k1z_zmm_zmmm512b64_imm8_sae
			(ushort)Mnemonic.Vfixupimmss,// EVEX_Vfixupimmss_xmm_k1z_xmm_xmmm32_imm8_sae
			(ushort)Mnemonic.Vfixupimmsd,// EVEX_Vfixupimmsd_xmm_k1z_xmm_xmmm64_imm8_sae
			(ushort)Mnemonic.Vreduceps,// EVEX_Vreduceps_xmm_k1z_xmmm128b32_imm8
			(ushort)Mnemonic.Vreduceps,// EVEX_Vreduceps_ymm_k1z_ymmm256b32_imm8
			(ushort)Mnemonic.Vreduceps,// EVEX_Vreduceps_zmm_k1z_zmmm512b32_imm8_sae
			(ushort)Mnemonic.Vreducepd,// EVEX_Vreducepd_xmm_k1z_xmmm128b64_imm8
			(ushort)Mnemonic.Vreducepd,// EVEX_Vreducepd_ymm_k1z_ymmm256b64_imm8
			(ushort)Mnemonic.Vreducepd,// EVEX_Vreducepd_zmm_k1z_zmmm512b64_imm8_sae
			(ushort)Mnemonic.Vreducess,// EVEX_Vreducess_xmm_k1z_xmm_xmmm32_imm8_sae
			(ushort)Mnemonic.Vreducesd,// EVEX_Vreducesd_xmm_k1z_xmm_xmmm64_imm8_sae
			(ushort)Mnemonic.Vfmaddsubps,// VEX_Vfmaddsubps_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfmaddsubps,// VEX_Vfmaddsubps_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfmaddsubps,// VEX_Vfmaddsubps_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddsubps,// VEX_Vfmaddsubps_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddsubpd,// VEX_Vfmaddsubpd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfmaddsubpd,// VEX_Vfmaddsubpd_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfmaddsubpd,// VEX_Vfmaddsubpd_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddsubpd,// VEX_Vfmaddsubpd_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubaddps,// VEX_Vfmsubaddps_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfmsubaddps,// VEX_Vfmsubaddps_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfmsubaddps,// VEX_Vfmsubaddps_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubaddps,// VEX_Vfmsubaddps_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubaddpd,// VEX_Vfmsubaddpd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfmsubaddpd,// VEX_Vfmsubaddpd_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfmsubaddpd,// VEX_Vfmsubaddpd_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubaddpd,// VEX_Vfmsubaddpd_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Pcmpestrm,// Pcmpestrm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Pcmpestrm64,// Pcmpestrm64_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpestrm,// VEX_Vpcmpestrm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpestrm64,// VEX_Vpcmpestrm64_xmm_xmmm128_imm8
			(ushort)Mnemonic.Pcmpestri,// Pcmpestri_xmm_xmmm128_imm8
			(ushort)Mnemonic.Pcmpestri64,// Pcmpestri64_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpestri,// VEX_Vpcmpestri_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpestri64,// VEX_Vpcmpestri64_xmm_xmmm128_imm8
			(ushort)Mnemonic.Pcmpistrm,// Pcmpistrm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpistrm,// VEX_Vpcmpistrm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Pcmpistri,// Pcmpistri_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcmpistri,// VEX_Vpcmpistri_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vfpclassps,// EVEX_Vfpclassps_k_k1_xmmm128b32_imm8
			(ushort)Mnemonic.Vfpclassps,// EVEX_Vfpclassps_k_k1_ymmm256b32_imm8
			(ushort)Mnemonic.Vfpclassps,// EVEX_Vfpclassps_k_k1_zmmm512b32_imm8
			(ushort)Mnemonic.Vfpclasspd,// EVEX_Vfpclasspd_k_k1_xmmm128b64_imm8
			(ushort)Mnemonic.Vfpclasspd,// EVEX_Vfpclasspd_k_k1_ymmm256b64_imm8
			(ushort)Mnemonic.Vfpclasspd,// EVEX_Vfpclasspd_k_k1_zmmm512b64_imm8
			(ushort)Mnemonic.Vfpclassss,// EVEX_Vfpclassss_k_k1_xmmm32_imm8
			(ushort)Mnemonic.Vfpclasssd,// EVEX_Vfpclasssd_k_k1_xmmm64_imm8
			(ushort)Mnemonic.Vfmaddps,// VEX_Vfmaddps_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfmaddps,// VEX_Vfmaddps_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfmaddps,// VEX_Vfmaddps_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddps,// VEX_Vfmaddps_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddpd,// VEX_Vfmaddpd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfmaddpd,// VEX_Vfmaddpd_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfmaddpd,// VEX_Vfmaddpd_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmaddpd,// VEX_Vfmaddpd_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmaddss,// VEX_Vfmaddss_xmm_xmm_xmmm32_xmm
			(ushort)Mnemonic.Vfmaddss,// VEX_Vfmaddss_xmm_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfmaddsd,// VEX_Vfmaddsd_xmm_xmm_xmmm64_xmm
			(ushort)Mnemonic.Vfmaddsd,// VEX_Vfmaddsd_xmm_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfmsubps,// VEX_Vfmsubps_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfmsubps,// VEX_Vfmsubps_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfmsubps,// VEX_Vfmsubps_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubps,// VEX_Vfmsubps_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubpd,// VEX_Vfmsubpd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfmsubpd,// VEX_Vfmsubpd_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfmsubpd,// VEX_Vfmsubpd_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfmsubpd,// VEX_Vfmsubpd_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfmsubss,// VEX_Vfmsubss_xmm_xmm_xmmm32_xmm
			(ushort)Mnemonic.Vfmsubss,// VEX_Vfmsubss_xmm_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfmsubsd,// VEX_Vfmsubsd_xmm_xmm_xmmm64_xmm
			(ushort)Mnemonic.Vfmsubsd,// VEX_Vfmsubsd_xmm_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vpshldw,// EVEX_Vpshldw_xmm_k1z_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpshldw,// EVEX_Vpshldw_ymm_k1z_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpshldw,// EVEX_Vpshldw_zmm_k1z_zmm_zmmm512_imm8
			(ushort)Mnemonic.Vpshldd,// EVEX_Vpshldd_xmm_k1z_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vpshldd,// EVEX_Vpshldd_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vpshldd,// EVEX_Vpshldd_zmm_k1z_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Vpshldq,// EVEX_Vpshldq_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vpshldq,// EVEX_Vpshldq_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vpshldq,// EVEX_Vpshldq_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Vpshrdw,// EVEX_Vpshrdw_xmm_k1z_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpshrdw,// EVEX_Vpshrdw_ymm_k1z_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vpshrdw,// EVEX_Vpshrdw_zmm_k1z_zmm_zmmm512_imm8
			(ushort)Mnemonic.Vpshrdd,// EVEX_Vpshrdd_xmm_k1z_xmm_xmmm128b32_imm8
			(ushort)Mnemonic.Vpshrdd,// EVEX_Vpshrdd_ymm_k1z_ymm_ymmm256b32_imm8
			(ushort)Mnemonic.Vpshrdd,// EVEX_Vpshrdd_zmm_k1z_zmm_zmmm512b32_imm8
			(ushort)Mnemonic.Vpshrdq,// EVEX_Vpshrdq_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vpshrdq,// EVEX_Vpshrdq_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vpshrdq,// EVEX_Vpshrdq_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Vfnmaddps,// VEX_Vfnmaddps_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfnmaddps,// VEX_Vfnmaddps_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfnmaddps,// VEX_Vfnmaddps_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmaddps,// VEX_Vfnmaddps_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmaddpd,// VEX_Vfnmaddpd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfnmaddpd,// VEX_Vfnmaddpd_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfnmaddpd,// VEX_Vfnmaddpd_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmaddpd,// VEX_Vfnmaddpd_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmaddss,// VEX_Vfnmaddss_xmm_xmm_xmmm32_xmm
			(ushort)Mnemonic.Vfnmaddss,// VEX_Vfnmaddss_xmm_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfnmaddsd,// VEX_Vfnmaddsd_xmm_xmm_xmmm64_xmm
			(ushort)Mnemonic.Vfnmaddsd,// VEX_Vfnmaddsd_xmm_xmm_xmm_xmmm64
			(ushort)Mnemonic.Vfnmsubps,// VEX_Vfnmsubps_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfnmsubps,// VEX_Vfnmsubps_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfnmsubps,// VEX_Vfnmsubps_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmsubps,// VEX_Vfnmsubps_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmsubpd,// VEX_Vfnmsubpd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vfnmsubpd,// VEX_Vfnmsubpd_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vfnmsubpd,// VEX_Vfnmsubpd_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vfnmsubpd,// VEX_Vfnmsubpd_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vfnmsubss,// VEX_Vfnmsubss_xmm_xmm_xmmm32_xmm
			(ushort)Mnemonic.Vfnmsubss,// VEX_Vfnmsubss_xmm_xmm_xmm_xmmm32
			(ushort)Mnemonic.Vfnmsubsd,// VEX_Vfnmsubsd_xmm_xmm_xmmm64_xmm
			(ushort)Mnemonic.Vfnmsubsd,// VEX_Vfnmsubsd_xmm_xmm_xmm_xmmm64
			(ushort)Mnemonic.Sha1rnds4,// Sha1rnds4_xmm_xmmm128_imm8
			(ushort)Mnemonic.Gf2p8affineqb,// Gf2p8affineqb_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vgf2p8affineqb,// VEX_Vgf2p8affineqb_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vgf2p8affineqb,// VEX_Vgf2p8affineqb_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vgf2p8affineqb,// EVEX_Vgf2p8affineqb_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vgf2p8affineqb,// EVEX_Vgf2p8affineqb_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vgf2p8affineqb,// EVEX_Vgf2p8affineqb_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Gf2p8affineinvqb,// Gf2p8affineinvqb_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vgf2p8affineinvqb,// VEX_Vgf2p8affineinvqb_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vgf2p8affineinvqb,// VEX_Vgf2p8affineinvqb_ymm_ymm_ymmm256_imm8
			(ushort)Mnemonic.Vgf2p8affineinvqb,// EVEX_Vgf2p8affineinvqb_xmm_k1z_xmm_xmmm128b64_imm8
			(ushort)Mnemonic.Vgf2p8affineinvqb,// EVEX_Vgf2p8affineinvqb_ymm_k1z_ymm_ymmm256b64_imm8
			(ushort)Mnemonic.Vgf2p8affineinvqb,// EVEX_Vgf2p8affineinvqb_zmm_k1z_zmm_zmmm512b64_imm8
			(ushort)Mnemonic.Aeskeygenassist,// Aeskeygenassist_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vaeskeygenassist,// VEX_Vaeskeygenassist_xmm_xmmm128_imm8
			(ushort)Mnemonic.Rorx,// VEX_Rorx_r32_rm32_imm8
			(ushort)Mnemonic.Rorx,// VEX_Rorx_r64_rm64_imm8
			(ushort)Mnemonic.Vpmacssww,// XOP_Vpmacssww_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacsswd,// XOP_Vpmacsswd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacssdql,// XOP_Vpmacssdql_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacssdd,// XOP_Vpmacssdd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacssdqh,// XOP_Vpmacssdqh_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacsww,// XOP_Vpmacsww_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacswd,// XOP_Vpmacswd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacsdql,// XOP_Vpmacsdql_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacsdd,// XOP_Vpmacsdd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmacsdqh,// XOP_Vpmacsdqh_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpcmov,// XOP_Vpcmov_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpcmov,// XOP_Vpcmov_ymm_ymm_ymmm256_ymm
			(ushort)Mnemonic.Vpcmov,// XOP_Vpcmov_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpcmov,// XOP_Vpcmov_ymm_ymm_ymm_ymmm256
			(ushort)Mnemonic.Vpperm,// XOP_Vpperm_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpperm,// XOP_Vpperm_xmm_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpmadcsswd,// XOP_Vpmadcsswd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpmadcswd,// XOP_Vpmadcswd_xmm_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vprotb,// XOP_Vprotb_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vprotw,// XOP_Vprotw_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vprotd,// XOP_Vprotd_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vprotq,// XOP_Vprotq_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcomb,// XOP_Vpcomb_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcomw,// XOP_Vpcomw_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcomd,// XOP_Vpcomd_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcomq,// XOP_Vpcomq_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcomub,// XOP_Vpcomub_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcomuw,// XOP_Vpcomuw_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcomud,// XOP_Vpcomud_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Vpcomuq,// XOP_Vpcomuq_xmm_xmm_xmmm128_imm8
			(ushort)Mnemonic.Blcfill,// XOP_Blcfill_r32_rm32
			(ushort)Mnemonic.Blcfill,// XOP_Blcfill_r64_rm64
			(ushort)Mnemonic.Blsfill,// XOP_Blsfill_r32_rm32
			(ushort)Mnemonic.Blsfill,// XOP_Blsfill_r64_rm64
			(ushort)Mnemonic.Blcs,// XOP_Blcs_r32_rm32
			(ushort)Mnemonic.Blcs,// XOP_Blcs_r64_rm64
			(ushort)Mnemonic.Tzmsk,// XOP_Tzmsk_r32_rm32
			(ushort)Mnemonic.Tzmsk,// XOP_Tzmsk_r64_rm64
			(ushort)Mnemonic.Blcic,// XOP_Blcic_r32_rm32
			(ushort)Mnemonic.Blcic,// XOP_Blcic_r64_rm64
			(ushort)Mnemonic.Blsic,// XOP_Blsic_r32_rm32
			(ushort)Mnemonic.Blsic,// XOP_Blsic_r64_rm64
			(ushort)Mnemonic.T1mskc,// XOP_T1mskc_r32_rm32
			(ushort)Mnemonic.T1mskc,// XOP_T1mskc_r64_rm64
			(ushort)Mnemonic.Blcmsk,// XOP_Blcmsk_r32_rm32
			(ushort)Mnemonic.Blcmsk,// XOP_Blcmsk_r64_rm64
			(ushort)Mnemonic.Blci,// XOP_Blci_r32_rm32
			(ushort)Mnemonic.Blci,// XOP_Blci_r64_rm64
			(ushort)Mnemonic.Llwpcb,// XOP_Llwpcb_r32
			(ushort)Mnemonic.Llwpcb,// XOP_Llwpcb_r64
			(ushort)Mnemonic.Slwpcb,// XOP_Slwpcb_r32
			(ushort)Mnemonic.Slwpcb,// XOP_Slwpcb_r64
			(ushort)Mnemonic.Vfrczps,// XOP_Vfrczps_xmm_xmmm128
			(ushort)Mnemonic.Vfrczps,// XOP_Vfrczps_ymm_ymmm256
			(ushort)Mnemonic.Vfrczpd,// XOP_Vfrczpd_xmm_xmmm128
			(ushort)Mnemonic.Vfrczpd,// XOP_Vfrczpd_ymm_ymmm256
			(ushort)Mnemonic.Vfrczss,// XOP_Vfrczss_xmm_xmmm32
			(ushort)Mnemonic.Vfrczsd,// XOP_Vfrczsd_xmm_xmmm64
			(ushort)Mnemonic.Vprotb,// XOP_Vprotb_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vprotb,// XOP_Vprotb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vprotw,// XOP_Vprotw_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vprotw,// XOP_Vprotw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vprotd,// XOP_Vprotd_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vprotd,// XOP_Vprotd_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vprotq,// XOP_Vprotq_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vprotq,// XOP_Vprotq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshlb,// XOP_Vpshlb_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpshlb,// XOP_Vpshlb_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshlw,// XOP_Vpshlw_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpshlw,// XOP_Vpshlw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshld,// XOP_Vpshld_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpshld,// XOP_Vpshld_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshlq,// XOP_Vpshlq_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpshlq,// XOP_Vpshlq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshab,// XOP_Vpshab_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpshab,// XOP_Vpshab_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshaw,// XOP_Vpshaw_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpshaw,// XOP_Vpshaw_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshad,// XOP_Vpshad_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpshad,// XOP_Vpshad_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vpshaq,// XOP_Vpshaq_xmm_xmmm128_xmm
			(ushort)Mnemonic.Vpshaq,// XOP_Vpshaq_xmm_xmm_xmmm128
			(ushort)Mnemonic.Vphaddbw,// XOP_Vphaddbw_xmm_xmmm128
			(ushort)Mnemonic.Vphaddbd,// XOP_Vphaddbd_xmm_xmmm128
			(ushort)Mnemonic.Vphaddbq,// XOP_Vphaddbq_xmm_xmmm128
			(ushort)Mnemonic.Vphaddwd,// XOP_Vphaddwd_xmm_xmmm128
			(ushort)Mnemonic.Vphaddwq,// XOP_Vphaddwq_xmm_xmmm128
			(ushort)Mnemonic.Vphadddq,// XOP_Vphadddq_xmm_xmmm128
			(ushort)Mnemonic.Vphaddubw,// XOP_Vphaddubw_xmm_xmmm128
			(ushort)Mnemonic.Vphaddubd,// XOP_Vphaddubd_xmm_xmmm128
			(ushort)Mnemonic.Vphaddubq,// XOP_Vphaddubq_xmm_xmmm128
			(ushort)Mnemonic.Vphadduwd,// XOP_Vphadduwd_xmm_xmmm128
			(ushort)Mnemonic.Vphadduwq,// XOP_Vphadduwq_xmm_xmmm128
			(ushort)Mnemonic.Vphaddudq,// XOP_Vphaddudq_xmm_xmmm128
			(ushort)Mnemonic.Vphsubbw,// XOP_Vphsubbw_xmm_xmmm128
			(ushort)Mnemonic.Vphsubwd,// XOP_Vphsubwd_xmm_xmmm128
			(ushort)Mnemonic.Vphsubdq,// XOP_Vphsubdq_xmm_xmmm128
			(ushort)Mnemonic.Bextr,// XOP_Bextr_r32_rm32_imm32
			(ushort)Mnemonic.Bextr,// XOP_Bextr_r64_rm64_imm32
			(ushort)Mnemonic.Lwpins,// XOP_Lwpins_r32_rm32_imm32
			(ushort)Mnemonic.Lwpins,// XOP_Lwpins_r64_rm32_imm32
			(ushort)Mnemonic.Lwpval,// XOP_Lwpval_r32_rm32_imm32
			(ushort)Mnemonic.Lwpval,// XOP_Lwpval_r64_rm32_imm32
			(ushort)Mnemonic.Pi2fw,// D3NOW_Pi2fw_mm_mmm64
			(ushort)Mnemonic.Pi2fd,// D3NOW_Pi2fd_mm_mmm64
			(ushort)Mnemonic.Pf2iw,// D3NOW_Pf2iw_mm_mmm64
			(ushort)Mnemonic.Pf2id,// D3NOW_Pf2id_mm_mmm64
			(ushort)Mnemonic.Pfrcpv,// D3NOW_Pfrcpv_mm_mmm64
			(ushort)Mnemonic.Pfrsqrtv,// D3NOW_Pfrsqrtv_mm_mmm64
			(ushort)Mnemonic.Pfnacc,// D3NOW_Pfnacc_mm_mmm64
			(ushort)Mnemonic.Pfpnacc,// D3NOW_Pfpnacc_mm_mmm64
			(ushort)Mnemonic.Pfcmpge,// D3NOW_Pfcmpge_mm_mmm64
			(ushort)Mnemonic.Pfmin,// D3NOW_Pfmin_mm_mmm64
			(ushort)Mnemonic.Pfrcp,// D3NOW_Pfrcp_mm_mmm64
			(ushort)Mnemonic.Pfrsqrt,// D3NOW_Pfrsqrt_mm_mmm64
			(ushort)Mnemonic.Pfsub,// D3NOW_Pfsub_mm_mmm64
			(ushort)Mnemonic.Pfadd,// D3NOW_Pfadd_mm_mmm64
			(ushort)Mnemonic.Pfcmpgt,// D3NOW_Pfcmpgt_mm_mmm64
			(ushort)Mnemonic.Pfmax,// D3NOW_Pfmax_mm_mmm64
			(ushort)Mnemonic.Pfrcpit1,// D3NOW_Pfrcpit1_mm_mmm64
			(ushort)Mnemonic.Pfrsqit1,// D3NOW_Pfrsqit1_mm_mmm64
			(ushort)Mnemonic.Pfsubr,// D3NOW_Pfsubr_mm_mmm64
			(ushort)Mnemonic.Pfacc,// D3NOW_Pfacc_mm_mmm64
			(ushort)Mnemonic.Pfcmpeq,// D3NOW_Pfcmpeq_mm_mmm64
			(ushort)Mnemonic.Pfmul,// D3NOW_Pfmul_mm_mmm64
			(ushort)Mnemonic.Pfrcpit2,// D3NOW_Pfrcpit2_mm_mmm64
			(ushort)Mnemonic.Pmulhrw,// D3NOW_Pmulhrw_mm_mmm64
			(ushort)Mnemonic.Pswapd,// D3NOW_Pswapd_mm_mmm64
			(ushort)Mnemonic.Pavgusb,// D3NOW_Pavgusb_mm_mmm64
			(ushort)Mnemonic.Rmpadjust,// Rmpadjust
			(ushort)Mnemonic.Rmpupdate,// Rmpupdate
			(ushort)Mnemonic.Psmash,// Psmash
			(ushort)Mnemonic.Pvalidate,// Pvalidatew
			(ushort)Mnemonic.Pvalidate,// Pvalidated
			(ushort)Mnemonic.Pvalidate,// Pvalidateq
			(ushort)Mnemonic.Serialize,// Serialize
			(ushort)Mnemonic.Xsusldtrk,// Xsusldtrk
			(ushort)Mnemonic.Xresldtrk,// Xresldtrk
			(ushort)Mnemonic.Invlpgb,// Invlpgbw
			(ushort)Mnemonic.Invlpgb,// Invlpgbd
			(ushort)Mnemonic.Invlpgb,// Invlpgbq
			(ushort)Mnemonic.Tlbsync,// Tlbsync
			(ushort)Mnemonic.Prefetchw,// PrefetchReserved3_m8
			(ushort)Mnemonic.Prefetch,// PrefetchReserved4_m8
			(ushort)Mnemonic.Prefetch,// PrefetchReserved5_m8
			(ushort)Mnemonic.Prefetch,// PrefetchReserved6_m8
			(ushort)Mnemonic.Prefetch,// PrefetchReserved7_m8
		};
	}
}
